% postproccessing on gibbs sampler results for Bayesian CEV models with only a constant drift
% for univariate interest rate swap rates of various maturities



%% results using full sample

% load saved samples of parameters
d=load('mu_bcev3_full_1y_chain1.txt');
mu_sample1y=d(:,2);
d=load('mu_bcev3_full_2y_chain1.txt');
mu_sample2y=d(:,2);
d=load('mu_bcev3_full_3y_chain1.txt');
mu_sample3y=d(:,2);
d=load('mu_bcev3_full_4y_chain1.txt');
mu_sample4y=d(:,2);
d=load('mu_bcev3_full_5y_chain1.txt');
mu_sample5y=d(:,2);
d=load('mu_bcev3_full_7y_chain1.txt');
mu_sample7y=d(:,2);
d=load('mu_bcev3_full_10y_chain1.txt');
mu_sample10y=d(:,2);
d=load('mu_bcev3_full_30y_chain1.txt');
mu_sample30y=d(:,2);

d=load('sigma_bcev3_full_1y_chain1.txt');
sigma_sample1y=d(:,2);
d=load('sigma_bcev3_full_2y_chain1.txt');
sigma_sample2y=d(:,2);
d=load('sigma_bcev3_full_3y_chain1.txt');
sigma_sample3y=d(:,2);
d=load('sigma_bcev3_full_4y_chain1.txt');
sigma_sample4y=d(:,2);
d=load('sigma_bcev3_full_5y_chain1.txt');
sigma_sample5y=d(:,2);
d=load('sigma_bcev3_full_7y_chain1.txt');
sigma_sample7y=d(:,2);
d=load('sigma_bcev3_full_10y_chain1.txt');
sigma_sample10y=d(:,2);
d=load('sigma_bcev3_full_30y_chain1.txt');
sigma_sample30y=d(:,2);

d=load('gamma_bcev3_full_1y_chain1.txt');
gamma_sample1y=d(:,2);
d=load('gamma_bcev3_full_2y_chain1.txt');
gamma_sample2y=d(:,2);
d=load('gamma_bcev3_full_3y_chain1.txt');
gamma_sample3y=d(:,2);
d=load('gamma_bcev3_full_4y_chain1.txt');
gamma_sample4y=d(:,2);
d=load('gamma_bcev3_full_5y_chain1.txt');
gamma_sample5y=d(:,2);
d=load('gamma_bcev3_full_7y_chain1.txt');
gamma_sample7y=d(:,2);
d=load('gamma_bcev3_full_10y_chain1.txt');
gamma_sample10y=d(:,2);
d=load('gamma_bcev3_full_30y_chain1.txt');
gamma_sample30y=d(:,2);

d=load('nu_bcev3_full_1y_chain1.txt');
nu_sample1y=d(:,2);
d=load('nu_bcev3_full_2y_chain1.txt');
nu_sample2y=d(:,2);
d=load('nu_bcev3_full_3y_chain1.txt');
nu_sample3y=d(:,2);
d=load('nu_bcev3_full_4y_chain1.txt');
nu_sample4y=d(:,2);
d=load('nu_bcev3_full_5y_chain1.txt');
nu_sample5y=d(:,2);
d=load('nu_bcev3_full_7y_chain1.txt');
nu_sample7y=d(:,2);
d=load('nu_bcev3_full_10y_chain1.txt');
nu_sample10y=d(:,2);
d=load('nu_bcev3_full_30y_chain1.txt');
nu_sample30y=d(:,2);

% compute some simple statistics
mean_mu=mean([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);
median_mu=median([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);
p025_mu=prctile([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y],2.5);
p975_mu=prctile([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y],97.5);
std_mu=std([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);

mean_sigma=mean([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
median_sigma=median([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
p025_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],2.5);
p975_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],97.5);
std_sigma=std([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);

mean_gamma=mean([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);
median_gamma=median([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);
p025_gamma=prctile([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y],2.5);
p975_gamma=prctile([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y],97.5);
std_gamma=std([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);

mean_nu=mean([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
median_nu=median([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
p025_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],2.5);
p975_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],97.5);
std_nu=std([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);

medians=[median_mu;median_sigma;median_gamma;median_nu];
p025=[p025_mu;p025_sigma;p025_gamma;p025_nu];
p975=[p975_mu;p975_sigma;p975_gamma;p975_nu];
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
pname={'mu','sigma','gamma','nu'};
NM=8;
NV=4;

% save posterior medians and posterior 95% confidence intervals into a file
fid=fopen('irswap_bcev3_full_stats.csv','w');
fprintf(fid,'%s,%s,%s,%s,%s\n','Swap Maturity','Parameter','Posterior Median',...
    'Posterior 2.5th percentile','Posterior 97.5th percentile');
for i=1:NM
    for j=1:NV
        fprintf(fid,'%s,%s,%7.4f,%7.4f,%7.4f\n',swap_maturity{i},pname{j},...
            medians(j,i),p025(j,i),p975(j,i));
    end
end
fclose(fid);

% kernel-smoothed density plots of posterior marginal densities
NMC=size(nu_sample30y,1);
NK=100;
samples=NaN(NMC,NV,NM);
samples(:,:,1)=[mu_sample1y,sigma_sample1y,gamma_sample1y,nu_sample1y];
samples(:,:,2)=[mu_sample2y,sigma_sample2y,gamma_sample2y,nu_sample2y];
samples(:,:,3)=[mu_sample3y,sigma_sample3y,gamma_sample3y,nu_sample3y];
samples(:,:,4)=[mu_sample4y,sigma_sample4y,gamma_sample4y,nu_sample4y];
samples(:,:,5)=[mu_sample5y,sigma_sample5y,gamma_sample5y,nu_sample5y];
samples(:,:,6)=[mu_sample7y,sigma_sample7y,gamma_sample7y,nu_sample7y];
samples(:,:,7)=[mu_sample10y,sigma_sample10y,gamma_sample10y,nu_sample10y];
samples(:,:,8)=[mu_sample30y,sigma_sample30y,gamma_sample30y,nu_sample30y];

ksd=NaN(NV,NK,NM);
xsd=NaN(NV,NK,NM);

for i=1:NM
    for j=1:NV
        lb=prctile(samples(:,j,i),2.5);
        ub=prctile(samples(:,j,i),97.5);
        il=find(samples(:,j,i)>lb);
        gsample=samples(il,j,i);
        iu=find(gsample<ub);
        fsample=gsample(iu);
        if j<2
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','unbounded');
        elseif j<3
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','positive');
        elseif j<4
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support',[-1.001,2.001]);
        else
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support',[2,30]);
        end
        figure;
        plot(xsd(j,:,i),ksd(j,:,i),'r-','LineWidth',2);
        xlabel(['\',pname{j}]);
        ylabel('Marginal Posterior Density');
        title([swap_maturity{i},' US Interest Rate Swaps (full sample)']);
        filename=[pname{j},'_',swap_maturity{i},'_full_ksd_bcev3'];
        print('-depsc2',[filename,'.eps']);
        print('-djpeg',[filename,'.jpg']);
        print('-dpdf',[filename,'.pdf']);
    end
end


% save data to mat file
save irswap_bcev3_fullsample_postprocess.mat

%% results using last 4 year of data
% load saved samples of parameters
d=load('mu_bcev3_sample4_1y_chain1.txt');
mu_sample1y=d(:,2);
d=load('mu_bcev3_sample4_2y_chain1.txt');
mu_sample2y=d(:,2);
d=load('mu_bcev3_sample4_3y_chain1.txt');
mu_sample3y=d(:,2);
d=load('mu_bcev3_sample4_4y_chain1.txt');
mu_sample4y=d(:,2);
d=load('mu_bcev3_sample4_5y_chain1.txt');
mu_sample5y=d(:,2);
d=load('mu_bcev3_sample4_7y_chain1.txt');
mu_sample7y=d(:,2);
d=load('mu_bcev3_sample4_10y_chain1.txt');
mu_sample10y=d(:,2);
d=load('mu_bcev3_sample4_30y_chain1.txt');
mu_sample30y=d(:,2);

d=load('sigma_bcev3_sample4_1y_chain1.txt');
sigma_sample1y=d(:,2);
d=load('sigma_bcev3_sample4_2y_chain1.txt');
sigma_sample2y=d(:,2);
d=load('sigma_bcev3_sample4_3y_chain1.txt');
sigma_sample3y=d(:,2);
d=load('sigma_bcev3_sample4_4y_chain1.txt');
sigma_sample4y=d(:,2);
d=load('sigma_bcev3_sample4_5y_chain1.txt');
sigma_sample5y=d(:,2);
d=load('sigma_bcev3_sample4_7y_chain1.txt');
sigma_sample7y=d(:,2);
d=load('sigma_bcev3_sample4_10y_chain1.txt');
sigma_sample10y=d(:,2);
d=load('sigma_bcev3_sample4_30y_chain1.txt');
sigma_sample30y=d(:,2);

d=load('gamma_bcev3_sample4_1y_chain1.txt');
gamma_sample1y=d(:,2);
d=load('gamma_bcev3_sample4_2y_chain1.txt');
gamma_sample2y=d(:,2);
d=load('gamma_bcev3_sample4_3y_chain1.txt');
gamma_sample3y=d(:,2);
d=load('gamma_bcev3_sample4_4y_chain1.txt');
gamma_sample4y=d(:,2);
d=load('gamma_bcev3_sample4_5y_chain1.txt');
gamma_sample5y=d(:,2);
d=load('gamma_bcev3_sample4_7y_chain1.txt');
gamma_sample7y=d(:,2);
d=load('gamma_bcev3_sample4_10y_chain1.txt');
gamma_sample10y=d(:,2);
d=load('gamma_bcev3_sample4_30y_chain1.txt');
gamma_sample30y=d(:,2);

d=load('nu_bcev3_sample4_1y_chain1.txt');
nu_sample1y=d(:,2);
d=load('nu_bcev3_sample4_2y_chain1.txt');
nu_sample2y=d(:,2);
d=load('nu_bcev3_sample4_3y_chain1.txt');
nu_sample3y=d(:,2);
d=load('nu_bcev3_sample4_4y_chain1.txt');
nu_sample4y=d(:,2);
d=load('nu_bcev3_sample4_5y_chain1.txt');
nu_sample5y=d(:,2);
d=load('nu_bcev3_sample4_7y_chain1.txt');
nu_sample7y=d(:,2);
d=load('nu_bcev3_sample4_10y_chain1.txt');
nu_sample10y=d(:,2);
d=load('nu_bcev3_sample4_30y_chain1.txt');
nu_sample30y=d(:,2);

% compute some simple statistics
mean_mu=mean([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);
median_mu=median([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);
p025_mu=prctile([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y],2.5);
p975_mu=prctile([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y],97.5);
std_mu=std([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);

mean_sigma=mean([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
median_sigma=median([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
p025_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],2.5);
p975_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],97.5);
std_sigma=std([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);

mean_gamma=mean([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);
median_gamma=median([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);
p025_gamma=prctile([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y],2.5);
p975_gamma=prctile([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y],97.5);
std_gamma=std([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);

mean_nu=mean([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
median_nu=median([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
p025_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],2.5);
p975_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],97.5);
std_nu=std([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);

medians=[median_mu;median_sigma;median_gamma;median_nu];
p025=[p025_mu;p025_sigma;p025_gamma;p025_nu];
p975=[p975_mu;p975_sigma;p975_gamma;p975_nu];
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
pname={'mu','sigma','gamma','nu'};
NM=8;
NV=4;

% save posterior medians and posterior 95% confidence intervals into a file
fid=fopen('irswap_bcev3_sample4_stats.csv','w');
fprintf(fid,'%s,%s,%s,%s,%s\n','Swap Maturity','Parameter','Posterior Median',...
    'Posterior 2.5th percentile','Posterior 97.5th percentile');
for i=1:NM
    for j=1:NV
        fprintf(fid,'%s,%s,%7.4f,%7.4f,%7.4f\n',swap_maturity{i},pname{j},...
            medians(j,i),p025(j,i),p975(j,i));
    end
end
fclose(fid);

% kernel-smoothed density plots of posterior marginal densities
NMC=size(nu_sample30y,1);
NK=100;
samples=NaN(NMC,NV,NM);
samples(:,:,1)=[mu_sample1y,sigma_sample1y,gamma_sample1y,nu_sample1y];
samples(:,:,2)=[mu_sample2y,sigma_sample2y,gamma_sample2y,nu_sample2y];
samples(:,:,3)=[mu_sample3y,sigma_sample3y,gamma_sample3y,nu_sample3y];
samples(:,:,4)=[mu_sample4y,sigma_sample4y,gamma_sample4y,nu_sample4y];
samples(:,:,5)=[mu_sample5y,sigma_sample5y,gamma_sample5y,nu_sample5y];
samples(:,:,6)=[mu_sample7y,sigma_sample7y,gamma_sample7y,nu_sample7y];
samples(:,:,7)=[mu_sample10y,sigma_sample10y,gamma_sample10y,nu_sample10y];
samples(:,:,8)=[mu_sample30y,sigma_sample30y,gamma_sample30y,nu_sample30y];

ksd=NaN(NV,NK,NM);
xsd=NaN(NV,NK,NM);

for i=1:NM
    for j=1:NV
        lb=prctile(samples(:,j,i),2.5);
        ub=prctile(samples(:,j,i),97.5);
        il=find(samples(:,j,i)>lb);
        gsample=samples(il,j,i);
        iu=find(gsample<ub);
        fsample=gsample(iu);
        if j<2
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','unbounded');
        elseif j<3
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','positive');
        elseif j<4
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support',[-1.001,2.001]);
        else
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support',[2,30]);
        end
        figure;
        plot(xsd(j,:,i),ksd(j,:,i),'r-','LineWidth',2);
        xlabel(['\',pname{j}]);
        ylabel('Marginal Posterior Density');
        title([swap_maturity{i},' US Interest Rate Swaps (4-year sample)']);
        filename=[pname{j},'_',swap_maturity{i},'_sample4_ksd_bcev3'];
        print('-depsc2',[filename,'.eps']);
        print('-djpeg',[filename,'.jpg']);
        print('-dpdf',[filename,'.pdf']);
    end
end

% save data to mat file
save irswap_bcev3_sample4_postprocess.mat

%% results using last 1 year of data
% load saved samples of parameters
d=load('mu_bcev3_sample1_1y_chain1.txt');
mu_sample1y=d(:,2);
d=load('mu_bcev3_sample1_2y_chain1.txt');
mu_sample2y=d(:,2);
d=load('mu_bcev3_sample1_3y_chain1.txt');
mu_sample3y=d(:,2);
d=load('mu_bcev3_sample1_4y_chain1.txt');
mu_sample4y=d(:,2);
d=load('mu_bcev3_sample1_5y_chain1.txt');
mu_sample5y=d(:,2);
d=load('mu_bcev3_sample1_7y_chain1.txt');
mu_sample7y=d(:,2);
d=load('mu_bcev3_sample1_10y_chain1.txt');
mu_sample10y=d(:,2);
d=load('mu_bcev3_sample1_30y_chain1.txt');
mu_sample30y=d(:,2);

d=load('sigma_bcev3_sample1_1y_chain1.txt');
sigma_sample1y=d(:,2);
d=load('sigma_bcev3_sample1_2y_chain1.txt');
sigma_sample2y=d(:,2);
d=load('sigma_bcev3_sample1_3y_chain1.txt');
sigma_sample3y=d(:,2);
d=load('sigma_bcev3_sample1_4y_chain1.txt');
sigma_sample4y=d(:,2);
d=load('sigma_bcev3_sample1_5y_chain1.txt');
sigma_sample5y=d(:,2);
d=load('sigma_bcev3_sample1_7y_chain1.txt');
sigma_sample7y=d(:,2);
d=load('sigma_bcev3_sample1_10y_chain1.txt');
sigma_sample10y=d(:,2);
d=load('sigma_bcev3_sample1_30y_chain1.txt');
sigma_sample30y=d(:,2);

d=load('gamma_bcev3_sample1_1y_chain1.txt');
gamma_sample1y=d(:,2);
d=load('gamma_bcev3_sample1_2y_chain1.txt');
gamma_sample2y=d(:,2);
d=load('gamma_bcev3_sample1_3y_chain1.txt');
gamma_sample3y=d(:,2);
d=load('gamma_bcev3_sample1_4y_chain1.txt');
gamma_sample4y=d(:,2);
d=load('gamma_bcev3_sample1_5y_chain1.txt');
gamma_sample5y=d(:,2);
d=load('gamma_bcev3_sample1_7y_chain1.txt');
gamma_sample7y=d(:,2);
d=load('gamma_bcev3_sample1_10y_chain1.txt');
gamma_sample10y=d(:,2);
d=load('gamma_bcev3_sample1_30y_chain1.txt');
gamma_sample30y=d(:,2);

d=load('nu_bcev3_sample1_1y_chain1.txt');
nu_sample1y=d(:,2);
d=load('nu_bcev3_sample1_2y_chain1.txt');
nu_sample2y=d(:,2);
d=load('nu_bcev3_sample1_3y_chain1.txt');
nu_sample3y=d(:,2);
d=load('nu_bcev3_sample1_4y_chain1.txt');
nu_sample4y=d(:,2);
d=load('nu_bcev3_sample1_5y_chain1.txt');
nu_sample5y=d(:,2);
d=load('nu_bcev3_sample1_7y_chain1.txt');
nu_sample7y=d(:,2);
d=load('nu_bcev3_sample1_10y_chain1.txt');
nu_sample10y=d(:,2);
d=load('nu_bcev3_sample1_30y_chain1.txt');
nu_sample30y=d(:,2);

% compute some simple statistics
mean_mu=mean([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);
median_mu=median([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);
p025_mu=prctile([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y],2.5);
p975_mu=prctile([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y],97.5);
std_mu=std([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);

mean_sigma=mean([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
median_sigma=median([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
p025_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],2.5);
p975_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],97.5);
std_sigma=std([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);

mean_gamma=mean([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);
median_gamma=median([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);
p025_gamma=prctile([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y],2.5);
p975_gamma=prctile([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y],97.5);
std_gamma=std([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);

mean_nu=mean([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
median_nu=median([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
p025_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],2.5);
p975_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],97.5);
std_nu=std([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);

medians=[median_mu;median_sigma;median_gamma;median_nu];
p025=[p025_mu;p025_sigma;p025_gamma;p025_nu];
p975=[p975_mu;p975_sigma;p975_gamma;p975_nu];
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
pname={'mu','sigma','gamma','nu'};
NM=8;
NV=4;

% save posterior medians and posterior 95% confidence intervals into a file
fid=fopen('irswap_bcev3_sample1_stats.csv','w');
fprintf(fid,'%s,%s,%s,%s,%s\n','Swap Maturity','Parameter','Posterior Median',...
    'Posterior 2.5th percentile','Posterior 97.5th percentile');
for i=1:NM
    for j=1:NV
        fprintf(fid,'%s,%s,%7.4f,%7.4f,%7.4f\n',swap_maturity{i},pname{j},...
            medians(j,i),p025(j,i),p975(j,i));
    end
end
fclose(fid);

% kernel-smoothed density plots of posterior marginal densities
NMC=size(nu_sample30y,1);
NK=100;
samples=NaN(NMC,NV,NM);
samples(:,:,1)=[mu_sample1y,sigma_sample1y,gamma_sample1y,nu_sample1y];
samples(:,:,2)=[mu_sample2y,sigma_sample2y,gamma_sample2y,nu_sample2y];
samples(:,:,3)=[mu_sample3y,sigma_sample3y,gamma_sample3y,nu_sample3y];
samples(:,:,4)=[mu_sample4y,sigma_sample4y,gamma_sample4y,nu_sample4y];
samples(:,:,5)=[mu_sample5y,sigma_sample5y,gamma_sample5y,nu_sample5y];
samples(:,:,6)=[mu_sample7y,sigma_sample7y,gamma_sample7y,nu_sample7y];
samples(:,:,7)=[mu_sample10y,sigma_sample10y,gamma_sample10y,nu_sample10y];
samples(:,:,8)=[mu_sample30y,sigma_sample30y,gamma_sample30y,nu_sample30y];

ksd=NaN(NV,NK,NM);
xsd=NaN(NV,NK,NM);

for i=1:NM
    for j=1:NV
        lb=prctile(samples(:,j,i),2.5);
        ub=prctile(samples(:,j,i),97.5);
        il=find(samples(:,j,i)>lb);
        gsample=samples(il,j,i);
        iu=find(gsample<ub);
        fsample=gsample(iu);
        if j<2
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','unbounded');
        elseif j<3
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','positive');
        elseif j<4
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support',[-1.001,2.001]);
        else
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support',[2,30]);
        end
        figure;
        plot(xsd(j,:,i),ksd(j,:,i),'r-','LineWidth',2);
        xlabel(['\',pname{j}]);
        ylabel('Marginal Posterior Density');
        title([swap_maturity{i},' US Interest Rate Swaps (1-year sample)']);
        filename=[pname{j},'_',swap_maturity{i},'_sample1_ksd_bcev3'];
        print('-depsc2',[filename,'.eps']);
        print('-djpeg',[filename,'.jpg']);
        print('-dpdf',[filename,'.pdf']);
    end
end

% save data to mat file
save irswap_bcev3_sample1_postprocess.mat