% postproccessing on gibbs sampler results for Bayesian CEV models for
% univariate interest rate swap rates of various maturities



%% results using full sample

% load saved samples of parameters
d=load('mu_full_1y_chain1.txt');
mu_sample1y=d(:,2);
d=load('mu_full_2y_chain1.txt');
mu_sample2y=d(:,2);
d=load('mu_full_3y_chain1.txt');
mu_sample3y=d(:,2);
d=load('mu_full_4y_chain1.txt');
mu_sample4y=d(:,2);
d=load('mu_full_5y_chain1.txt');
mu_sample5y=d(:,2);
d=load('mu_full_7y_chain1.txt');
mu_sample7y=d(:,2);
d=load('mu_full_10y_chain1.txt');
mu_sample10y=d(:,2);
d=load('mu_full_30y_chain1.txt');
mu_sample30y=d(:,2);

d=load('rho_full_1y_chain1.txt');
rho_sample1y=d(:,2);
d=load('rho_full_2y_chain1.txt');
rho_sample2y=d(:,2);
d=load('rho_full_3y_chain1.txt');
rho_sample3y=d(:,2);
d=load('rho_full_4y_chain1.txt');
rho_sample4y=d(:,2);
d=load('rho_full_5y_chain1.txt');
rho_sample5y=d(:,2);
d=load('rho_full_7y_chain1.txt');
rho_sample7y=d(:,2);
d=load('rho_full_10y_chain1.txt');
rho_sample10y=d(:,2);
d=load('rho_full_30y_chain1.txt');
rho_sample30y=d(:,2);

d=load('sigma_full_1y_chain1.txt');
sigma_sample1y=d(:,2);
d=load('sigma_full_2y_chain1.txt');
sigma_sample2y=d(:,2);
d=load('sigma_full_3y_chain1.txt');
sigma_sample3y=d(:,2);
d=load('sigma_full_4y_chain1.txt');
sigma_sample4y=d(:,2);
d=load('sigma_full_5y_chain1.txt');
sigma_sample5y=d(:,2);
d=load('sigma_full_7y_chain1.txt');
sigma_sample7y=d(:,2);
d=load('sigma_full_10y_chain1.txt');
sigma_sample10y=d(:,2);
d=load('sigma_full_30y_chain1.txt');
sigma_sample30y=d(:,2);

d=load('gamma_full_1y_chain1.txt');
gamma_sample1y=d(:,2);
d=load('gamma_full_2y_chain1.txt');
gamma_sample2y=d(:,2);
d=load('gamma_full_3y_chain1.txt');
gamma_sample3y=d(:,2);
d=load('gamma_full_4y_chain1.txt');
gamma_sample4y=d(:,2);
d=load('gamma_full_5y_chain1.txt');
gamma_sample5y=d(:,2);
d=load('gamma_full_7y_chain1.txt');
gamma_sample7y=d(:,2);
d=load('gamma_full_10y_chain1.txt');
gamma_sample10y=d(:,2);
d=load('gamma_full_30y_chain1.txt');
gamma_sample30y=d(:,2);

d=load('nu_full_1y_chain1.txt');
nu_sample1y=d(:,2);
d=load('nu_full_2y_chain1.txt');
nu_sample2y=d(:,2);
d=load('nu_full_3y_chain1.txt');
nu_sample3y=d(:,2);
d=load('nu_full_4y_chain1.txt');
nu_sample4y=d(:,2);
d=load('nu_full_5y_chain1.txt');
nu_sample5y=d(:,2);
d=load('nu_full_7y_chain1.txt');
nu_sample7y=d(:,2);
d=load('nu_full_10y_chain1.txt');
nu_sample10y=d(:,2);
d=load('nu_full_30y_chain1.txt');
nu_sample30y=d(:,2);

% transform mu and rho parameter draws into draws of mu and kappa
kappa_sample1y=1-rho_sample1y;
theta_sample1y=mu_sample1y./kappa_sample1y;
kappa_sample2y=1-rho_sample2y;
theta_sample2y=mu_sample2y./kappa_sample2y;
kappa_sample3y=1-rho_sample3y;
theta_sample3y=mu_sample3y./kappa_sample3y;
kappa_sample4y=1-rho_sample4y;
theta_sample4y=mu_sample4y./kappa_sample4y;
kappa_sample5y=1-rho_sample5y;
theta_sample5y=mu_sample5y./kappa_sample5y;
kappa_sample7y=1-rho_sample7y;
theta_sample7y=mu_sample7y./kappa_sample7y;
kappa_sample10y=1-rho_sample10y;
theta_sample10y=mu_sample10y./kappa_sample10y;
kappa_sample30y=1-rho_sample30y;
theta_sample30y=mu_sample30y./kappa_sample30y;

% compute some simple statistics
mean_theta=mean([theta_sample1y,theta_sample2y,theta_sample3y,theta_sample4y,...
    theta_sample5y,theta_sample7y,theta_sample10y,theta_sample30y]);
median_theta=median([theta_sample1y,theta_sample2y,theta_sample3y,theta_sample4y,...
    theta_sample5y,theta_sample7y,theta_sample10y,theta_sample30y]);
p025_theta=prctile([theta_sample1y,theta_sample2y,theta_sample3y,theta_sample4y,...
    theta_sample5y,theta_sample7y,theta_sample10y,theta_sample30y],2.5);
p975_theta=prctile([theta_sample1y,theta_sample2y,theta_sample3y,theta_sample4y,...
    theta_sample5y,theta_sample7y,theta_sample10y,theta_sample30y],97.5);
std_theta=std([theta_sample1y,theta_sample2y,theta_sample3y,theta_sample4y,...
    theta_sample5y,theta_sample7y,theta_sample10y,theta_sample30y]);

mean_kappa=mean([kappa_sample1y,kappa_sample2y,kappa_sample3y,kappa_sample4y,...
    kappa_sample5y,kappa_sample7y,kappa_sample10y,kappa_sample30y]);
median_kappa=median([kappa_sample1y,kappa_sample2y,kappa_sample3y,kappa_sample4y,...
    kappa_sample5y,kappa_sample7y,kappa_sample10y,kappa_sample30y]);
p025_kappa=prctile([kappa_sample1y,kappa_sample2y,kappa_sample3y,kappa_sample4y,...
    kappa_sample5y,kappa_sample7y,kappa_sample10y,kappa_sample30y],2.5);
p975_kappa=prctile([kappa_sample1y,kappa_sample2y,kappa_sample3y,kappa_sample4y,...
    kappa_sample5y,kappa_sample7y,kappa_sample10y,kappa_sample30y],97.5);
std_kappa=std([kappa_sample1y,kappa_sample2y,kappa_sample3y,kappa_sample4y,...
    kappa_sample5y,kappa_sample7y,kappa_sample10y,kappa_sample30y]);

mean_sigma=mean([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
median_sigma=median([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
p025_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],2.5);
p975_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],97.5);
std_sigma=std([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);

mean_gamma=mean([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);
median_gamma=median([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);
p025_gamma=prctile([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y],2.5);
p975_gamma=prctile([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y],97.5);
std_gamma=std([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);

mean_nu=mean([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
median_nu=median([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
p025_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],2.5);
p975_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],97.5);
std_nu=std([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);

medians=[median_theta;median_kappa;median_sigma;median_gamma;median_nu];
p025=[p025_theta;p025_kappa;p025_sigma;p025_gamma;p025_nu];
p975=[p975_theta;p975_kappa;p975_sigma;p975_gamma;p975_nu];
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
pname={'theta','kappa','sigma','gamma','nu'};
NM=8;
NV=5;

% save posterior medians and posterior 95% confidence intervals into a file
fid=fopen('irswap_bcev4_full_stats.csv','w');
fprintf(fid,'%s,%s,%s,%s,%s\n','Swap Maturity','Parameter','Posterior Median',...
    'Posterior 2.5th percentile','Posterior 97.5th percentile');
for i=1:NM
    for j=1:NV
        fprintf(fid,'%s,%s,%7.4f,%7.4f,%7.4f\n',swap_maturity{i},pname{j},...
            medians(j,i),p025(j,i),p975(j,i));
    end
end
fclose(fid);

% kernel-smoothed density plots of posterior marginal densities
NMC=size(nu_sample30y,1);
NK=100;
samples=NaN(NMC,NV,NM);
samples(:,:,1)=[theta_sample1y,kappa_sample1y,sigma_sample1y,gamma_sample1y,nu_sample1y];
samples(:,:,2)=[theta_sample2y,kappa_sample2y,sigma_sample2y,gamma_sample2y,nu_sample2y];
samples(:,:,3)=[theta_sample3y,kappa_sample3y,sigma_sample3y,gamma_sample3y,nu_sample3y];
samples(:,:,4)=[theta_sample4y,kappa_sample4y,sigma_sample4y,gamma_sample4y,nu_sample4y];
samples(:,:,5)=[theta_sample5y,kappa_sample5y,sigma_sample5y,gamma_sample5y,nu_sample5y];
samples(:,:,6)=[theta_sample7y,kappa_sample7y,sigma_sample7y,gamma_sample7y,nu_sample7y];
samples(:,:,7)=[theta_sample10y,kappa_sample10y,sigma_sample10y,gamma_sample10y,nu_sample10y];
samples(:,:,8)=[theta_sample30y,kappa_sample30y,sigma_sample30y,gamma_sample30y,nu_sample30y];

ksd=NaN(NV,NK,NM);
xsd=NaN(NV,NK,NM);

for i=1:NM
    for j=1:NV
        lb=prctile(samples(:,j,i),2.5);
        ub=prctile(samples(:,j,i),97.5);
        il=find(samples(:,j,i)>lb);
        gsample=samples(il,j,i);
        iu=find(gsample<ub);
        fsample=gsample(iu);
        if j<3
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','unbounded');
        elseif j<4
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','positive');
        elseif j<5
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support',[-1.001,2.001]);
        else
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support',[2,30]);
        end
        figure;
        plot(xsd(j,:,i),ksd(j,:,i),'r-','LineWidth',2);
        xlabel(pname{j});
        ylabel('Marginal Posterior Density');
        title([swap_maturity{i},'US Interest Rate Swaps (full sample)']);
        filename=[pname{j},'_',swap_maturity{i},'_full_ksd'];
        print('-depsc2',[filename,'.eps']);
        print('-djpeg',[filename,'.jpg']);
        print('-dpdf',[filename,'.pdf']);
    end
end


% save data to mat file
save irswap_bcev4_fullsample_postprocess.mat

%% results using last 4 year of data
% load saved samples of parameters
d=load('mu_sample4_1y_chain1.txt');
mu_sample1y=d(:,2);
d=load('mu_sample4_2y_chain1.txt');
mu_sample2y=d(:,2);
d=load('mu_sample4_3y_chain1.txt');
mu_sample3y=d(:,2);
d=load('mu_sample4_4y_chain1.txt');
mu_sample4y=d(:,2);
d=load('mu_sample4_5y_chain1.txt');
mu_sample5y=d(:,2);
d=load('mu_sample4_7y_chain1.txt');
mu_sample7y=d(:,2);
d=load('mu_sample4_10y_chain1.txt');
mu_sample10y=d(:,2);
d=load('mu_sample4_30y_chain1.txt');
mu_sample30y=d(:,2);

d=load('rho_sample4_1y_chain1.txt');
rho_sample1y=d(:,2);
d=load('rho_sample4_2y_chain1.txt');
rho_sample2y=d(:,2);
d=load('rho_sample4_3y_chain1.txt');
rho_sample3y=d(:,2);
d=load('rho_sample4_4y_chain1.txt');
rho_sample4y=d(:,2);
d=load('rho_sample4_5y_chain1.txt');
rho_sample5y=d(:,2);
d=load('rho_sample4_7y_chain1.txt');
rho_sample7y=d(:,2);
d=load('rho_sample4_10y_chain1.txt');
rho_sample10y=d(:,2);
d=load('rho_sample4_30y_chain1.txt');
rho_sample30y=d(:,2);

d=load('sigma_sample4_1y_chain1.txt');
sigma_sample1y=d(:,2);
d=load('sigma_sample4_2y_chain1.txt');
sigma_sample2y=d(:,2);
d=load('sigma_sample4_3y_chain1.txt');
sigma_sample3y=d(:,2);
d=load('sigma_sample4_4y_chain1.txt');
sigma_sample4y=d(:,2);
d=load('sigma_sample4_5y_chain1.txt');
sigma_sample5y=d(:,2);
d=load('sigma_sample4_7y_chain1.txt');
sigma_sample7y=d(:,2);
d=load('sigma_sample4_10y_chain1.txt');
sigma_sample10y=d(:,2);
d=load('sigma_sample4_30y_chain1.txt');
sigma_sample30y=d(:,2);

d=load('gamma_sample4_1y_chain1.txt');
gamma_sample1y=d(:,2);
d=load('gamma_sample4_2y_chain1.txt');
gamma_sample2y=d(:,2);
d=load('gamma_sample4_3y_chain1.txt');
gamma_sample3y=d(:,2);
d=load('gamma_sample4_4y_chain1.txt');
gamma_sample4y=d(:,2);
d=load('gamma_sample4_5y_chain1.txt');
gamma_sample5y=d(:,2);
d=load('gamma_sample4_7y_chain1.txt');
gamma_sample7y=d(:,2);
d=load('gamma_sample4_10y_chain1.txt');
gamma_sample10y=d(:,2);
d=load('gamma_sample4_30y_chain1.txt');
gamma_sample30y=d(:,2);

d=load('nu_sample4_1y_chain1.txt');
nu_sample1y=d(:,2);
d=load('nu_sample4_2y_chain1.txt');
nu_sample2y=d(:,2);
d=load('nu_sample4_3y_chain1.txt');
nu_sample3y=d(:,2);
d=load('nu_sample4_4y_chain1.txt');
nu_sample4y=d(:,2);
d=load('nu_sample4_5y_chain1.txt');
nu_sample5y=d(:,2);
d=load('nu_sample4_7y_chain1.txt');
nu_sample7y=d(:,2);
d=load('nu_sample4_10y_chain1.txt');
nu_sample10y=d(:,2);
d=load('nu_sample4_30y_chain1.txt');
nu_sample30y=d(:,2);

% transform mu and rho parameter draws into draws of mu and kappa
kappa_sample1y=1-rho_sample1y;
theta_sample1y=mu_sample1y./kappa_sample1y;
kappa_sample2y=1-rho_sample2y;
theta_sample2y=mu_sample2y./kappa_sample2y;
kappa_sample3y=1-rho_sample3y;
theta_sample3y=mu_sample3y./kappa_sample3y;
kappa_sample4y=1-rho_sample4y;
theta_sample4y=mu_sample4y./kappa_sample4y;
kappa_sample5y=1-rho_sample5y;
theta_sample5y=mu_sample5y./kappa_sample5y;
kappa_sample7y=1-rho_sample7y;
theta_sample7y=mu_sample7y./kappa_sample7y;
kappa_sample10y=1-rho_sample10y;
theta_sample10y=mu_sample10y./kappa_sample10y;
kappa_sample30y=1-rho_sample30y;
theta_sample30y=mu_sample30y./kappa_sample30y;

% compute some simple statistics
mean_theta=mean([theta_sample1y,theta_sample2y,theta_sample3y,theta_sample4y,...
    theta_sample5y,theta_sample7y,theta_sample10y,theta_sample30y]);
median_theta=median([theta_sample1y,theta_sample2y,theta_sample3y,theta_sample4y,...
    theta_sample5y,theta_sample7y,theta_sample10y,theta_sample30y]);
p025_theta=prctile([theta_sample1y,theta_sample2y,theta_sample3y,theta_sample4y,...
    theta_sample5y,theta_sample7y,theta_sample10y,theta_sample30y],2.5);
p975_theta=prctile([theta_sample1y,theta_sample2y,theta_sample3y,theta_sample4y,...
    theta_sample5y,theta_sample7y,theta_sample10y,theta_sample30y],97.5);
std_theta=std([theta_sample1y,theta_sample2y,theta_sample3y,theta_sample4y,...
    theta_sample5y,theta_sample7y,theta_sample10y,theta_sample30y]);

mean_kappa=mean([kappa_sample1y,kappa_sample2y,kappa_sample3y,kappa_sample4y,...
    kappa_sample5y,kappa_sample7y,kappa_sample10y,kappa_sample30y]);
median_kappa=median([kappa_sample1y,kappa_sample2y,kappa_sample3y,kappa_sample4y,...
    kappa_sample5y,kappa_sample7y,kappa_sample10y,kappa_sample30y]);
p025_kappa=prctile([kappa_sample1y,kappa_sample2y,kappa_sample3y,kappa_sample4y,...
    kappa_sample5y,kappa_sample7y,kappa_sample10y,kappa_sample30y],2.5);
p975_kappa=prctile([kappa_sample1y,kappa_sample2y,kappa_sample3y,kappa_sample4y,...
    kappa_sample5y,kappa_sample7y,kappa_sample10y,kappa_sample30y],97.5);
std_kappa=std([kappa_sample1y,kappa_sample2y,kappa_sample3y,kappa_sample4y,...
    kappa_sample5y,kappa_sample7y,kappa_sample10y,kappa_sample30y]);

mean_sigma=mean([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
median_sigma=median([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
p025_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],2.5);
p975_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],97.5);
std_sigma=std([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);

mean_gamma=mean([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);
median_gamma=median([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);
p025_gamma=prctile([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y],2.5);
p975_gamma=prctile([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y],97.5);
std_gamma=std([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);

mean_nu=mean([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
median_nu=median([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
p025_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],2.5);
p975_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],97.5);
std_nu=std([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);

medians=[median_theta;median_kappa;median_sigma;median_gamma;median_nu];
p025=[p025_theta;p025_kappa;p025_sigma;p025_gamma;p025_nu];
p975=[p975_theta;p975_kappa;p975_sigma;p975_gamma;p975_nu];
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
pname={'theta','kappa','sigma','gamma','nu'};
NM=8;
NV=5;

% save posterior medians and posterior 95% confidence intervals into a file
fid=fopen('irswap_bcev4_sample4_stats.csv','w');
fprintf(fid,'%s,%s,%s,%s,%s\n','Swap Maturity','Parameter','Posterior Median',...
    'Posterior 2.5th percentile','Posterior 97.5th percentile');
for i=1:NM
    for j=1:NV
        fprintf(fid,'%s,%s,%7.4f,%7.4f,%7.4f\n',swap_maturity{i},pname{j},...
            medians(j,i),p025(j,i),p975(j,i));
    end
end
fclose(fid);

% kernel-smoothed density plots of posterior marginal densities
NMC=size(nu_sample30y,1);
NK=100;
samples=NaN(NMC,NV,NM);
samples(:,:,1)=[theta_sample1y,kappa_sample1y,sigma_sample1y,gamma_sample1y,nu_sample1y];
samples(:,:,2)=[theta_sample2y,kappa_sample2y,sigma_sample2y,gamma_sample2y,nu_sample2y];
samples(:,:,3)=[theta_sample3y,kappa_sample3y,sigma_sample3y,gamma_sample3y,nu_sample3y];
samples(:,:,4)=[theta_sample4y,kappa_sample4y,sigma_sample4y,gamma_sample4y,nu_sample4y];
samples(:,:,5)=[theta_sample5y,kappa_sample5y,sigma_sample5y,gamma_sample5y,nu_sample5y];
samples(:,:,6)=[theta_sample7y,kappa_sample7y,sigma_sample7y,gamma_sample7y,nu_sample7y];
samples(:,:,7)=[theta_sample10y,kappa_sample10y,sigma_sample10y,gamma_sample10y,nu_sample10y];
samples(:,:,8)=[theta_sample30y,kappa_sample30y,sigma_sample30y,gamma_sample30y,nu_sample30y];

ksd=NaN(NV,NK,NM);
xsd=NaN(NV,NK,NM);

for i=1:NM
    for j=1:NV
        lb=prctile(samples(:,j,i),2.5);
        ub=prctile(samples(:,j,i),97.5);
        il=find(samples(:,j,i)>lb);
        gsample=samples(il,j,i);
        iu=find(gsample<ub);
        fsample=gsample(iu);
        if j<3
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','unbounded');
        elseif j<4
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','positive');
        elseif j<5
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support',[-1.001,2.001]);
        else
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support',[2,30]);
        end
        figure;
        plot(xsd(j,:,i),ksd(j,:,i),'r-','LineWidth',2);
        xlabel(pname{j});
        ylabel('Marginal Posterior Density');
        title([swap_maturity{i},'US Interest Rate Swaps (4-year sample)']);
        filename=[pname{j},'_',swap_maturity{i},'_sample4_ksd'];
        print('-depsc2',[filename,'.eps']);
        print('-djpeg',[filename,'.jpg']);
        print('-dpdf',[filename,'.pdf']);
    end
end

% save data to mat file
save irswap_bcev4_sample4_postprocess.mat

%% results using last 1 year of data
% load saved samples of parameters
d=load('mu_sample1_1y_chain1.txt');
mu_sample1y=d(:,2);
d=load('mu_sample1_2y_chain1.txt');
mu_sample2y=d(:,2);
d=load('mu_sample1_3y_chain1.txt');
mu_sample3y=d(:,2);
d=load('mu_sample1_4y_chain1.txt');
mu_sample4y=d(:,2);
d=load('mu_sample1_5y_chain1.txt');
mu_sample5y=d(:,2);
d=load('mu_sample1_7y_chain1.txt');
mu_sample7y=d(:,2);
d=load('mu_sample1_10y_chain1.txt');
mu_sample10y=d(:,2);
d=load('mu_sample1_30y_chain1.txt');
mu_sample30y=d(:,2);

d=load('rho_sample1_1y_chain1.txt');
rho_sample1y=d(:,2);
d=load('rho_sample1_2y_chain1.txt');
rho_sample2y=d(:,2);
d=load('rho_sample1_3y_chain1.txt');
rho_sample3y=d(:,2);
d=load('rho_sample1_4y_chain1.txt');
rho_sample4y=d(:,2);
d=load('rho_sample1_5y_chain1.txt');
rho_sample5y=d(:,2);
d=load('rho_sample1_7y_chain1.txt');
rho_sample7y=d(:,2);
d=load('rho_sample1_10y_chain1.txt');
rho_sample10y=d(:,2);
d=load('rho_sample1_30y_chain1.txt');
rho_sample30y=d(:,2);

d=load('sigma_sample1_1y_chain1.txt');
sigma_sample1y=d(:,2);
d=load('sigma_sample1_2y_chain1.txt');
sigma_sample2y=d(:,2);
d=load('sigma_sample1_3y_chain1.txt');
sigma_sample3y=d(:,2);
d=load('sigma_sample1_4y_chain1.txt');
sigma_sample4y=d(:,2);
d=load('sigma_sample1_5y_chain1.txt');
sigma_sample5y=d(:,2);
d=load('sigma_sample1_7y_chain1.txt');
sigma_sample7y=d(:,2);
d=load('sigma_sample1_10y_chain1.txt');
sigma_sample10y=d(:,2);
d=load('sigma_sample1_30y_chain1.txt');
sigma_sample30y=d(:,2);

d=load('gamma_sample1_1y_chain1.txt');
gamma_sample1y=d(:,2);
d=load('gamma_sample1_2y_chain1.txt');
gamma_sample2y=d(:,2);
d=load('gamma_sample1_3y_chain1.txt');
gamma_sample3y=d(:,2);
d=load('gamma_sample1_4y_chain1.txt');
gamma_sample4y=d(:,2);
d=load('gamma_sample1_5y_chain1.txt');
gamma_sample5y=d(:,2);
d=load('gamma_sample1_7y_chain1.txt');
gamma_sample7y=d(:,2);
d=load('gamma_sample1_10y_chain1.txt');
gamma_sample10y=d(:,2);
d=load('gamma_sample1_30y_chain1.txt');
gamma_sample30y=d(:,2);

d=load('nu_sample1_1y_chain1.txt');
nu_sample1y=d(:,2);
d=load('nu_sample1_2y_chain1.txt');
nu_sample2y=d(:,2);
d=load('nu_sample1_3y_chain1.txt');
nu_sample3y=d(:,2);
d=load('nu_sample1_4y_chain1.txt');
nu_sample4y=d(:,2);
d=load('nu_sample1_5y_chain1.txt');
nu_sample5y=d(:,2);
d=load('nu_sample1_7y_chain1.txt');
nu_sample7y=d(:,2);
d=load('nu_sample1_10y_chain1.txt');
nu_sample10y=d(:,2);
d=load('nu_sample1_30y_chain1.txt');
nu_sample30y=d(:,2);

% transform mu and rho parameter draws into draws of mu and kappa
kappa_sample1y=1-rho_sample1y;
theta_sample1y=mu_sample1y./kappa_sample1y;
kappa_sample2y=1-rho_sample2y;
theta_sample2y=mu_sample2y./kappa_sample2y;
kappa_sample3y=1-rho_sample3y;
theta_sample3y=mu_sample3y./kappa_sample3y;
kappa_sample4y=1-rho_sample4y;
theta_sample4y=mu_sample4y./kappa_sample4y;
kappa_sample5y=1-rho_sample5y;
theta_sample5y=mu_sample5y./kappa_sample5y;
kappa_sample7y=1-rho_sample7y;
theta_sample7y=mu_sample7y./kappa_sample7y;
kappa_sample10y=1-rho_sample10y;
theta_sample10y=mu_sample10y./kappa_sample10y;
kappa_sample30y=1-rho_sample30y;
theta_sample30y=mu_sample30y./kappa_sample30y;

% compute some simple statistics
mean_theta=mean([theta_sample1y,theta_sample2y,theta_sample3y,theta_sample4y,...
    theta_sample5y,theta_sample7y,theta_sample10y,theta_sample30y]);
median_theta=median([theta_sample1y,theta_sample2y,theta_sample3y,theta_sample4y,...
    theta_sample5y,theta_sample7y,theta_sample10y,theta_sample30y]);
p025_theta=prctile([theta_sample1y,theta_sample2y,theta_sample3y,theta_sample4y,...
    theta_sample5y,theta_sample7y,theta_sample10y,theta_sample30y],2.5);
p975_theta=prctile([theta_sample1y,theta_sample2y,theta_sample3y,theta_sample4y,...
    theta_sample5y,theta_sample7y,theta_sample10y,theta_sample30y],97.5);
std_theta=std([theta_sample1y,theta_sample2y,theta_sample3y,theta_sample4y,...
    theta_sample5y,theta_sample7y,theta_sample10y,theta_sample30y]);

mean_kappa=mean([kappa_sample1y,kappa_sample2y,kappa_sample3y,kappa_sample4y,...
    kappa_sample5y,kappa_sample7y,kappa_sample10y,kappa_sample30y]);
median_kappa=median([kappa_sample1y,kappa_sample2y,kappa_sample3y,kappa_sample4y,...
    kappa_sample5y,kappa_sample7y,kappa_sample10y,kappa_sample30y]);
p025_kappa=prctile([kappa_sample1y,kappa_sample2y,kappa_sample3y,kappa_sample4y,...
    kappa_sample5y,kappa_sample7y,kappa_sample10y,kappa_sample30y],2.5);
p975_kappa=prctile([kappa_sample1y,kappa_sample2y,kappa_sample3y,kappa_sample4y,...
    kappa_sample5y,kappa_sample7y,kappa_sample10y,kappa_sample30y],97.5);
std_kappa=std([kappa_sample1y,kappa_sample2y,kappa_sample3y,kappa_sample4y,...
    kappa_sample5y,kappa_sample7y,kappa_sample10y,kappa_sample30y]);

mean_sigma=mean([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
median_sigma=median([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
p025_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],2.5);
p975_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],97.5);
std_sigma=std([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);

mean_gamma=mean([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);
median_gamma=median([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);
p025_gamma=prctile([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y],2.5);
p975_gamma=prctile([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y],97.5);
std_gamma=std([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);

mean_nu=mean([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
median_nu=median([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
p025_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],2.5);
p975_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],97.5);
std_nu=std([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);

medians=[median_theta;median_kappa;median_sigma;median_gamma;median_nu];
p025=[p025_theta;p025_kappa;p025_sigma;p025_gamma;p025_nu];
p975=[p975_theta;p975_kappa;p975_sigma;p975_gamma;p975_nu];
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
pname={'theta','kappa','sigma','gamma','nu'};
NM=8;
NV=5;

% save posterior medians and posterior 95% confidence intervals into a file
fid=fopen('irswap_bcev4_sample1_stats.csv','w');
fprintf(fid,'%s,%s,%s,%s,%s\n','Swap Maturity','Parameter','Posterior Median',...
    'Posterior 2.5th percentile','Posterior 97.5th percentile');
for i=1:NM
    for j=1:NV
        fprintf(fid,'%s,%s,%7.4f,%7.4f,%7.4f\n',swap_maturity{i},pname{j},...
            medians(j,i),p025(j,i),p975(j,i));
    end
end
fclose(fid);

% kernel-smoothed density plots of posterior marginal densities
NMC=size(nu_sample30y,1);
NK=100;
samples=NaN(NMC,NV,NM);
samples(:,:,1)=[theta_sample1y,kappa_sample1y,sigma_sample1y,gamma_sample1y,nu_sample1y];
samples(:,:,2)=[theta_sample2y,kappa_sample2y,sigma_sample2y,gamma_sample2y,nu_sample2y];
samples(:,:,3)=[theta_sample3y,kappa_sample3y,sigma_sample3y,gamma_sample3y,nu_sample3y];
samples(:,:,4)=[theta_sample4y,kappa_sample4y,sigma_sample4y,gamma_sample4y,nu_sample4y];
samples(:,:,5)=[theta_sample5y,kappa_sample5y,sigma_sample5y,gamma_sample5y,nu_sample5y];
samples(:,:,6)=[theta_sample7y,kappa_sample7y,sigma_sample7y,gamma_sample7y,nu_sample7y];
samples(:,:,7)=[theta_sample10y,kappa_sample10y,sigma_sample10y,gamma_sample10y,nu_sample10y];
samples(:,:,8)=[theta_sample30y,kappa_sample30y,sigma_sample30y,gamma_sample30y,nu_sample30y];

ksd=NaN(NV,NK,NM);
xsd=NaN(NV,NK,NM);

for i=1:NM
    for j=1:NV
        lb=prctile(samples(:,j,i),2.5);
        ub=prctile(samples(:,j,i),97.5);
        il=find(samples(:,j,i)>lb);
        gsample=samples(il,j,i);
        iu=find(gsample<ub);
        fsample=gsample(iu);
        if j<3
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','unbounded');
        elseif j<4
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','positive');
        elseif j<5
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support',[-1.001,2.001]);
        else
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support',[2,30]);
        end
        figure;
        plot(xsd(j,:,i),ksd(j,:,i),'r-','LineWidth',2);
        xlabel(pname{j});
        ylabel('Marginal Posterior Density');
        title([swap_maturity{i},'US Interest Rate Swaps (1-year sample)']);
        filename=[pname{j},'_',swap_maturity{i},'_sample1_ksd'];
        print('-depsc2',[filename,'.eps']);
        print('-djpeg',[filename,'.jpg']);
        print('-dpdf',[filename,'.pdf']);
    end
end

% save data to mat file
save irswap_bcev4_sample1_postprocess.mat