function [m,e]=cev3_moments(b,infoz,stat,y,X,Z)

% X is r(t-1), y is r(t)-r(t-1) Z is [1 r(t-1) r(t-1)^2]
% infoz.parms is a 3-vector indicating if the pararmeter is restricted
%   To impose a restriction, pass the value in the desired element, else
%   pass a NaN.
%   The parameter vector is arranged as [mu sigmasq gamma]

% --- Grab parameters out of b, Find parameters that are fixed -------
parms = repmat(NaN,3,1);
parms(isnan(infoz.parms)) = b;
parms(~isnan(infoz.parms)) = infoz.parms(~isnan(infoz.parms));
mu = parms(1);
sigma = parms(2);
gamma = parms(3);
  

% --- Form model residuals -------------------------------------------  
T = rows(X);
e1 = y - mu;
e2 = e1.^2 - (sigma^2*X.^(2*gamma));
e3 = e1.^3;
e4 = e1.^4;
%e = [e1 e2 e3 e4];
e = [e1 e2];

% --- Moments are inner product with instruments ---------------------
m = reshape(Z'*e/T,6,1);
%m = reshape(Z'*e/T,4,1);