% comparison of gmm and MLE estimates of gamma
% load gmm results
% full sample
gmm_full_results=csvread('irswap_cev3_full_gmmstats.csv',1,2);
gmm_full_gamma=gmm_full_results(3:3:24,:);

% 4y sample
gmm_sample4_results=csvread('irswap_cev3_sample4_gmmstats.csv',1,2);
gmm_sample4_gamma=gmm_sample4_results(3:3:24,:);

% 1y sample
gmm_sample1_results=csvread('irswap_cev3_sample1_gmmstats.csv',1,2);
gmm_sample1_gamma=gmm_sample1_results(3:3:24,:);

% load mle normal results
% full sample
mle_cev3N_full_results=csvread('irswap_cev3_full_stats.csv',1,2);
mle_cev3N_full_gamma=mle_cev3N_full_results(3:3:24,:);
 
% 4y sample
mle_cev3N_sample4_results=csvread('irswap_cev3_sample4_stats.csv',1,2);
mle_cev3N_sample4_gamma=mle_cev3N_sample4_results(3:3:24,:);

% 1y sample
mle_cev3N_sample1_results=csvread('irswap_cev3_sample1_stats.csv',1,2);
mle_cev3N_sample1_gamma=mle_cev3N_sample1_results(3:3:24,:);

% load mle student t results
% full sample
mle_cev3t_full_results=csvread('irswap_cevt3_full_stats.csv',1,2);
mle_cev3t_full_gamma=mle_cev3t_full_results(3:4:31,:);

% 4y sample
mle_cev3t_sample4_results=csvread('irswap_cevt3_sample4_stats.csv',1,2);
mle_cev3t_sample4_gamma=mle_cev3t_sample4_results(3:4:31,:);

% 1y sample
mle_cev3t_sample1_results=csvread('irswap_cevt3_sample1_stats.csv',1,2);
mle_cev3t_sample1_gamma=mle_cev3t_sample1_results(3:4:31,:);

% reshape things if needed

% plot of estimates with error bars
% gmm versus normal MLE
figure;
% just the dots first
plot(mle_cev3N_full_gamma(:,1),gmm_full_gamma(:,1),'r.','MarkerSize',22);hold on;
plot(mle_cev3N_sample4_gamma(:,1),gmm_sample4_gamma(:,1),'b.','MarkerSize',22);hold on;
plot(mle_cev3N_sample1_gamma(:,1),gmm_sample1_gamma(:,1),'g.','MarkerSize',22);hold on;
legend('Full sample','4-year sample','1-year sample','Location','NorthWest');
% error bars
errorbar(mle_cev3N_sample1_gamma(:,1),gmm_sample1_gamma(:,1),...
    gmm_sample1_gamma(:,1)-gmm_sample1_gamma(:,2),...
    gmm_sample1_gamma(:,3)-gmm_sample1_gamma(:,1),'g.');
hold on;
herrorbar(mle_cev3N_sample1_gamma(:,1),gmm_sample1_gamma(:,1),...
    mle_cev3N_sample1_gamma(:,1)-mle_cev3N_sample1_gamma(:,2),...
    mle_cev3N_sample1_gamma(:,3)-mle_cev3N_sample1_gamma(:,1),'g.');
hold on;
errorbar(mle_cev3N_sample4_gamma(:,1),gmm_sample4_gamma(:,1),...
    gmm_sample4_gamma(:,1)-gmm_sample4_gamma(:,2),...
    gmm_sample4_gamma(:,3)-gmm_sample4_gamma(:,1),'b.');
hold on;
herrorbar(mle_cev3N_sample4_gamma(:,1),gmm_sample4_gamma(:,1),...
    mle_cev3N_sample4_gamma(:,1)-mle_cev3N_sample4_gamma(:,2),...
    mle_cev3N_sample4_gamma(:,3)-mle_cev3N_sample4_gamma(:,1),'b.');
hold on;
errorbar(mle_cev3N_full_gamma(:,1),gmm_full_gamma(:,1),...
    gmm_full_gamma(:,1)-gmm_full_gamma(:,2),...
    gmm_full_gamma(:,3)-gmm_full_gamma(:,1),'r.');
hold on;
herrorbar(mle_cev3N_full_gamma(:,1),gmm_full_gamma(:,1),...
    mle_cev3N_full_gamma(:,1)-mle_cev3N_full_gamma(:,2),...
    mle_cev3N_full_gamma(:,3)-mle_cev3N_full_gamma(:,1),'r.');
hold on;
xlabel('MLE');
ylabel('GMM');
% finally add axes and 45-degree line
axis([-1.5,2,-1.5,2]);
v=axis;
l1=line([v(1),v(2)],[0,0]); 
set(l1,'Color','k');
hold on;
l2=line([0,0],[v(3),v(4)]); 
set(l2,'Color','k');
hold on;
d45=linspace(v(1),v(2));
plot(d45,d45,'k--');
print('-dpdf','irswaps_cev3_gmm_mleN_comparison.pdf')
print('-djpeg','irswaps_cev3_gmm_mleN_comparison.jpg')
print('-depsc2','irswaps_cev3_gmm_mleN_comparison.eps')

% gmm versus Student t MLE
figure;
% just the dots first
plot(mle_cev3t_full_gamma(:,1),gmm_full_gamma(:,1),'r.','MarkerSize',22);hold on;
plot(mle_cev3t_sample4_gamma(:,1),gmm_sample4_gamma(:,1),'b.','MarkerSize',22);hold on;
plot(mle_cev3t_sample1_gamma(:,1),gmm_sample1_gamma(:,1),'g.','MarkerSize',22);hold on;
legend('Full sample','4-year sample','1-year sample')
% error bars
errorbar(mle_cev3t_sample1_gamma(:,1),gmm_sample1_gamma(:,1),...
    gmm_sample1_gamma(:,1)-gmm_sample1_gamma(:,2),...
    gmm_sample1_gamma(:,3)-gmm_sample1_gamma(:,1),'g.');
hold on;
herrorbar(mle_cev3t_sample1_gamma(:,1),gmm_sample1_gamma(:,1),...
    mle_cev3t_sample1_gamma(:,1)-mle_cev3t_sample1_gamma(:,2),...
    mle_cev3t_sample1_gamma(:,3)-mle_cev3t_sample1_gamma(:,1),'g.');
hold on;
errorbar(mle_cev3t_sample4_gamma(:,1),gmm_sample4_gamma(:,1),...
    gmm_sample4_gamma(:,1)-gmm_sample4_gamma(:,2),...
    gmm_sample4_gamma(:,3)-gmm_sample4_gamma(:,1),'b.');
hold on;
herrorbar(mle_cev3t_sample4_gamma(:,1),gmm_sample4_gamma(:,1),...
    mle_cev3t_sample4_gamma(:,1)-mle_cev3t_sample4_gamma(:,2),...
    mle_cev3t_sample4_gamma(:,3)-mle_cev3t_sample4_gamma(:,1),'b.');
hold on;
errorbar(mle_cev3t_full_gamma(:,1),gmm_full_gamma(:,1),...
    gmm_full_gamma(:,1)-gmm_full_gamma(:,2),...
    gmm_full_gamma(:,3)-gmm_full_gamma(:,1),'r.');
hold on;
herrorbar(mle_cev3t_full_gamma(:,1),gmm_full_gamma(:,1),...
    mle_cev3t_full_gamma(:,1)-mle_cev3t_full_gamma(:,2),...
    mle_cev3t_full_gamma(:,3)-mle_cev3t_full_gamma(:,1),'r.');
hold on;
xlabel('MLE');
ylabel('GMM');
% finally add axes and 45-degree line
axis([-.5,1.25,-.5,1.25]);
v=axis;
l1=line([v(1),v(2)],[0,0]); 
set(l1,'Color','k');
hold on;
l2=line([0,0],[v(3),v(4)]); 
set(l2,'Color','k');
hold on;
d45=linspace(v(1),v(2));
plot(d45,d45,'k--');
print('-dpdf','irswaps_cev3_gmm_mlet_comparison.pdf')
print('-djpeg','irswaps_cev3_gmm_mlet_comparison.jpg')
print('-depsc2','irswaps_cev3_gmm_mlet_comparison.eps')

% 2-in-1 comparison
figure;
subplot(2,1,1);
% just the dots first
plot(mle_cev3N_full_gamma(:,1),gmm_full_gamma(:,1),'r.','MarkerSize',22);hold on;
plot(mle_cev3N_sample4_gamma(:,1),gmm_sample4_gamma(:,1),'b.','MarkerSize',22);hold on;
plot(mle_cev3N_sample1_gamma(:,1),gmm_sample1_gamma(:,1),'g.','MarkerSize',22);hold on;
legend('Full sample','4-year sample','1-year sample','Location','NorthWest')
% error bars
errorbar(mle_cev3N_sample1_gamma(:,1),gmm_sample1_gamma(:,1),...
    gmm_sample1_gamma(:,1)-gmm_sample1_gamma(:,2),...
    gmm_sample1_gamma(:,3)-gmm_sample1_gamma(:,1),'g.');
hold on;
herrorbar(mle_cev3N_sample1_gamma(:,1),gmm_sample1_gamma(:,1),...
    mle_cev3N_sample1_gamma(:,1)-mle_cev3N_sample1_gamma(:,2),...
    mle_cev3N_sample1_gamma(:,3)-mle_cev3N_sample1_gamma(:,1),'g.');
hold on;
errorbar(mle_cev3N_sample4_gamma(:,1),gmm_sample4_gamma(:,1),...
    gmm_sample4_gamma(:,1)-gmm_sample4_gamma(:,2),...
    gmm_sample4_gamma(:,3)-gmm_sample4_gamma(:,1),'b.');
hold on;
herrorbar(mle_cev3N_sample4_gamma(:,1),gmm_sample4_gamma(:,1),...
    mle_cev3N_sample4_gamma(:,1)-mle_cev3N_sample4_gamma(:,2),...
    mle_cev3N_sample4_gamma(:,3)-mle_cev3N_sample4_gamma(:,1),'b.');
hold on;
errorbar(mle_cev3N_full_gamma(:,1),gmm_full_gamma(:,1),...
    gmm_full_gamma(:,1)-gmm_full_gamma(:,2),...
    gmm_full_gamma(:,3)-gmm_full_gamma(:,1),'r.');
hold on;
herrorbar(mle_cev3N_full_gamma(:,1),gmm_full_gamma(:,1),...
    mle_cev3N_full_gamma(:,1)-mle_cev3N_full_gamma(:,2),...
    mle_cev3N_full_gamma(:,3)-mle_cev3N_full_gamma(:,1),'r.');
hold on;
xlabel('MLE');
ylabel('GMM');
title('Normal residuals');
% finally add axes and 45-degree line
axis([-1.5,2,-1.5,2]);
v=axis;
l1=line([v(1),v(2)],[0,0]); 
set(l1,'Color','k');
hold on;
l2=line([0,0],[v(3),v(4)]); 
set(l2,'Color','k');
hold on;
d45=linspace(v(1),v(2));
plot(d45,d45,'k--');
subplot(2,1,2);
% just the dots first
plot(mle_cev3t_full_gamma(:,1),gmm_full_gamma(:,1),'r.','MarkerSize',22);hold on;
plot(mle_cev3t_sample4_gamma(:,1),gmm_sample4_gamma(:,1),'b.','MarkerSize',22);hold on;
plot(mle_cev3t_sample1_gamma(:,1),gmm_sample1_gamma(:,1),'g.','MarkerSize',22);hold on;
%legend('Full sample','4-year sample','1-year sample','Location','SouthEast')
% error bars
errorbar(mle_cev3t_sample1_gamma(:,1),gmm_sample1_gamma(:,1),...
    gmm_sample1_gamma(:,1)-gmm_sample1_gamma(:,2),...
    gmm_sample1_gamma(:,3)-gmm_sample1_gamma(:,1),'g.');
hold on;
herrorbar(mle_cev3t_sample1_gamma(:,1),gmm_sample1_gamma(:,1),...
    mle_cev3t_sample1_gamma(:,1)-mle_cev3t_sample1_gamma(:,2),...
    mle_cev3t_sample1_gamma(:,3)-mle_cev3t_sample1_gamma(:,1),'g.');
hold on;
errorbar(mle_cev3t_sample4_gamma(:,1),gmm_sample4_gamma(:,1),...
    gmm_sample4_gamma(:,1)-gmm_sample4_gamma(:,2),...
    gmm_sample4_gamma(:,3)-gmm_sample4_gamma(:,1),'b.');
hold on;
herrorbar(mle_cev3t_sample4_gamma(:,1),gmm_sample4_gamma(:,1),...
    mle_cev3t_sample4_gamma(:,1)-mle_cev3t_sample4_gamma(:,2),...
    mle_cev3t_sample4_gamma(:,3)-mle_cev3t_sample4_gamma(:,1),'b.');
hold on;
errorbar(mle_cev3t_full_gamma(:,1),gmm_full_gamma(:,1),...
    gmm_full_gamma(:,1)-gmm_full_gamma(:,2),...
    gmm_full_gamma(:,3)-gmm_full_gamma(:,1),'r.');
hold on;
herrorbar(mle_cev3t_full_gamma(:,1),gmm_full_gamma(:,1),...
    mle_cev3t_full_gamma(:,1)-mle_cev3t_full_gamma(:,2),...
    mle_cev3t_full_gamma(:,3)-mle_cev3t_full_gamma(:,1),'r.');
hold on;
xlabel('MLE');
ylabel('GMM');
title('Student t residuals');
% finally add axes and 45-degree line
axis([-1.5,2.0,-1.5,2.0]);
v=axis;
l1=line([v(1),v(2)],[0,0]); 
set(l1,'Color','k');
hold on;
l2=line([0,0],[v(3),v(4)]); 
set(l2,'Color','k');
hold on;
d45=linspace(v(1),v(2));
plot(d45,d45,'k--');
print('-dpdf','irswaps_cev3_gmm_mle_comparison.pdf')
print('-djpeg','irswaps_cev3_gmm_mle_comparison.jpg')
print('-depsc2','irswaps_cev3_gmm_mle_comparison.eps')