% compute log-likelihood function for constant elasticity of
% volatility model with normal innovations
% INPUTS
% params    = vector containing the 2 parameters (log scale, elasticity)
% r0        = initial value
% data      = sample, purpotedly from CEV with normal innovations
% cens      = censoring parameter (not used)
% freq      = a vector of integer input frequences 9not used)
% OUTPUTS
% L         = log-likelihood function

function L = cev2_normal_llf(params,data,cens,freq)

r0=data(1,1);
r=data(2:end);
sigmabar=exp(params(1));
gamma=params(2);
L=cev2_normal_loglik(r0,r,sigmabar,gamma);