% compute log-likelihood function for driftless cev process with normal innovations
% INPUTS
% r0        = initial value
% r(1:T)    = sample, purpotedly from CEV with normal innovations
% sigma     = scale of variance
% gamma     = elasticity of variance
% OUTPUTS
% L         = log-likelihood function

function L = cev2_normal_loglik(r0,r,sigma,gamma)

T=size(r,1); % determinet the sample size
L=log(1/(sqrt(2*pi)*sigma*r0^gamma))-((r(1)-r0)^2/(2*sigma^2*r0^(2*gamma)));
if isnan(L)
    L=0;
end
% %L=log(normpdf((r(1)-r0)/(sigma*r0^gamma),0,1));
for t=2:T
    L1=log(1/(sqrt(2*pi)*sigma*r(t-1)^gamma))-((r(t)-r(t-1))^2/(2*sigma^2*r(t-1)^(2*gamma)));
    if ~isnan(L1)
        L=L+L1;
    end
end
%L=L+nansum(log(tpdf(diff(r)./(sigma.*r(1:end-1).^gamma),100))); 