% compute log-likelihood function for constant elasticity of
% volatility model with Student t innovations
% INPUTS
% params    = vector containing the 3 parameters (log scale, elasticity, degrees of freedom)
% r0        = initial value
% data      = sample, purpotedly from CEV with t innovations
% cens      = censoring parameter (not used)
% freq      = a vector of integer input frequences (not used)
% OUTPUTS
% L         = log-likelihood function

function L = cev2_t_llf(params,data,cens,freq)

r0=data(1,1);
r=data(2:end);
sigmabar=exp(params(1));
gamma=params(2);
nu=params(3);
L=cev2_t_loglik(r0,r,sigmabar,gamma,nu);