% compute log-likelihood function for driftless cev process with normal innovations
% INPUTS
% r0        = initial value
% r(1:T)    = sample, purpotedly from CEV with normal innovations
% mu        = mean drift
% sigma     = scale of variance
% gamma     = elasticity of variance
% OUTPUTS
% L         = log-likelihood function

function L = cev3_normal_loglik(r0,r,mu,sigma,gamma)

T=size(r,1); % determine the sample size
%L=log(normpdf((r(1)-r0-kappa*(theta-r0))/(sigma*abs(r0)^gamma),0,1));
L=log(1/(sqrt(2*pi)*sigma*abs(r0)^gamma))-((r(1)-r0-mu)^2/(2*sigma^2*abs(r0)^(2*gamma)));
if isnan(L)
    L=0;
end
for t=2:T
    %L1=log(normpdf((r(t)-r(t-1)-kappa*(theta-r(t-1)))/(sigma*abs(r(t-1))^gamma),0,1));
    L1=log(1/(sqrt(2*pi)*sigma*abs(r(t-1))^gamma))-((r(t)-r(t-1)-mu)^2/(2*sigma^2*abs(r(t-1))^(2*gamma)));
    if ~isnan(L1)
        L=L+L1;
    end
end
%L=L+nansum(log(tpdf(diff(r)./(sigma.*r(1:end-1).^gamma),100))); 