% compute log-likelihood function for constant elasticity of
% volatility model with student t innovations
% INPUTS
% params    = vector containing the 3 parameters (mean,log scale, elasticity)
% r0        = initial value
% data      = sample, purpotedly from CEV with normal innovations
% cens      = censoring parameter (not used)
% freq      = a vector of integer input frequences 9not used)
% OUTPUTS
% L         = log-likelihood function

function L = cev3_t_llf(params,data,cens,freq)

r0=data(1,1);
r=data(2:end);
mu=params(1);
sigmabar=exp(params(2));
gamma=params(3);
nu = params(4);
L=cev3_t_loglik(r0,r,mu,sigmabar,gamma,nu);