% latex tables for CEV model
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
varnames={'$\mu$','$\sigma$','\gamma$','$\nu$'};
N=8;
NV=3; % for GMM and MLE normal

% GMM results
params=csvread('irswap_cev3_full_gmmstats.csv',1,2);
params4=csvread('irswap_cev3_sample4_gmmstats.csv',1,2);
params1=csvread('irswap_cev3_sample1_gmmstats.csv',1,2);

FID = fopen('cev3_gmm_results.tex', 'w');
fprintf(FID, '\\begin{tabular}{ccrrrrrr}\\hline\n');
fprintf(FID,'\\multirow{2}{1.1cm}{Swap Maturity} & \\multirow{2}{*}{Parameter} & \\multicolumn{2}{c}{Full Sample} & \\multicolumn{2}{c}{4-year window} & \\multicolumn{2}{c}{1-year window}\\\\ \n');
fprintf(FID,'\\cline{3-8} & & Estimate & Bounds & Estimate & Bounds& Estimate & Bounds  \\\\ \n');
fprintf(FID,'\\hline\\hline \n');
for i=1:N
    for j=1:NV
        if j==2
            fprintf(FID,'%s & %s & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) \\\\ \n',...
                swap_maturity{i},varnames{j},params((i-1)*NV+j,1),params((i-1)*NV+j,2),params((i-1)*NV+j,3),...
                params4((i-1)*NV+j,1),params4((i-1)*NV+j,2),params4((i-1)*NV+j,3),...
                params1((i-1)*NV+j,1),params1((i-1)*NV+j,2),params1((i-1)*NV+j,3));
        else
            fprintf(FID,'& %s & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) \\\\ \n',...
                varnames{j},params((i-1)*NV+j,1),params((i-1)*NV+j,2),params((i-1)*NV+j,3),...
                params4((i-1)*NV+j,1),params4((i-1)*NV+j,2),params4((i-1)*NV+j,3),...
                params1((i-1)*NV+j,1),params1((i-1)*NV+j,2),params1((i-1)*NV+j,3));
        end
        if j==3
            fprintf(FID,'\\hline\n');
        end
    end
end
fprintf(FID, '\\end{tabular}\n');
fclose(FID);

% Normal MLE results
clear params params1 params4
params=csvread('irswap_cev3_full_stats.csv',1,2);
params4=csvread('irswap_cev3_sample4_stats.csv',1,2);
params1=csvread('irswap_cev3_sample1_stats.csv',1,2);

FID = fopen('cev3_normal_results.tex', 'w');
fprintf(FID, '\\begin{tabular}{ccrrrrrr}\\hline\n');
fprintf(FID,'\\multirow{2}{1.1cm}{Swap Maturity} & \\multirow{2}{*}{Parameter} & \\multicolumn{2}{c}{Full Sample} & \\multicolumn{2}{c}{4-year window} & \\multicolumn{2}{c}{1-year window}\\\\ \n');
fprintf(FID,'\\cline{3-8} & & Estimate & Bounds & Estimate & Bounds& Estimate & Bounds  \\\\ \n');
fprintf(FID,'\\hline\\hline \n');
for i=1:N
    for j=1:NV
        if j==2
            fprintf(FID,'%s & %s & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) \\\\ \n',...
                swap_maturity{i},varnames{j},params((i-1)*NV+j,1),params((i-1)*NV+j,2),params((i-1)*NV+j,3),...
                params4((i-1)*NV+j,1),params4((i-1)*NV+j,2),params4((i-1)*NV+j,3),...
                params1((i-1)*NV+j,1),params1((i-1)*NV+j,2),params1((i-1)*NV+j,3));
        else
            fprintf(FID,'& %s & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) \\\\ \n',...
                varnames{j},params((i-1)*NV+j,1),params((i-1)*NV+j,2),params((i-1)*NV+j,3),...
                params4((i-1)*NV+j,1),params4((i-1)*NV+j,2),params4((i-1)*NV+j,3),...
                params1((i-1)*NV+j,1),params1((i-1)*NV+j,2),params1((i-1)*NV+j,3));
        end
        if j==3
            fprintf(FID,'\\hline\n');
        end
    end
end
fprintf(FID, '\\end{tabular}\n');
fclose(FID);

% Student t MLE results
clear params params1 params4
NV=4;
params=csvread('irswap_cevt3_full_stats.csv',1,2);
params4=csvread('irswap_cevt3_sample4_stats.csv',1,2);
params1=csvread('irswap_cevt3_sample1_stats.csv',1,2);

FID = fopen('cev3_mle_results.tex', 'w');
fprintf(FID, '\\begin{tabular}{ccrrrrrr}\\hline\n');
fprintf(FID,'\\multirow{2}{1.1cm}{Swap Maturity} & \\multirow{2}{*}{Parameter} & \\multicolumn{2}{c}{Full Sample} & \\multicolumn{2}{c}{4-year window} & \\multicolumn{2}{c}{1-year window}\\\\ \n');
fprintf(FID,'\\cline{3-8} & & Estimate & Bounds & Estimate & Bounds& Estimate & Bounds  \\\\ \n');
fprintf(FID,'\\hline\\hline \n');
for i=1:N
    for j=1:NV
        if j==3
            fprintf(FID,'%s & %s & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) \\\\ \n',...
                swap_maturity{i},varnames{j},params((i-1)*NV+j,1),params((i-1)*NV+j,2),params((i-1)*NV+j,3),...
                params4((i-1)*NV+j,1),params4((i-1)*NV+j,2),params4((i-1)*NV+j,3),...
                params1((i-1)*NV+j,1),params1((i-1)*NV+j,2),params1((i-1)*NV+j,3));
        else
            fprintf(FID,'& %s & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) \\\\ \n',...
                varnames{j},params((i-1)*NV+j,1),params((i-1)*NV+j,2),params((i-1)*NV+j,3),...
                params4((i-1)*NV+j,1),params4((i-1)*NV+j,2),params4((i-1)*NV+j,3),...
                params1((i-1)*NV+j,1),params1((i-1)*NV+j,2),params1((i-1)*NV+j,3));
        end
        if j==4
            fprintf(FID,'\\hline\n');
        end
    end
end
fprintf(FID, '\\end{tabular}\n');
fclose(FID);

% Student t Bayesian results
clear params params1 params4
params=csvread('irswap_bcev3_full_stats.csv',1,2);
params4=csvread('irswap_bcev3_sample4_stats.csv',1,2);
params1=csvread('irswap_bcev3_sample1_stats.csv',1,2);

FID = fopen('bcev3_results.tex', 'w');
fprintf(FID, '\\begin{tabular}{ccrrrrrr}\\hline\n');
fprintf(FID,'\\multirow{3}{1.1cm}{Swap Maturity} & \\multirow{3}{*}{Parameter} & \\multicolumn{2}{c}{Full Sample} & \\multicolumn{2}{c}{4-year Window} & \\multicolumn{2}{c}{1-year Window}\\\\ \n');
fprintf(FID,'\\cline{3-8} & & {Posterior} & Posterior & {Posterior} & Posterior& {Posterior} & Posterior  \\\\ \n');
fprintf(FID, ' & & {Median} & 95\\%% Bounds & {Median} & 95\\%% Bounds & {Median} & 95\\%% Bounds \\\\ \n');
fprintf(FID,'\\hline\\hline \n');
for i=1:N
    for j=1:NV
        if j==3
            fprintf(FID,'%s & %s & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) \\\\ \n',...
                swap_maturity{i},varnames{j},params((i-1)*NV+j,1),params((i-1)*NV+j,2),params((i-1)*NV+j,3),...
                params4((i-1)*NV+j,1),params4((i-1)*NV+j,2),params4((i-1)*NV+j,3),...
                params1((i-1)*NV+j,1),params1((i-1)*NV+j,2),params1((i-1)*NV+j,3));
        else
            fprintf(FID,'& %s & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) \\\\ \n',...
                varnames{j},params((i-1)*NV+j,1),params((i-1)*NV+j,2),params((i-1)*NV+j,3),...
                params4((i-1)*NV+j,1),params4((i-1)*NV+j,2),params4((i-1)*NV+j,3),...
                params1((i-1)*NV+j,1),params1((i-1)*NV+j,2),params1((i-1)*NV+j,3));
        end
        if j==4
            fprintf(FID,'\\hline\n');
        end
    end
end
fprintf(FID, '\\end{tabular}\n');
fclose(FID);



% panel version of Bayesian CEV with common gamma
clear params params1 params4
params=csvread('irswap_bcev3_panel_full_stats.csv',1,2);
params4=csvread('irswap_bcev3_panel_sample4_stats.csv',1,2);
params1=csvread('irswap_bcev3_panel_sample1_stats.csv',1,2);

FID = fopen('bcev3_panel_results.tex', 'w');
fprintf(FID, '\\begin{tabular}{ccrrrrrr}\\hline\n');
fprintf(FID,'\\multirow{3}{*}{Swap Maturity} & \\multirow{3}{*}{Parameter} & \\multicolumn{2}{c}{Full Sample} & \\multicolumn{2}{c}{4-year Window} & \\multicolumn{2}{c}{1-year Window}\\\\ \n');
fprintf(FID,'\\cline{3-8} & & {Posterior} & Posterior & {Posterior} & Posterior& {Posterior} & Posterior  \\\\ \n');
fprintf(FID, ' & & {Median} & 95\\%% Bounds & {Median} & 95\\%% Bounds & {Median} & 95\\%% Bounds \\\\ \n');
fprintf(FID,'\\hline\\hline \n');
for i=1:N
    for j=1:NV
        if j==2 % sigma row
            fprintf(FID,'%s & %s & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) \\\\ \n',...
                swap_maturity{i},varnames{j},params((i-1)*NV+j,1),params((i-1)*NV+j,2),params((i-1)*NV+j,3),...
                params4((i-1)*NV+j,1),params4((i-1)*NV+j,2),params4((i-1)*NV+j,3),...
                params1((i-1)*NV+j,1),params1((i-1)*NV+j,2),params1((i-1)*NV+j,3));
        elseif (j~=3) % skip gamma rows
            fprintf(FID,'& %s & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) \\\\ \n',...
                varnames{j},params((i-1)*NV+j,1),params((i-1)*NV+j,2),params((i-1)*NV+j,3),...
                params4((i-1)*NV+j,1),params4((i-1)*NV+j,2),params4((i-1)*NV+j,3),...
                params1((i-1)*NV+j,1),params1((i-1)*NV+j,2),params1((i-1)*NV+j,3));
        end
        if j==NV
            fprintf(FID,'\\hline\n');
        end
    end
end
% add gamma row
i=1;
j=3;
fprintf(FID,'& %s & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) & %5.3f &(%5.3f,%5.3f) \\\\ \n',...
    varnames{j},params((i-1)*NV+j,1),params((i-1)*NV+j,2),params((i-1)*NV+j,3),...
    params4((i-1)*NV+j,1),params4((i-1)*NV+j,2),params4((i-1)*NV+j,3),...
    params1((i-1)*NV+j,1),params1((i-1)*NV+j,2),params1((i-1)*NV+j,3));

fprintf(FID,'\\hline\n');
fprintf(FID, '\\end{tabular}\n');
fclose(FID);

% GMM J-test for overidentifying restrictions
jtest=csvread('irswap_cev3_gmmfit.csv',1,1);

FID = fopen('cev3_gmm_jtest.tex', 'w');
fprintf(FID, '\\begin{tabular}{crrrrrr}\\hline\n');
fprintf(FID,'\\multirow{2}{1.1cm}{Swap Maturity} &  \\multicolumn{2}{c}{Full Sample} & \\multicolumn{2}{c}{4-year window} & \\multicolumn{2}{c}{1-year window}\\\\ \n');
fprintf(FID,'\\cline{2-7} & J-test & p-value & J-test & p-value& J-test & p-value  \\\\ \n');
fprintf(FID,'\\hline\\hline \n');
for i=1:N
    fprintf(FID,'%s & %5.3f & %5.3f & %5.3f &%5.3f & %5.3f &%5.3f \\\\ \n',...
        swap_maturity{i},jtest(i,1),jtest(i,2),jtest(i,3),jtest(i,4),jtest(i,5),jtest(i,6)); 
    fprintf(FID,'\\hline\n');  
end
fprintf(FID, '\\end{tabular}\n');
fclose(FID);
