% latex tables for Nyblom Stability tests
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
NM=8;


% read in results
Nyt=csvread('irswap_cev3t_nyblomstats.csv',1,1);



FID = fopen('cev3t_nyblom_results.tex', 'w');
fprintf(FID, '\\begin{tabular}{cclclcl}\\hline\n');
fprintf(FID,'\\multirow{2}{*}{Swap Maturity} &  \\multicolumn{2}{c}{Full sample} &\\multicolumn{2}{c}{4-year sample} &\\multicolumn{2}{c}{1-year sample} \\\\ \n');
fprintf(FID,'\\cline{2-7} & Test stat & p-value & Test stat & p-value & Test stat & p-value \\\\ \n');
fprintf(FID,'\\hline\\hline \n');
for i=1:NM    
    fprintf(FID,'%s & %7.2f & %9.6f  &%7.2f & %9.6f & %7.2f  & %9.6f \\\\ \n',...
                swap_maturity{i},Nyt(i,:));
end
fprintf(FID,'\\hline\n');
fprintf(FID, '\\end{tabular}\n');
fclose(FID);