% simulating Nyblom statistics distribution
NMC=1000000;
T=1000;
x=[ones(T,1),(-1).^(1:T)'];
V0=x'*x;
V=V0/T;
Vinv=inv(V0);
beta=[-1;1];
nyb=NaN(NMC,1);
p=[0.000001,0.00001,0.0001,0.001,0.0025,0.005,0.01,0.025,0.05,0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,0.95,0.975,0.99,0.995,0.9975,0.999];

h=waitbar(0,'Simulating Nyblom Statistics under null');
for i=1:NMC
    waitbar(i/NMC);
    y=x*beta+randn(T,1);
    betahat=Vinv*x'*y;
    e=y-x*betahat;
    sigmasqhat=e'*e/T;
    f=x.*repmat(e,[1,2]);
    S=cumsum(f);
    SS=zeros(2,2);
    for t=1:T
        SS=SS+S(t,:)'*S(t,:);
    end
    nyb(i)=1/(T*sigmasqhat)*trace(Vinv*SS);
end
close(h);
cv=quantile(nyb,1-p);
save nyblom_cv2.mat