% testing cev3_gmm function

% generate artificial time-series from the model
T=1024;
r0=2.9;
sigmabar=0.02;
mu=0.001;
gamma=0.75;
nu=5;
[r,sigma] = cev3_t_simulator(T,mu,sigmabar,gamma,nu,r0);
figure;
plot(r);axis tight;
xlabel('t');
ylabel('r');

% regime counts
['CEV Regime  ','Difference Regime  ','Return Regime  ']
disp([sum(sigma<sigmabar),sum(sigma==sigmabar),sum(sigma>sigmabar)]);




% estimate
start=[0;log(std(diff(r)));0.5];
null=[0 0 0]';
vnames=strvcat('mu','sigma','gamma');	% Names
IWM='Z';
SD='gn';
S='W';
wlags=20;
gmmit=3;
gmmtol=1e-7;
maxit=25;
Strim=1;
Slast=1;
[p,pse] = cev3_gmm(r,start,null,vnames,IWM,SD,S,wlags,gmmit,gmmtol,maxit,Strim,Slast);
% report
disp(['   True mu             ','Estimator           ','Lower Bound         ','Upper Bound        ']);
disp([mu, p(1),p(1)+norminv(0.025)*pse(1),p(1)+norminv(0.975)*pse(1)]);
disp(['   True sigmabar       ','Estimator           ','Lower Bound         ','Upper Bound        ']);
disp([sigmabar, p(2),p(2)+norminv(0.025)*pse(2),p(1)+norminv(0.975)*pse(2)]);
disp(['   True gamma          ','Estimator           ','Lower Bound         ','Upper Bound        ']);
disp([gamma, p(3),p(3)+norminv(0.025)*pse(3),p(3)+norminv(0.975)*pse(3)]);


