% testing simulators from hybrid piecewise elasticity of volatility model
T=1024;
r0=2.67;
sigmabar=0.015;
theta=2.6;
kappa=0.03;
gamma=0.5;
nu=3.5;

[r,sigma] = cev_normal_simulator(T,theta,kappa,sigmabar,gamma,r0);
[rt,sigmat] = cev_t_simulator(T,theta,kappa,sigmabar,gamma,nu,r0);
'sample volatility of normal rates'
std(diff(r))
'sample volatility of fat-tailed rates'
std(diff(rt))

figure;
subplot(2,2,1);
plot(r);axis tight;xlabel('t');ylabel('r_t');
subplot(2,2,2);
plot(sigma); axis tight;xlabel('t');ylabel('\sigma_t');
subplot(2,2,3);
plot(rt);axis tight;xlabel('t');ylabel('r_t');
subplot(2,2,4);
plot(sigmat);axis tight;xlabel('t');ylabel('\sigma_t');

figure;
subplot(2,1,1);
plot(r,'b-'); hold on;
plot(rt,'r-');
axis tight;
xlabel('t');ylabel('r_t');title('Simulated Interest Rate');
subplot(2,1,2);
plot(sigma,'b-'); hold on;
plot(sigmat,'r-');
axis tight;
xlabel('t');ylabel('\sigma_t');title('Simulated volatility')