% compute log-likelihood function for zero elasticity of
% volatility model with normal innovations
% INPUTS
% params    = vector containing the 3 parameters (mean parameters and log scale)
% r0        = initial value
% data      = sample, purpotedly from normal AR model
% cens      = censoring parameter (not used)
% freq      = a vector of integer input frequences 9not used)
% OUTPUTS
% L         = log-likelihood function

function L = zev_normal_llf(params,data,cens,freq)

r0=data(1,1);
r=data(2:end);
theta=params(1);
kappa=params(2);
sigmabar=exp(params(3));
L=cev4_normal_loglik(r0,r,theta,kappa,sigmabar,0);