% compute log-likelihood function for zero elasticity of
% volatility model with Student t innovations
% INPUTS
% params    = vector containing the 4 parameters (mean parameters, log scale, degrees of freedom)
% r0        = initial value
% data      = sample, purpotedly from zero-elastic CEV with t innovations
% cens      = censoring parameter (not used)
% freq      = a vector of integer input frequences (not used)
% OUTPUTS
% L         = log-likelihood function

function L = zev_t_llf(params,data,cens,freq)

r0=data(1,1);
r=data(2:end);
theta=params(1);
kappa=params(2);
sigmabar=exp(params(3));
nu=params(4);
L=cev4_t_loglik(r0,r,theta,kappa,sigmabar,0,nu);