data=csvread('irswap_daily_20000703_20120726.csv',1,1);
[T,N]=size(data);
dates=csvread('irswap_daily_20000703_20120726.csv',1,0,[1,0,T,0]);
data_diff=diff(data);
data_ret=diff(data)./data(1:end-1,:);
years=floor(dates/10000);
months=floor((dates-years*10000)/100);
days=(dates-years*10000-months*100);
T0=floor(T/7);
label_indices=1:T0:T;
N0=numel(label_indices);
date_label={};
for i=1:N0
    date_label{i}=[num2str(years(label_indices(i))),'.',num2str(months(label_indices(i))),'.',num2str(days(label_indices(i)))];
end

co=[0,0,1;  0,0.5,0; 1,0,0; 0,0.75,0.75;   0.75,0,0.75; 0.75,0.75,0; 0.25,0.25,0.25;0.31,0.4,0.58];

% starting date of 4 year window
T04=dates(end)-40000;
i04=min(find(dates>=T04));

% starting date of 1 year window
T01=dates(end)-10000;
i01=min(find(dates>=T01));
eps=0.0001;

% plot levels
figure;
for i=1:7
    plot(data(:,1:7),'Color',co(i,:));hold on;
end
plot(data(:,8),'Color',[0.31,0.4,0.58]);hold on;
axis tight;
y=ylim;
v=axis;
hold off;
h4=fill([i04,i04,T,T],[y(1)+eps,y(2)-eps,y(2)+eps,y(1)-eps],[0.9,0.9,0.9]);hold on;
axis(v);
%set(h4,'FaceAlpha',0.9);
%set(h4,'EdgeAlpha',0.25);
h1=fill([i01,i01,T,T],[y(1),y(2),y(2),y(1)],[0.85,0.85,0.9]);
%set(h1,'FaceAlpha',0.85);
%set(h1,'EdgeAlpha',0.25);
plot(data(:,1:7));hold on;
plot(data(:,8),'Color',[0.31,0.4,0.58]);hold on;
set(gca,'XTick',label_indices);
set(gca,'XTickLabel',date_label);
xticklabel_rotate([],60,[]);
set(get(get(h4,'Annotation'),'LegendInformation'),...
    'IconDisplayStyle','off'); % Exclude line from legend
set(get(get(h1,'Annotation'),'LegendInformation'),...
    'IconDisplayStyle','off'); % Exclude line from legend
legend('1y','2y','3y','4y','5y','7y','10y','30y');
xlabel('Date');
ylabel('Percent');
print('-depsc2','irswaps_levelplot.eps');
print('-djpeg','irswaps_levelplot.jpg');
print('-dpdf','irswaps_levelplot.pdf');

% plot changes
figure;
subplot(1,2,1);
for i=1:7
    plot(data_diff(:,i),'Color',co(i,:));hold on;
end
plot(data_diff(:,8),'Color',[0.31,0.4,0.58]);hold on;
axis tight;
set(gca,'XTick',label_indices);
set(gca,'XTickLabel',date_label);
xticklabel_rotate([],60,[]);
xlabel('Date');
ylabel('Percent');
title('Absolute changes');
subplot(1,2,2);
plot(data_ret(:,1:7));hold on;
plot(data_ret(:,8),'Color',[0.31,0.4,0.58]);hold on;
axis tight;
set(gca,'XTick',label_indices);
set(gca,'XTickLabel',date_label);
xticklabel_rotate([],60,[]);
xlabel('Date');
ylabel('Percent');
title('Relative changes');
print('-depsc2','irswaps_changeplot.eps');
print('-djpeg','irswaps_changeplot.jpg');
print('-dpdf','irswaps_changeplot.pdf');

% plot squared changes
figure;
subplot(1,2,1);
for i=1:7
    plot(data_diff(:,i).^2,'Color',co(i,:));hold on;
end
plot(data_diff(:,8).^2,'Color',[0.31,0.4,0.58]);hold on;
axis tight;
set(gca,'XTick',label_indices);
set(gca,'XTickLabel',date_label);
xticklabel_rotate([],60,[]);
xlabel('Date');
ylabel('Percent');
title('Absolute changes squared');
subplot(1,2,2);
plot(data_ret(:,1:7).^2);hold on;
plot(data_ret(:,8).^2,'Color',[0.31,0.4,0.58]);hold on;
axis tight;
set(gca,'XTick',label_indices);
set(gca,'XTickLabel',date_label);
xticklabel_rotate([],60,[]);
xlabel('Date');
ylabel('Percent');
title('Relative changes squared');
print('-depsc2','irswaps_sqchangeplot.eps');
print('-djpeg','irswaps_sqchangeplot.jpg');
print('-dpdf','irswaps_sqchangeplot.pdf');

% plot both in 2x2 fashion
figure;
subplot(2,2,1);
for i=1:7
    plot(data_diff(:,i),'Color',co(i,:));hold on;
end
plot(data_diff(:,8),'Color',[0.31,0.4,0.58]);hold on;
axis tight;
set(gca,'XTick',label_indices);
set(gca,'XTickLabel',date_label);
xticklabel_rotate([],60,[]);
xlabel('Date');
ylabel('Percent');
title('Absolute changes');
subplot(2,2,2);
plot(data_ret(:,1:7));hold on;
plot(data_ret(:,8),'Color',[0.31,0.4,0.58]);hold on;
axis tight;
set(gca,'XTick',label_indices);
set(gca,'XTickLabel',date_label);
xticklabel_rotate([],60,[]);
xlabel('Date');
ylabel('Percent');
title('Relative changes');
subplot(2,2,3);
for i=1:7
    plot(data_diff(:,i).^2,'Color',co(i,:));hold on;
end
plot(data_diff(:,8).^2,'Color',[0.31,0.4,0.58]);hold on;
axis tight;
set(gca,'XTick',label_indices);
set(gca,'XTickLabel',date_label);
xticklabel_rotate([],60,[]);
xlabel('Date');
ylabel('Percent');
title('Absolute changes squared');
subplot(2,2,4);
plot(data_ret(:,1:7).^2);hold on;
plot(data_ret(:,8).^2,'Color',[0.31,0.4,0.58]);hold on;
axis tight;
set(gca,'XTick',label_indices);
set(gca,'XTickLabel',date_label);
xticklabel_rotate([],60,[]);
xlabel('Date');
ylabel('Percent');
title('Relative changes squared');
print('-depsc2','irswaps_vchangeplot.eps');
print('-djpeg','irswaps_vchangeplot.jpg');
print('-dpdf','irswaps_vchangeplot.pdf');