% latex tables
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
varnames={'Pearson $\chi^2$','AIC','Kolmogorov-Smirnov-Lilliefors','Anderson-Darling',};
N=8;
NV=4;

% read in results
%ksls=zeros(N,6);
ksls=csvread('irswap_ks_t_stats.csv',1,1);
%ads=zeros(N,6);
ads=csvread('irswap_ad_t_stats.csv',1,1);
pears=csvread('irswap_pearson_t_stats.csv',1,1);
%aics=zeros(N,6);
aics=csvread('irswap_aict_stats.csv',1,1);
params=zeros(N*NV,6);
for i=1:N
    params((i-1)*NV+1:i*NV,:)=[pears(i,:);aics(i,:);ksls(i,:);ads(i,:)];
end




FID = fopen('goft_results.tex', 'w');
fprintf(FID, '\\begin{tabular}{clcccccc}\\hline\n');
fprintf(FID,'\\multirow{2}{*}{Swap Maturity} & \\multirow{2}{*}{Statistic} & \\multicolumn{2}{c}{Full Sample} & \\multicolumn{2}{c}{4-year Window} & \\multicolumn{2}{c}{1-year Window}\\\\ \n');
fprintf(FID,'\\cline{3-8} & & Diff & Ret & Diff & Ret& Diff & Ret  \\\\ \n');
fprintf(FID,'\\hline\\hline \n');
for i=1:N
    for j=1:NV
        if j==2
            fprintf(FID,'%s & %s & %9.2f & %9.2f  &%9.4f & %9.2f & %9.2f  & %9.2f \\\\ \n',...
                swap_maturity{i},varnames{j},params((i-1)*NV+j,1),params((i-1)*NV+j,2),params((i-1)*NV+j,3),...
                params((i-1)*NV+j,4),params((i-1)*NV+j,5),params((i-1)*NV+j,6));
        else
            fprintf(FID,'& %s & %9.6f & %9.6f  &%9.6f & %9.6f & %9.6f  &%9.6f \\\\ \n',...
                varnames{j},params((i-1)*NV+j,1),params((i-1)*NV+j,2),params((i-1)*NV+j,3),...
                params((i-1)*NV+j,4),params((i-1)*NV+j,5),params((i-1)*NV+j,6));
        end
        if j==4
            fprintf(FID,'\\hline\n');
        end
    end
end

 
fprintf(FID, '\\end{tabular}\n');
fclose(FID);