% function [aic,bic] = ic(y)
% compute information criteria for normal fit
% INPUTS
% y     = data
% OUTPUTS
% aic   = Akaike Information Criterios
% bic   = Bayesian Information Criterion
% aicc  = AIC with small sample correction
function [aic,bic,aicc] = ic(y)

T=numel(y);
vf=mle(y);
nlogL=normlike(vf,y);
aic=4+2*nlogL;
aicc=aic+12/(T-3);
bic=2*nlogL+2*log(T);
