% Anderson-Darling  tests against t distribution with df=5
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
NM=8;

% load data
data=csvread('../data/irswap_daily_20000703_20120726.csv',1,1);
[T,N]=size(data);
dates=csvread('../data/irswap_daily_20000703_20120726.csv',1,0,[1,0,T,0]);
% last 4 years
i4=find(dates>=dates(end)-40000);
data4=data(i4,:);
T4=size(data4,1);
% last 1 year
i1=find(dates>=dates(end)-10000);
data1=data(i1,:);
T1=size(data1,1);

ADt=NaN(N,2); % one for diff, the other for rets
ADp=NaN(N,2); % storing p-values
ADt4=NaN(N,2); 
ADp4=NaN(N,2); 
ADt1=NaN(N,2); 
ADp1=NaN(N,2);

df=5;
alpha=0.0001;

for i=1:N
    sample=diff(data(:,i));
    disp(['full sample ',swap_maturity{i},' diff']);
    [h,ADt(i,1),ADp(i,1),crv0,crv1] = ad_t_test(sample,df,alpha);
    sample=diff(data(:,i))./data(1:end-1,i);
    disp(['full sample ',swap_maturity{i},' ret']);
    [h,ADt(i,2),ADp(i,2),crv0,crv1] = ad_t_test(sample,df,alpha);
    sample=diff(data4(:,i));
    disp(['4-year sample ',swap_maturity{i},' diff']);
    [h,ADt4(i,1),ADp4(i,1),crv0,crv1] = ad_t_test(sample,df,alpha);
    sample=diff(data4(:,i))./data4(1:end-1,i);
    disp(['4-year sample ',swap_maturity{i},' ret']);
    [h,ADt4(i,2),ADp4(i,2),crv0,crv1] = ad_t_test(sample,df,alpha);
    sample=diff(data1(:,i));
    disp(['1-year sample ',swap_maturity{i},' diff']);
    [h,ADt1(i,1),ADp1(i,1),crv0,crv1] = ad_t_test(sample,df,alpha);
    sample=diff(data1(:,i))./data1(1:end-1,i);
    disp(['1-year sample ',swap_maturity{i},' ret']);
    [h,ADt1(i,2),ADp1(i,2),crv0,crv1] = ad_t_test(sample,df,alpha);
end

% save results in csv files

fid=fopen('irswap_ad_t_stats.csv','w');
fprintf(fid,'%s,%s,%s,%s,%s,%s,%s\n','Swap Maturity','AD t diff full sample',...
    'AD t ret full sample','AD t diff 4y-sample','AD t ret 4y-sample',...
    'AD t diff 1y-sample','AD t diff 1y-sample');
for i=1:N
    fprintf(fid,'%s,%11.8f,%11.8f,%11.8f,%11.8f,%11.8f,%11.8f\n',...
        swap_maturity{i},ADp(i,1),ADp(i,2),ADp4(i,1),ADp4(i,2),ADp1(i,1),ADp1(i,2));
end
fclose(fid);
