% AIC  tests against t distribution with df=5
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
NM=8;

% load data
data=csvread('../data/irswap_daily_20000703_20120726.csv',1,1);
[T,N]=size(data);
dates=csvread('../data/irswap_daily_20000703_20120726.csv',1,0,[1,0,T,0]);
% last 4 years
i4=find(dates>=dates(end)-40000);
data4=data(i4,:);
T4=size(data4,1);
% last 1 year
i1=find(dates>=dates(end)-10000);
data1=data(i1,:);
T1=size(data1,1);

AICt=NaN(N,2); % one for diff, the other for rets
AICp=NaN(N,2); % storing p-values
AICt4=NaN(N,2); 
AICp4=NaN(N,2); 
AICt1=NaN(N,2); 
AICp1=NaN(N,2);

df=5;
alpha=0.0001;

for i=1:N
    sample=diff(data(:,i));
    disp(['full sample ',swap_maturity{i},' diff']);
    [h,AICt(i,1),AICp(i,1)] = ict(sample);
    sample=diff(data(:,i))./data(1:end-1,i);
    disp(['full sample ',swap_maturity{i},' ret']);
    [h,AICt(i,2),AICp(i,2)] = ict(sample);
    sample=diff(data4(:,i));
    disp(['4-year sample ',swap_maturity{i},' diff']);
    [h,AICt4(i,1),AICp4(i,1)] = ict(sample);
    sample=diff(data4(:,i))./data4(1:end-1,i);
    disp(['4-year sample ',swap_maturity{i},' ret']);
    [h,AICt4(i,2),AICp4(i,2)] = ict(sample);
    sample=diff(data1(:,i));
    disp(['1-year sample ',swap_maturity{i},' diff']);
    [h,AICt1(i,1),AICp1(i,1)] = ict(sample);
    sample=diff(data1(:,i))./data1(1:end-1,i);
    disp(['1-year sample ',swap_maturity{i},' ret']);
    [h,AICt1(i,2),AICp1(i,2)] = ict(sample);
end

% save results in csv files

fid=fopen('irswap_aict_stats.csv','w');
fprintf(fid,'%s,%s,%s,%s,%s,%s,%s\n','Swap Maturity','AIC t diff full sample',...
    'AIC t ret full sample','AIC t diff 4y-sample','AIC t ret 4y-sample',...
    'AIC t diff 1y-sample','AIC t diff 1y-sample');
for i=1:N
    fprintf(fid,'%s,%11.4f,%11.4f,%11.4f,%11.4f,%11.4f,%11.4f\n',...
        swap_maturity{i},AICp(i,1),AICp(i,2),AICp4(i,1),AICp4(i,2),AICp1(i,1),AICp1(i,2));
end
fclose(fid);