% goodness-of-fit  tests

% load data
data=csvread('../data/irswap_daily_20000703_20120726.csv',1,1);
[T,N]=size(data);
dates=csvread('../data/irswap_daily_20000703_20120726.csv',1,0,[1,0,T,0]);
% last 4 years
i4=find(dates>=dates(end)-40000);
data4=data(i4,:);
T4=size(data4,1);
% last 1 year
i1=find(dates>=dates(end)-10000);
data1=data(i1,:);
T1=size(data1,1);
names={'US IRSWAPS 1y','US IRSWAPS 2y','US IRSWAPS 3y','US IRSWAPS 4y',...
    'US IRSWAPS 5y','US IRSWAPS 7y','US IRSWAPS 10y','US IRSWAPS 30y'};

% Pearson chi-square test
Ppearson=NaN(N,2); % one for diff, other for rets
Ppearson4=NaN(N,2);
Ppearson1=NaN(N,2);
nbins=floor(2.28*T^0.4);
nbins1=floor(2.28*T1^0.4);
nbins4=floor(2.28*T4^0.4);
for i=1:N
    phat=mle(diff(data(:,i)),'distribution','tlocationscale');
    [h,Ppearson(i,1)]=chi2gof(diff(data(:,i)),'cdf',@(z) tcdf((z-phat(1))/phat(2),phat(3)),'nparams',3,'nbins',nbins);
    phat=mle(diff(data(:,i))./data(1:end-1,i),'distribution','tlocationscale');
    [h,Ppearson(i,2)]=chi2gof(diff(data(:,i))./data(1:end-1,i),'cdf',@(z) tcdf((z-phat(1))/phat(2),phat(3)),'nparams',3,'nbins',nbins);
    phat=mle(diff(data4(:,i)),'distribution','tlocationscale');
    [h,Ppearson4(i,1)]=chi2gof(diff(data4(:,i)),'cdf',@(z) tcdf((z-phat(1))/phat(2),phat(3)),'nparams',3,'nbins',nbins4);
    phat=mle(diff(data4(:,i))./data4(1:end-1,i),'distribution','tlocationscale');
    [h,Ppearson4(i,2)]=chi2gof(diff(data4(:,i))./data4(1:end-1,i),'cdf',@(z) tcdf((z-phat(1))/phat(2),phat(3)),'nparams',3,'nbins',nbins4);
     phat=mle(diff(data4(:,i)),'distribution','tlocationscale');
    [h,Ppearson1(i,1)]=chi2gof(diff(data1(:,i)),'cdf',@(z) tcdf((z-phat(1))/phat(2),phat(3)),'nparams',3,'nbins',nbins1);
    phat=mle(diff(data1(:,i))./data1(1:end-1,i),'distribution','tlocationscale');
    [h,Ppearson1(i,2)]=chi2gof(diff(data1(:,i))./data1(1:end-1,i),'cdf',@(z) tcdf((z-phat(1))/phat(2),phat(3)),'nparams',3,'nbins',nbins1);
end


% save to csv file
% save results in csv files
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
NM=8;


fid=fopen('irswap_pearson_t_stats.csv','w');
fprintf(fid,'%s,%s,%s,%s,%s,%s,%s\n','Swap Maturity','Pearson t diff full sample',...
    'Pearson t ret full sample','Pearson t diff 4y-sample','Pearson t ret 4y-sample',...
    'Pearson t diff 1y-sample','Pearson t diff 1y-sample');
for i=1:N
    fprintf(fid,'%s,%9.6f,%9.6f,%9.6f,%9.6f,%9.6f,%9.6f\n',...
        swap_maturity{i},Ppearson(i,1),Ppearson(i,2),Ppearson4(i,1),Ppearson4(i,2),Ppearson1(i,1),Ppearson1(i,2));
end
fclose(fid);

