% latex tables for Engle ARCH LM tests
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
lags={'1','2','3','4','5','10'};
forms={'Diff','Ret'};
NM=8;
NF=2;


% read in results
Lt=csvread('irswap_archlm1_stats.csv',1,2);
Ll=csvread('irswap_archlm5_stats.csv',1,2);


FID = fopen('archlm_results.tex', 'w');
fprintf(FID, '\\begin{tabular}{clrlrlrl}\\hline\n');
fprintf(FID,'\\multicolumn{8}{c}{ARCH(1)}  \\\\ \\cline{3-8}\n');
fprintf(FID,'\\multirow{2}{*}{Swap Maturity} & \\multirow{2}{*}{Form} & \\multicolumn{2}{c}{Full sample} &\\multicolumn{2}{c}{4-year sample} &\\multicolumn{2}{c}{1-year sample} \\\\ \n');
fprintf(FID,'\\cline{3-8} & & Test stat & p-value & Test stat & p-value & Test stat & p-value \\\\ \n');
fprintf(FID,'\\hline\\hline \n');
for i=1:NM
    for j=1:NF
        if j==2
            fprintf(FID,'%s & %s & %7.2f & %9.6f  &%7.2f & %9.6f & %7.2f  & %9.6f \\\\ \n',...
                swap_maturity{i},forms{j},Lt((i-1)*NF+j,1),Lt((i-1)*NF+j,2),...
                Lt((i-1)*NF+j,3),Lt((i-1)*NF+j,4),Lt((i-1)*NF+j,5),Lt((i-1)*NF+j,6));
        else
            fprintf(FID,'& %s & %7.2f & %9.6f  &%7.2f & %9.6f & %7.2f  & %9.6f \\\\ \n',...
                forms{j},Lt((i-1)*NF+j,1),Lt((i-1)*NF+j,2),...
                Lt((i-1)*NF+j,3),Lt((i-1)*NF+j,4),Lt((i-1)*NF+j,5),Lt((i-1)*NF+j,6));
        end
        if j==2
            fprintf(FID,'\\hline\n');
        end
    end
end
fprintf(FID,'\\multicolumn{8}{c}{ARCH(5)} \\\\ \n');
fprintf(FID,'\\cline{3-8}\n');
for i=1:NM
    for j=1:NF
        if j==2
            fprintf(FID,'%s & %s & %7.2f & %9.6f  &%7.2f & %9.6f & %7.2f  & %9.6f \\\\ \n',...
                swap_maturity{i},forms{j},Ll((i-1)*NF+j,1),Ll((i-1)*NF+j,2),...
                Ll((i-1)*NF+j,3),Ll((i-1)*NF+j,4),Ll((i-1)*NF+j,5),Ll((i-1)*NF+j,6));
        else
            fprintf(FID,'& %s & %7.2f & %9.6f  &%7.2f & %9.6f & %7.2f  & %9.6f \\\\ \n',...
                forms{j},Ll((i-1)*NF+j,1),Ll((i-1)*NF+j,2),...
                Ll((i-1)*NF+j,3),Ll((i-1)*NF+j,4),Ll((i-1)*NF+j,5),Ll((i-1)*NF+j,6));
        end
        if j==2
            fprintf(FID,'\\hline\n');
        end
    end
end
fprintf(FID, '\\end{tabular}\n');
fclose(FID);