% latex tables for nonparamteric Goldberg-Quandt tests
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
lags={'1','2','3','4','5','10'};
forms={'Diff','Ret'};
NM=8;
NF=2;


% read in results
Lt=csvread('irswap_GQ_time_stats.csv',1,2);
Ll=csvread('irswap_GQ_level_stats.csv',1,2);


FID = fopen('goldfeld_quandt_peaks_results.tex', 'w');
fprintf(FID, '\\begin{tabular}{clllllll}\\hline\n');
fprintf(FID,'\\multicolumn{8}{c}{Time Heteroscedasticity}  \\\\ \\cline{3-8}\n');
fprintf(FID,'\\multirow{2}{*}{Swap Maturity} & \\multirow{2}{*}{Form} & \\multicolumn{2}{c}{Full sample} &\\multicolumn{2}{c}{4-year sample} &\\multicolumn{2}{c}{1-year sample} \\\\ \n');
fprintf(FID,'\\cline{3-8} & & Peaks & p-value & Peaks & p-value & Peaks & p-value \\\\ \n');
fprintf(FID,'\\hline\\hline \n');
for i=1:NM
    for j=1:NF
        if j==2
            fprintf(FID,'%s & %s & %g & %7.4f  &%g & %7.4f & %g  & %7.4f \\\\ \n',...
                swap_maturity{i},forms{j},Lt((i-1)*NF+j,1),Lt((i-1)*NF+j,2),...
                Lt((i-1)*NF+j,3),Lt((i-1)*NF+j,4),Lt((i-1)*NF+j,5),Lt((i-1)*NF+j,6));
        else
            fprintf(FID,'& %s & %g & %7.4f  &%g & %7.4f & %g  & %7.4f \\\\ \n',...
                forms{j},Lt((i-1)*NF+j,1),Lt((i-1)*NF+j,2),...
                Lt((i-1)*NF+j,3),Lt((i-1)*NF+j,4),Lt((i-1)*NF+j,5),Lt((i-1)*NF+j,6));
        end
        if j==2
            fprintf(FID,'\\hline\n');
        end
    end
end
fprintf(FID,'\\multicolumn{8}{c}{Level Heteroscedasticity} \\\\ \n');
fprintf(FID,'\\cline{3-8}\n');
for i=1:NM
    for j=1:NF
        if j==2
            fprintf(FID,'%s & %s & %g & %7.4f  &%g & %7.4f & %g  & %7.4f \\\\ \n',...
                swap_maturity{i},forms{j},Ll((i-1)*NF+j,1),Ll((i-1)*NF+j,2),...
                Ll((i-1)*NF+j,3),Ll((i-1)*NF+j,4),Ll((i-1)*NF+j,5),Ll((i-1)*NF+j,6));
        else
            fprintf(FID,'& %s & %g & %7.4f  &%g & %7.4f & %g  & %7.4f \\\\ \n',...
                forms{j},Ll((i-1)*NF+j,1),Ll((i-1)*NF+j,2),...
                Ll((i-1)*NF+j,3),Ll((i-1)*NF+j,4),Ll((i-1)*NF+j,5),Ll((i-1)*NF+j,6));
        end
        if j==2
            fprintf(FID,'\\hline\n');
        end
    end
end
fprintf(FID, '\\end{tabular}\n');
fclose(FID);