% latex tables Cameron-Trivedi IM test decompositions
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
lags={'1','2','3','4','5','10'};
forms={'Diff','Ret'};
NM=8;
NF=2;


% read in results
Lt=csvread('irswap_imtest_level_stats.csv',1,2);


FID = fopen('imtest_results.tex', 'w');
fprintf(FID, '\\begin{tabular}{clllllllllllll}\\hline\n');
fprintf(FID,'\\multirow{2}{*}{Swap Maturity} & \\multirow{2}{*}{Form} & \\multicolumn{4}{c}{Full sample} &\\multicolumn{4}{c}{4-year sample} &\\multicolumn{4}{c}{1-year sample} \\\\ \n');
fprintf(FID,'\\cline{3-14} & & IM & $\\textrm{IM}_2$ & $\\textrm{IM}_3$ & $\\textrm{IM}_4$ & IM & $\\textrm{IM}_2$ & $\\textrm{IM}_3$ & $\\textrm{IM}_4$ & IM & $\\textrm{IM}_2$ & $\\textrm{IM}_3$ & $\\textrm{IM}_4$ \\\\ \n');
fprintf(FID,'\\hline\\hline \n');
for i=1:NM
    for j=1:NF
        if j==2
            fprintf(FID,'%s & %s & %7.2f & %7.2f  &%7.2f & %7.2f & %7.2f  & %7.2f & %7.2f & %7.2f  &%7.2f & %7.2f & %7.2f  & %7.2f \\\\ \n',...
                swap_maturity{i},forms{j},Lt((i-1)*NF+j,1),Lt((i-1)*NF+j,2),...
                Lt((i-1)*NF+j,3),Lt((i-1)*NF+j,4),Lt((i-1)*NF+j,5),Lt((i-1)*NF+j,6),...
                Lt((i-1)*NF+j,7),Lt((i-1)*NF+j,8),Lt((i-1)*NF+j,9),Lt((i-1)*NF+j,10),...
                Lt((i-1)*NF+j,11),Lt((i-1)*NF+j,12));
        else
            fprintf(FID,'& %s & %7.2f & %7.2f  &%7.2f & %7.2f & %7.2f  & %7.2f & %7.2f & %7.2f  &%7.2f & %7.2f & %7.2f  & %7.2f \\\\ \n',...
                forms{j},Lt((i-1)*NF+j,1),Lt((i-1)*NF+j,2),...
                Lt((i-1)*NF+j,3),Lt((i-1)*NF+j,4),Lt((i-1)*NF+j,5),Lt((i-1)*NF+j,6),...
                Lt((i-1)*NF+j,7),Lt((i-1)*NF+j,8),Lt((i-1)*NF+j,9),Lt((i-1)*NF+j,10),...
                Lt((i-1)*NF+j,11),Lt((i-1)*NF+j,12));
        end
        if j==2
            fprintf(FID,'\\hline\n');
        end
    end
end
fprintf(FID, '\\end{tabular}\n');
fclose(FID);