% Engle's ARCH LM test
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
Form={'Diff','Ret'};
NM=8; % number of maturities
NF=2; % number of functional representations
NS=3; % number of (sub)samples

% load data
data=csvread('../data/irswap_daily_20000703_20120726.csv',1,1);
[T,N]=size(data);
dates=csvread('../data/irswap_daily_20000703_20120726.csv',1,0,[1,0,T,0]);
% last 4 years
i4=find(dates>=dates(end)-40000);
data4=data(i4,:);
T4=size(data4,1);
% last 1 year
i1=find(dates>=dates(end)-10000);
data1=data(i1,:);
T1=size(data1,1);
Lt=NaN(NM,NF,NS);
h=Lt;
pval=NaN(NM,NF,NS);
Lt2=NaN(NM,NF,NS);
h2=Lt2;
pval2=NaN(NM,NF,NS);

% ARCH(1)
for i=1:NM
    [h(i,1,1),pval(i,1,1),Lt(i,1,1)]=archtest(diff(data(:,i))-mean(diff(data(:,i))));
    [h(i,1,2),pval(i,1,2),Lt(i,1,2)]=archtest(diff(data4(:,i))-mean(diff(data4(:,i))));
    [h(i,1,3),pval(i,1,3),Lt(i,1,3)]=archtest(diff(data1(:,i))-mean(diff(data1(:,i))));
    [h(i,2,1),pval(i,2,1),Lt(i,2,1)]=archtest(diff(data(:,i))./data(1:end-1,i)-mean((diff(data(:,i))./data(1:end-1,i))));
    [h(i,2,2),pval(i,2,2),Lt(i,2,2)]=archtest(diff(data4(:,i))./data4(1:end-1,i)-mean((diff(data(:,i))./data(1:end-1,i))));
    [h(i,2,3),pval(i,2,3),Lt(i,2,3)]=archtest(diff(data1(:,i))./data1(1:end-1,i)-mean((diff(data(:,i))./data(1:end-1,i))));
end
  
% ARCH(5)
for i=1:NM
    [h2(i,1,1),pval2(i,1,1),Lt2(i,1,1)]=archtest(diff(data(:,i))-mean(diff(data(:,i))),'lags',5);
    [h2(i,1,2),pval2(i,1,2),Lt2(i,1,2)]=archtest(diff(data4(:,i))-mean(diff(data4(:,i))),'lags',5);
    [h2(i,1,3),pval2(i,1,3),Lt2(i,1,3)]=archtest(diff(data1(:,i))-mean(diff(data4(:,i))),'lags',5);
    [h2(i,2,1),pval2(i,2,1),Lt2(i,2,1)]=archtest(diff(data(:,i))./data(1:end-1,i)-mean((diff(data(:,i))./data(1:end-1,i))),'lags',5);
    [h2(i,2,2),pval2(i,2,2),Lt2(i,2,2)]=archtest(diff(data4(:,i))./data4(1:end-1,i)-mean((diff(data4(:,i))./data4(1:end-1,i))),'lags',5);
    [h2(i,2,3),pval2(i,2,3),Lt2(i,2,3)]=archtest(diff(data1(:,i))./data1(1:end-1,i)-mean((diff(data1(:,i))./data1(1:end-1,i))),'lags',5);
end

save irswaps_archlm.mat

% save to csv files
fid=fopen('irswap_archlm1_stats.csv','w');
fprintf(fid,'%s,%s,%s,%s,%s,%s,%s,%s\n','Swap Maturity','Form',...
    'Full sample Levene statistic','Full sample p-value','4-year sample Levene statistic',...
    '4-year sample p-value','1-year sample Levene statistics',...
    '1-year sample p-value');
for i=1:NM
    for j=1:NF
        fprintf(fid,'%s,%s,%7.2f,%11.8f,%7.2f,%11.8f,%7.2f,%11.8f\n',...
            swap_maturity{i},Form{j},Lt(i,j,1),pval(i,j,1),Lt(i,j,2),pval(i,j,2),...
            Lt(i,j,3),pval(i,j,3));
    end
end
fclose(fid);


fid=fopen('irswap_archlm5_stats.csv','w');
fprintf(fid,'%s,%s,%s,%s,%s,%s,%s,%s\n','Swap Maturity','Form',...
    'Full sample Levene statistic','Full sample p-value','4-year sample Levene statistic',...
    '4-year sample p-value','1-year sample Levene statistics',...
    '1-year sample p-value');
for i=1:NM
    for j=1:NF
        fprintf(fid,'%s,%s,%7.2f,%11.8f,%7.2f,%11.8f,%7.2f,%11.8f\n',...
            swap_maturity{i},Form{j},Lt2(i,j,1),pval2(i,j,1),Lt2(i,j,2),pval2(i,j,2),...
            Lt2(i,j,3),pval2(i,j,3));
    end
end
fclose(fid);