swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
Form={'Diff','Ret'};
NM=8;
NF=2;


% load data
data=csvread('../data/irswap_daily_20000703_20120726.csv',1,1);
[T,N]=size(data);
dates=csvread('../data/irswap_daily_20000703_20120726.csv',1,0,[1,0,T,0]);
% last 4 years
i4=find(dates>=dates(end)-40000);
data4=data(i4,:);
T4=size(data4,1);
% last 1 year
i1=find(dates>=dates(end)-10000);
data1=data(i1,:);
T1=size(data1,1);

% load null distributions
cdf1=csvread('PeakTest253.csv');
cdf4=csvread('PeakTest1003.csv');
cdf_full=csvread('PeakTest3019.csv');


% TIME as scedastic variable
tv=[1:1:T-1]';
tv4=[1:1:T4-1]';
tv1=[1:1:T1-1]';
peaks_full=NaN(2,NM,2);
peaks_4y=NaN(2,NM,2);
peaks_1y=NaN(2,NM,2);
pvals_full=NaN(2,NM,2);
pvals_4y=NaN(2,NM,2);
pvals_1y=NaN(2,NM,2);
for i=1:NM
    % full sample
    % diff
    peaks_full(:,i,1)=goldfeld_quandt(diff(data(:,i)),tv);
    pvals_full(1,i,1)=min(cdf_full(peaks_full(1,i,1)+1),1-cdf_full(peaks_full(1,i,1)+1));
    pvals_full(2,i,1)=min(cdf_full(peaks_full(2,i,1)+1),1-cdf_full(peaks_full(2,i,1)+1));
    % ret
    peaks_full(:,i,2)=goldfeld_quandt(diff(data(:,i))./data(1:end-1,i),tv);
    pvals_full(1,i,2)=min(cdf_full(peaks_full(1,i,2)+1),1-cdf_full(peaks_full(1,i,2)+1));
    pvals_full(2,i,2)=min(cdf_full(peaks_full(2,i,2)+1),1-cdf_full(peaks_full(2,i,2)+1));
    % 4-year sample
    % diff
    peaks_4y(:,i,1)=goldfeld_quandt(diff(data4(:,i)),tv4);
    pvals_4y(1,i,1)=min(cdf4(peaks_4y(1,i,1)+1),1-cdf4(peaks_4y(1,i,1)+1));
    pvals_4y(2,i,1)=min(cdf4(peaks_4y(2,i,1)+1),1-cdf4(peaks_4y(2,i,1)+1));
    % ret
    peaks_4y(:,i,2)=goldfeld_quandt(diff(data4(:,i))./data4(1:end-1,i),tv4);
    pvals_4y(1,i,2)=min(cdf4(peaks_4y(1,i,2)+1),1-cdf4(peaks_4y(1,i,2)+1));
    pvals_4y(2,i,2)=min(cdf4(peaks_4y(2,i,2)+1),1-cdf4(peaks_4y(2,i,2)+1));
    % 1-year sample
    % diff
    peaks_1y(:,i,1)=goldfeld_quandt(diff(data1(:,i)),tv1);
    pvals_1y(1,i,1)=min(cdf1(peaks_1y(1,i,1)+1),1-cdf1(peaks_1y(1,i,1)+1));
    pvals_1y(2,i,1)=min(cdf1(peaks_1y(2,i,1)+1),1-cdf1(peaks_1y(2,i,1)+1));
    % ret
    peaks_1y(:,i,2)=goldfeld_quandt(diff(data1(:,i))./data1(1:end-1,i),tv1);
    pvals_1y(1,i,2)=min(cdf1(peaks_1y(1,i,2)+1),1-cdf1(peaks_1y(1,i,2)+1));
    pvals_1y(2,i,2)=min(cdf1(peaks_1y(2,i,2)+1),1-cdf1(peaks_1y(2,i,2)+1));
end
    
% Level as scedastic variable
lpeaks_full=NaN(2,NM,2);
lpeaks_4y=NaN(2,NM,2);
lpeaks_1y=NaN(2,NM,2);
lpvals_full=NaN(2,NM,2);
lpvals_4y=NaN(2,NM,2);
lpvals_1y=NaN(2,NM,2);
for i=1:NM
    % full sample
    % diff
    lpeaks_full(:,i,1)=goldfeld_quandt(diff(data(:,i)),[data(1:end-1,i)]);
    lpvals_full(1,i,1)=min(cdf_full(lpeaks_full(1,i,1)+1),1-cdf_full(lpeaks_full(1,i,1)+1));
    lpvals_full(2,i,1)=min(cdf_full(lpeaks_full(2,i,1)+1),1-cdf_full(lpeaks_full(2,i,1)+1));
    % ret
    lpeaks_full(:,i,2)=goldfeld_quandt(diff(data(:,i))./data(1:end-1,i),[data(1:end-1,i)]);
    lpvals_full(1,i,2)=min(cdf_full(lpeaks_full(1,i,2)+1),1-cdf_full(lpeaks_full(1,i,2)+1));
    lpvals_full(2,i,2)=min(cdf_full(lpeaks_full(2,i,2)+1),1-cdf_full(lpeaks_full(2,i,2)+1));
    % 4-year sample
    % diff
    lpeaks_4y(:,i,1)=goldfeld_quandt(diff(data4(:,i)),[data4(1:end-1,i)]);
    lpvals_4y(1,i,1)=min(cdf4(lpeaks_4y(1,i,1)+1),1-cdf4(lpeaks_4y(1,i,1)+1));
    lpvals_4y(2,i,1)=min(cdf4(lpeaks_4y(2,i,1)+1),1-cdf4(lpeaks_4y(2,i,1)+1));
    % ret
    lpeaks_4y(:,i,2)=goldfeld_quandt(diff(data4(:,i))./data4(1:end-1,i),[data4(1:end-1,i)]);
    lpvals_4y(1,i,2)=min(cdf4(lpeaks_4y(1,i,2)+1),1-cdf4(lpeaks_4y(1,i,2)+1));
    lpvals_4y(2,i,2)=min(cdf4(lpeaks_4y(2,i,2)+1),1-cdf4(lpeaks_4y(2,i,2)+1));
    % 1-year sample
    % diff
    lpeaks_1y(:,i,1)=goldfeld_quandt(diff(data1(:,i)),[data1(1:end-1,i)]);
    lpvals_1y(1,i,1)=min(cdf1(lpeaks_1y(1,i,1)+1),1-cdf1(lpeaks_1y(1,i,1)+1));
    lpvals_1y(2,i,1)=min(cdf1(lpeaks_1y(2,i,1)+1),1-cdf1(lpeaks_1y(2,i,1)+1));
    % ret
    lpeaks_1y(:,i,2)=goldfeld_quandt(diff(data1(:,i))./data1(1:end-1,i),[data1(1:end-1,i)]);
    lpvals_1y(1,i,2)=min(cdf1(lpeaks_1y(1,i,2)+1),1-cdf1(lpeaks_1y(1,i,2)+1));
    lpvals_1y(2,i,2)=min(cdf1(lpeaks_1y(2,i,2)+1),1-cdf1(lpeaks_1y(2,i,2)+1));
end

save irswaps_goldfeld_quandt_peaks.mat

% % save to csv files
fid=fopen('irswap_GQ_time_stats.csv','w');
fprintf(fid,'%s,%s,%s,%s,%s,%s,%s,%s\n','Swap Maturity','Form',...
    'Full sample peaks statistic','Full sample p-value','4-year sample peaks statistic',...
    '4-year sample p-value','1-year sample peaks statistics',...
    '1-year sample p-value');
for i=1:NM
    for j=1:NF
        fprintf(fid,'%s,%s,%g,%11.8f,%g,%11.8f,%g,%11.8f\n',...
            swap_maturity{i},Form{j},peaks_full(1,i,j),pvals_full(1,i,j),peaks_4y(1,i,j),pvals_4y(1,i,j),...
            peaks_1y(1,i,j),pvals_1y(1,i,j));
    end
end
fclose(fid);

% save to csv files
fid=fopen('irswap_GQ_level_stats.csv','w');
fprintf(fid,'%s,%s,%s,%s,%s,%s,%s,%s\n','Swap Maturity','Form',...
    'Full sample peaks statistic','Full sample p-value','4-year sample peaks statistic',...
    '4-year sample p-value','1-year sample peaks statistics',...
    '1-year sample p-value');
for i=1:NM
    for j=1:NF
        fprintf(fid,'%s,%s,%g,%11.8f,%g,%11.8f,%g,%11.8f\n',...
            swap_maturity{i},Form{j},lpeaks_full(1,i,j),lpvals_full(1,i,j),lpeaks_4y(1,i,j),lpvals_4y(1,i,j),...
            lpeaks_1y(1,i,j),lpvals_1y(1,i,j));
    end
end
fclose(fid);