% Information Matrix tests with Cameron-Trivedi deomposition
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
Form={'Diff','Ret'};
NM=8; % number of maturities
NF=2; % number of functional representations
NS=3; % number of (sub)samples

% load data
data=csvread('../data/irswap_daily_20000703_20120726.csv',1,1);
[T,N]=size(data);
dates=csvread('../data/irswap_daily_20000703_20120726.csv',1,0,[1,0,T,0]);
% last 4 years
i4=find(dates>=dates(end)-40000);
data4=data(i4,:);
T4=size(data4,1);
% last 1 year
i1=find(dates>=dates(end)-10000);
data1=data(i1,:);
T1=size(data1,1);
imt=NaN(NM,NF,NS);
t2=NaN(NM,NF,NS);
t3=NaN(NM,NF,NS);
t4=NaN(NM,NF,NS);
pimt=NaN(NM,NF,NS);
p2=NaN(NM,NF,NS);
p3=NaN(NM,NF,NS);
p4=NaN(NM,NF,NS);
limt=NaN(NM,NF,NS);
lt2=NaN(NM,NF,NS);
lt3=NaN(NM,NF,NS);
lt4=NaN(NM,NF,NS);
lpimt=NaN(NM,NF,NS);
lp2=NaN(NM,NF,NS);
lp3=NaN(NM,NF,NS);
lp4=NaN(NM,NF,NS);
x=ones(T-1,1);
x4=ones(T4-1,1);
x1=ones(T1-1,1);

% time tests
for i=1:NM
    [imt(i,1,1),t2(i,1,1),t3(i,1,1),t4(i,1,1),pimt(i,1,1),p2(i,1,1),p3(i,1,1),p4(i,1,1)]=imtest(diff(data(:,i)),x);
    [imt(i,1,2),t2(i,1,2),t3(i,1,2),t4(i,1,2),pimt(i,1,2),p2(i,1,2),p3(i,1,2),p4(i,1,2)]=imtest(diff(data4(:,i)),x4);
    [imt(i,1,3),t2(i,1,3),t3(i,1,3),t4(i,1,3),pimt(i,1,3),p2(i,1,3),p3(i,1,3),p4(i,1,3)]=imtest(diff(data1(:,i)),x1);
    [imt(i,2,1),t2(i,2,1),t3(i,2,1),t4(i,2,1),pimt(i,2,1),p2(i,2,1),p3(i,2,1),p4(i,2,1)]=imtest(diff(data(:,i))./data(1:end-1,i),x);
    [imt(i,2,2),t2(i,2,2),t3(i,2,2),t4(i,2,2),pimt(i,2,2),p2(i,2,2),p3(i,2,2),p4(i,2,2)]=imtest(diff(data4(:,i))./data4(1:end-1,i),x4);
    [imt(i,2,3),t2(i,2,3),t3(i,2,3),t4(i,2,3),pimt(i,2,3),p2(i,2,3),p3(i,2,3),p4(i,2,3)]=imtest(diff(data1(:,i))./data1(1:end-1,i),x1);
end
    
% level tests   
for i=1:NM
    [limt(i,1,1),lt2(i,1,1),lt3(i,1,1),lt4(i,1,1),lpimt(i,1,1),lp2(i,1,1),lp3(i,1,1),lp4(i,1,1)]=imtest(diff(data(:,i)),[x,data(1:end-1,i)]);
    [limt(i,1,2),lt2(i,1,2),lt3(i,1,2),lt4(i,1,2),lpimt(i,1,2),lp2(i,1,2),lp3(i,1,2),lp4(i,1,2)]=imtest(diff(data4(:,i)),[x4,data4(1:end-1,i)]);
    [limt(i,1,3),lt2(i,1,3),lt3(i,1,3),lt4(i,1,3),lpimt(i,1,3),lp2(i,1,3),lp3(i,1,3),lp4(i,1,3)]=imtest(diff(data1(:,i)),[x1,data1(1:end-1,i)]);
    [limt(i,2,1),lt2(i,2,1),lt3(i,2,1),lt4(i,2,1),lpimt(i,2,1),lp2(i,2,1),lp3(i,2,1),lp4(i,2,1)]=imtest(diff(data(:,i))./data(1:end-1,i),[x,data(1:end-1,i)]);
    [limt(i,2,2),lt2(i,2,2),lt3(i,2,2),lt4(i,2,2),lpimt(i,2,2),lp2(i,2,2),lp3(i,2,2),lp4(i,2,2)]=imtest(diff(data4(:,i))./data4(1:end-1,i),[x4,data4(1:end-1,i)]);
    [limt(i,2,3),lt2(i,2,3),lt3(i,2,3),lt4(i,2,3),lpimt(i,2,3),lp2(i,2,3),lp3(i,2,3),lp4(i,2,3)]=imtest(diff(data1(:,i))./data1(1:end-1,i),[x1,data1(1:end-1,i)]);
end

save irswaps_imtest.mat

% save to csv files
fid=fopen('irswap_imtest_level_stats.csv','w');
fprintf(fid,'%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s\n','Swap Maturity','Form',...
    'Full sample IM test','Full sample IM2','Full sample IM3','Full sample IM4',...
    '4-year sample IM test','4-year sample IM2','4-year sample IM3','4-year sample IM4',...
    '1-year sample IM test','1-year sample IM2','1-year sample IM3','1-year sample IM4');
for i=1:NM
    for j=1:NF
        fprintf(fid,'%s,%s,%7.2f,%7.2f,%7.2f,%7.2f,%7.2f,%7.2f,%7.2f,%7.2f,%7.2f,%7.2f,%7.2f,%7.2f\n',...
            swap_maturity{i},Form{j},limt(i,j,1),lt2(i,j,1),lt3(i,j,1),lt4(i,j,1),...
            limt(i,j,2),lt2(i,j,2),lt3(i,j,2),lt4(i,j,2),...
            limt(i,j,3),lt2(i,j,3),lt3(i,j,3),lt4(i,j,3));
    end
end
fclose(fid);
    