% compute log-likelihood function for hybrid piecewise elasticity of
% volatility model with Student t innovations
% INPUTS
% params    = vector containing the seven parameters (scale, elasticity and degrees of freedom)
% r0        = initial value
% data      = sample, purpotedly from HPEV with Student t innovations
% cens      = censoring parameter (not used)
% freq      = a vector of integer input frequences (not used)
% OUTPUTS
% L         = log-likelihood function

function L = hpev3_t_llf(params,data,cens,freq)

r0=data(1,1);
r=data(2:end);
mu=params(1);
sigmabar=exp(params(2));
gamma=params(3);
lambda=params(4);
r_l=params(5);
r_u=params(5)+exp(params(6));
nu=params(7);
L=hpev3_t_loglikelihood(r0,r,mu,sigmabar,gamma,lambda,r_l,r_u,nu);