% nice plot of a hybrid picewise CEV
% set parameters
sigma=0.05;
rlow=2.;
rup=3.0;
gamma=0.725;
lambda=1.0;
rmin=0.35;
rmax=7.0;
NR=64;
r=linspace(0,4,NR);
vol=NaN(NR,1);
% for i=1:NR
%     if r(i)<rlow
%         vol(i)=sigma*(r(i)/rlow)^gamma;
%     elseif r(i)<rup
%         vol(i)=sigma;
%     else
%         vol(i)=sigma*(1+lambda*(r(i)-rup));
%     end
% end

vol = hpev_vol(sigma,rlow,rup,lambda,gamma,r);

figure;
plot(r,vol,'r','LineWidth',2);
hold on;
xlabel('Yield, r');
ylabel('Volatility');
% drop two vertical dashed lines
l1=line([rlow,rlow],[0,sigma]);
hold on;
set(l1,'LineStyle','--');
l2=line([rup,rup],[0,sigma]);
set(l2,'LineStyle','--');
hold on;
% drop one horizontal dashed line
l3=line([0,rlow],[sigma,sigma]);
hold on;
set(l3,'LineStyle','--');
% get rid of tick labels
set(gca,'XTickLabel',[]);
set(gca,'YTickLabel',[]);
set(gca,'XTick',[]);
set(gca,'YTick',[]);
% add annotations to sigma, rlow, rup
v=axis;
text(rlow/v(2)+0.02,0.02,'r_L','Units','normalized','FontSize',14); hold on;
text(rup/v(2)+0.02,0.02,'r_U','Units','normalized','FontSize',14); hold on;
text(0.02,sigma/v(4)+0.02,'\sigma','Units','normalized','FontSize',14); hold on;
% write to file
print('-depsc2','hpev_profile.eps');
print('-djpeg','hpev_profile.jpg');
print('-dpdf','hpev_profile.pdf');
