% compute log-likelihood function for hybrid piecewise elasticity of
% volatility model with Student t innovations
% INPUTS
% params    = vector containing the seven parameters (scale, elasticity and degrees of freedom)
% r0        = initial value
% data      = sample, purpotedly from HPEV with Student t innovations
% cens      = censoring parameter (not used)
% freq      = a vector of integer input frequences (not used)
% OUTPUTS
% L         = log-likelihood function

function L = hpev_t_llf(params,data,cens,freq)

r0=data(1,1);
r=data(2:end);
theta=params(1);
kappa=params(2);
sigmabar=exp(params(3));
gamma=params(4);
lambda=params(5);
r_l=params(6);
r_u=params(6)+exp(params(7));
nu=params(8);
L=hpev_t_loglikelihood(r0,r,theta,kappa,sigmabar,gamma,lambda,r_l,r_u,nu);