% evaluate hpev volatility profile
% INPUTS
% sigma     = scale of volatility
% rlow      = upper bound on 1st CEV regime
% rup       = upper bound on 2nd CEV regime
% lambda    = slope in 3rd regime
% gamma     = elasticity in 1st regime
% r         = abscissa where volatility should be evaluated
% OUTPUTS
% vol       = value of volatility
function vol = hpev_vol(sigma,rlow,rup,lambda,gamma,r)

% regime indicators
regime1=(r<rlow);
regime2=(r>=rlow).*(r<rup);
regime3=(r>=rup);

vol=regime1.*sigma.*(r/rlow).^gamma+regime2.*sigma+regime3.*sigma.*(1+lambda.*(r-rup));