% full sample
params=csvread('irswap_hpev3t_full_stats.csv',1,2);
sigma=params(2:7:51,1);
rlow=params(3:7:52,1);
rup=params(4:7:53,1);
gamma=params(5:7:54,1);
lambda=params(6:7:55,1);
nu=params(7:7:56,1);
% 4-year sample
params4=csvread('irswap_hpev3t_sample4_stats.csv',1,2);
sigma4=params4(2:7:51,1);
rlow4=params4(3:7:52,1);
rup4=params4(4:7:53,1);
gamma4=params4(5:7:54,1);
lambda4=params4(6:7:55,1);
nu4=params4(7:7:56,1);
% 1-year sample
params1=csvread('irswap_hpev3t_sample1_stats.csv',1,2);
sigma1=params1(2:7:51,1);
rlow1=params1(3:7:52,1);
rup1=params1(4:7:53,1);
gamma1=params1(5:7:54,1);
lambda1=params1(6:7:55,1);
nu1=params1(7:7:56,1);
data=csvread('../data/irswap_daily_20000703_20120726.csv',1,1);
[T,N]=size(data);
dates=csvread('../data/irswap_daily_20000703_20120726.csv',1,0,[1,0,T,0]);
% last 4 years
i4=find(dates>=dates(end)-40000);
data4=data(i4,:);
T4=size(data4,1);
% last 1 year
i1=find(dates>=dates(end)-10000);
data1=data(i1,:);
T1=size(data1,1);
names={'US IRSWAPS 1y','US IRSWAPS 2y','US IRSWAPS 3y','US IRSWAPS 4y',...
    'US IRSWAPS 5y','US IRSWAPS 7y','US IRSWAPS 10y','US IRSWAPS 30y'};
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
sample={' (full sample)',' (4-year sample)',' (1-year sample)'};
NR=64;
vol=NaN(NR,N);
vol4=NaN(NR,N);
vol1=NaN(NR,N);
%r=linspace(min(min(data)),max(max(data)),NR)';
r=linspace(0.05,max(max(data)),NR)';
r4=r;%linspace(min(min(data4)),max(max(data4)),NR)';
r1=r;%linspace(min(min(data1)),max(max(data1)),NR)';

for i=1:N
    vol(:,i)=hpev_vol(sigma(i),rlow(i),rup(i),lambda(i),gamma(i),r);
    vol4(:,i)=hpev_vol(sigma4(i),rlow4(i),rup4(i),lambda4(i),gamma4(i),r4);
    vol1(:,i)=hpev_vol(sigma1(i),rlow1(i),rup1(i),lambda1(i),gamma1(i),r1);
    figure;
    plot(r,vol(:,i),'r','LineWidth',2);
    hold on;
    xlabel('Yield, r');
    ylabel('Volatility');
    % drop two vertical dashed lines
    l1=line([rlow(i),rlow(i)],[0,sigma(i)]);
    hold on;
    set(l1,'LineStyle','--');
    l2=line([rup(i),rup(i)],[0,sigma(i)]);
    set(l2,'LineStyle','--');
    hold on;
    % drop one horizontal dashed line
    l3=line([0,rlow(i)],[sigma(i),sigma(i)]);
    hold on;
    set(l3,'LineStyle','--');
    % add annotations to sigma, rlow, rup
    v=axis;
    title([names{i}, sample{1}]);
    text(rlow(i)/v(2)-0.06,0.02,'r_L','Units','normalized','FontSize',14); hold on;
    text(max(rup(i)/v(2)+0.02,rlow(i)/v(2)+0.08),0.02,'r_U','Units','normalized','FontSize',14); hold on;
    text(0.02,sigma(i)/v(4)+0.02,'\sigma','Units','normalized','FontSize',14); hold on;
    % write to files
    print('-depsc2',['hpev_',swap_maturity{i},'_fullsample_profile.eps']);
    print('-djpeg',['hpev_',swap_maturity{i},'_fullsample_profile.jpg']);
    print('-dpdf',['hpev_',swap_maturity{i},'_fullsample_profile.pdf']);
    
    figure;
    plot(r4,vol4(:,i),'r','LineWidth',2);
    hold on;
    xlabel('Yield, r');
    ylabel('Volatility');
    % drop two vertical dashed lines
    l1=line([rlow4(i),rlow4(i)],[0,sigma4(i)]);
    hold on;
    set(l1,'LineStyle','--');
    l2=line([rup4(i),rup4(i)],[0,sigma4(i)]);
    set(l2,'LineStyle','--');
    hold on;
    % drop one horizontal dashed line
    l3=line([0,rlow4(i)],[sigma4(i),sigma4(i)]);
    hold on;
    set(l3,'LineStyle','--');
    % add annotations to sigma, rlow, rup
    v=axis;
    title([names{i}, sample{2}]);
    text(rlow4(i)/v(2)-0.06,0.02,'r_L','Units','normalized','FontSize',14); hold on;
    text(max(rup4(i)/v(2)+0.02,rlow4(i)/v(2)+0.08),0.02,'r_U','Units','normalized','FontSize',14); hold on;
    text(0.02,sigma4(i)/v(4)+0.02,'\sigma','Units','normalized','FontSize',14); hold on;
    % write to files
    print('-depsc2',['hpev_',swap_maturity{i},'_sample4_profile.eps']);
    print('-djpeg',['hpev_',swap_maturity{i},'_sample4_profile.jpg']);
    print('-dpdf',['hpev_',swap_maturity{i},'_sample4_profile.pdf']);
    
    figure;
    plot(r1,vol1(:,i),'r','LineWidth',2);
    hold on;
    xlabel('Yield, r');
    ylabel('Volatility');
    % drop two vertical dashed lines
    l1=line([rlow1(i),rlow1(i)],[0,sigma1(i)]);
    hold on;
    set(l1,'LineStyle','--');
    l2=line([rup1(i),rup1(i)],[0,sigma1(i)]);
    set(l2,'LineStyle','--');
    hold on;
    % drop one horizontal dashed line
    l3=line([0,rlow1(i)],[sigma1(i),sigma1(i)]);
    hold on;
    set(l3,'LineStyle','--');
    % add annotations to sigma, rlow, rup
    v=axis;
    title([names{i}, sample{3}]);
    text(rlow1(i)/v(2)-0.06,0.02,'r_L','Units','normalized','FontSize',14); hold on;
    text(max(rup1(i)/v(2)+0.02,rlow1(i)/v(2)+0.08),0.02,'r_U','Units','normalized','FontSize',14); hold on;
    text(0.02,sigma1(i)/v(4)+0.02,'\sigma','Units','normalized','FontSize',14); hold on;
    % write to files
    print('-depsc2',['hpev_',swap_maturity{i},'_sample1_profile.eps']);
    print('-djpeg',['hpev_',swap_maturity{i},'_sample1_profile.jpg']);
    print('-dpdf',['hpev_',swap_maturity{i},'_sample1_profile.pdf']);

end
    