% testing simulators from hybrid piecewise elasticity of volatility model
T=1024;
r0=2.67;
r_l=2.0;
r_u=5.0;
sigmabar=0.015;
theta=2.6;
kappa=0.03;
lambda=0.05;
gamma=0.5;
nu=3.5;

[r,H] = hpev_normal_simulator(T,theta,kappa,sigmabar,gamma,lambda,r_l,r_u,r0);
[rt,Ht] = hpev_t_simulator(T,theta,kappa,sigmabar,gamma,lambda,r_l,r_u,nu,r0);
'sample volatility of normal rates'
std(diff(r))
'sample volatility of fat-tailed rates'
std(diff(rt))

figure;
subplot(2,2,1);
plot(r);axis tight;xlabel('t');ylabel('r_t');
subplot(2,2,2);
plot(H); axis tight;xlabel('t');ylabel('H_t');
subplot(2,2,3);
plot(rt);axis tight;xlabel('t');ylabel('r_t');
subplot(2,2,4);
plot(Ht);axis tight;xlabel('t');ylabel('H_t');

figure;
subplot(2,1,1);
plot(r,'b-'); hold on;
plot(rt,'r-');
axis tight;
xlabel('t');ylabel('r_t');title('Simulated Interest Rate');
subplot(2,1,2);
plot(H,'b-'); hold on;
plot(Ht,'r-');
axis tight;
xlabel('t');ylabel('H_t');title('Simulated volatility multiplier')