% test stanton estimator

% load data
data=csvread('../data/irswap_daily_20000703_20120726.csv',1,1);
[T,N]=size(data);
dates=csvread('../data/irswap_daily_20000703_20120726.csv',1,0,[1,0,T,0]);
p=NaN(N,4);
ci=NaN(2,4,N);
aic=NaN(N,1);
p4=NaN(N,4);
ci4=NaN(2,4,N);
aic4=NaN(N,1);
p1=NaN(N,4);
ci1=NaN(2,4,N);
aic1=NaN(N,1);
alpha=0.05;
% last 4 years
i4=find(dates>=dates(end)-40000);
data4=data(i4,:);
% last 1 year
i1=find(dates>=dates(end)-10000);
data1=data(i1,:);
names={'US IRSWAPS 1y','US IRSWAPS 2y','US IRSWAPS 3y','US IRSWAPS 4y',...
    'US IRSWAPS 5y','US IRSWAPS 7y','US IRSWAPS 10y','US IRSWAPS 30y'};

i=1;
[V,yv,B] = stanton(data(:,i));
[V4,yv4,B] = stanton(data4(:,i),yv,B);
[V1,yv1,B] = stanton(data1(:,i),yv,B);
figure;
plot(yv,sqrt(V),'b-'); hold on;
plot(yv4,sqrt(V4),'r-');hold on;
plot(yv1,sqrt(V1),'g-');
xlabel('Level of Interest Rate');
ylabel('Volatility');
legend('Full sample','4-year window','1-year window');