% put extended KPSS critical values into latex table
vals = csvread('critvalues_kpss_mean.csv');
sz=size(vals);

fid = fopen('kpss_critvalues.tex', 'w');
fprintf(fid,'\\begin{tabular}{rcc} \\hline\n');
fprintf(fid, '\\multirow{2}{*}{Significance Level} &  \\multicolumn{2}{c}{Critical Value} \\\\ \n');
fprintf(fid,'\\cline{2-3} & No trend & Linear trend  \\\\ \\hline\\hline \n');
for i=1:sz(1)
    fprintf(fid,'%9.6f & %7.4f & %7.4f \\\\ \n',vals(i,:));
end
fprintf(fid,'\\hline \n');
fprintf(fid, '\\end{tabular}\n');
fclose(fid);
