% kpss tests on irswap data

% load data
data=csvread('../data/irswap_daily_20000703_20120726.csv',1,1);
[T,N]=size(data);
dates=csvread('../data/irswap_daily_20000703_20120726.csv',1,0,[1,0,T,0]);
alpha=0.05;
% last 4 years
i4=find(dates>=dates(end)-40000);
data4=data(i4,:);
% last 1 year
i1=find(dates>=dates(end)-10000);
data1=data(i1,:);

NL=10; % maximum number of lags

pval=NaN(NL,2*N);
stat=NaN(NL,2*N);
pval4=NaN(NL,2*N);
stat4=NaN(NL,2*N);
pval1=NaN(NL,2*N);
stat1=NaN(NL,2*N);


for l=1:NL
    for i=1:N
        % full sample stats
        [h,pval(l,2*i-1),stat(l,2*i-1)]=kpsstest2(diff(data(:,i)),'Lags',l);
        [h,pval(l,2*i),stat(l,2*i)]=kpsstest2(diff(data(:,i))./data(1:end-1,i),'Lags',l);
        % 4-year sample stats
        [h,pval4(l,2*i-1),stat4(l,2*i-1)]=kpsstest2(diff(data4(:,i)),'Lags',l);
        [h,pval4(l,2*i),stat4(l,2*i)]=kpsstest2(diff(data4(:,i))./data4(1:end-1,i),'Lags',l);
        % 1-year sample stats
        [h,pval1(l,2*i-1),stat1(l,2*i-1)]=kpsstest2(diff(data1(:,i)),'Lags',l);
        [h,pval1(l,2*i),stat1(l,2*i)]=kpsstest2(diff(data1(:,i))./data1(1:end-1,i),'Lags',l);
    end
end

% save results
csvwrite('irswaps_kpss_pval_full.csv',pval);
csvwrite('irswaps_kpss_stat_full.csv',stat);
csvwrite('irswaps_kpss_pval_4y.csv',pval4);
csvwrite('irswaps_kpss_stat_4y.csv',stat4);
csvwrite('irswaps_kpss_pval_1y.csv',pval1);
csvwrite('irswaps_kpss_stat_1y.csv',stat1);