% latex tables for KPSS
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
lags={'1','2','3','4','5','10'};
forms={'Diff','Ret'};
N=8;
NL=7;
NF=2;
lags=[1,2,3,4,5,6,10];
optimal_lags_full=6*ones(N,NF);
optimal_lags_4y=[5,5;5,5;6,5;4,6;5,5;5,5;5,5;5,5];
optimal_lags_1y=[5,4;4,4;4,4;4,4;4,6;3,3;3,3;3,3];


% read in results
kpss_full=csvread('irswaps_kpss_pval_full.csv');
kpss_4y=csvread('irswaps_kpss_pval_4y.csv');
kpss_1y=csvread('irswaps_kpss_pval_1y.csv');

pvals_full=kpss_full(lags,:)';
pvals_4y=kpss_4y(lags,:)';
pvals_1y=kpss_1y(lags,:)';


FID = fopen('kpss_results.tex', 'w');
fprintf(FID, '\\begin{tabular}{clcccccccc}\\hline\n');
fprintf(FID,'\\multirow{2}{*}{Swap Maturity} & \\multirow{2}{*}{Form} & \\multicolumn{7}{c}{Lags} &Optimal \\\\ \n');
fprintf(FID,'\\cline{3-9} & & 1 & 2 & 3 & 4 & 5 & 6 & 10 & Lags \\\\ \n');
fprintf(FID,'\\hline\\hline \n');
fprintf(FID,'\\multicolumn{10}{c}{Full Sample}\\\\ \\hline\n');
for i=1:N
    for j=1:NF
        if j==2
            fprintf(FID,'%s & %s & %9.6f & %9.6f  &%9.6f & %9.6f & %9.6f  & %9.6f & %9.6f& %g\\\\ \n',...
                swap_maturity{i},forms{j},pvals_full((i-1)*NF+j,1),pvals_full((i-1)*NF+j,2),pvals_full((i-1)*NF+j,3),...
                pvals_full((i-1)*NF+j,4),pvals_full((i-1)*NF+j,5),pvals_full((i-1)*NF+j,6),pvals_full((i-1)*NF+j,7),optimal_lags_full(i,j));
        else
            fprintf(FID,'& %s & %9.6f & %9.6f  &%9.6f & %9.6f & %9.6f  &%9.6f &%9.6f & %g\\\\ \n',...
                forms{j},pvals_full((i-1)*NF+j,1),pvals_full((i-1)*NF+j,2),pvals_full((i-1)*NF+j,3),...
                pvals_full((i-1)*NF+j,4),pvals_full((i-1)*NF+j,5),pvals_full((i-1)*NF+j,6),pvals_full((i-1)*NF+j,7),optimal_lags_full(i,j));
        end
        if j==2
            fprintf(FID,'\\hline\n');
        end
    end
end
fprintf(FID,'\\multicolumn{10}{c}{4-year Sample}\\\\ \\hline\n');
% fprintf(FID,'\\multirow{2}{*}{Swap Maturity} & \\multirow{2}{*}{Form} & \\multicolumn{6}{c}{Lags} \\\\ \n');
% fprintf(FID,'\\cline{3-8} & & 1 & 2 & 3 & 4 & 5 & 6  \\\\ \n');
fprintf(FID,'\\hline \n');
for i=1:N
    for j=1:NF
        if j==2
            fprintf(FID,'%s & %s & %9.6f & %9.6f  &%9.6f & %9.6f & %9.6f  & %9.6f & %9.6f& %g\\\\ \n',...
                swap_maturity{i},forms{j},pvals_4y((i-1)*NF+j,1),pvals_4y((i-1)*NF+j,2),pvals_4y((i-1)*NF+j,3),...
                pvals_4y((i-1)*NF+j,4),pvals_4y((i-1)*NF+j,5),pvals_4y((i-1)*NF+j,6),pvals_4y((i-1)*NF+j,7),optimal_lags_4y(i,j));
        else
            fprintf(FID,'& %s & %9.6f & %9.6f  &%9.6f & %9.6f & %9.6f  &%9.6f & %9.6f& %g\\\\ \n',...
                forms{j},pvals_4y((i-1)*NF+j,1),pvals_4y((i-1)*NF+j,2),pvals_4y((i-1)*NF+j,3),...
                pvals_4y((i-1)*NF+j,4),pvals_4y((i-1)*NF+j,5),pvals_4y((i-1)*NF+j,6),pvals_4y((i-1)*NF+j,7),optimal_lags_4y(i,j));
        end
        if j==2
            fprintf(FID,'\\hline\n');
        end
    end
end
fprintf(FID,'\\multicolumn{10}{c}{1-year Sample}\\\\ \\hline\n');
% fprintf(FID,'\\multirow{2}{*}{Swap Maturity} & \\multirow{2}{*}{Form} & \\multicolumn{6}{c}{Lags} \\\\ \n');
% fprintf(FID,'\\cline{3-8} & & 1 & 2 & 3 & 4 & 5 & 6  \\\\ \n');
fprintf(FID,'\\hline\n');
for i=1:N
    for j=1:NF
        if j==2
            fprintf(FID,'%s & %s & %9.6f & %9.6f  &%9.6f & %9.6f & %9.6f  & %9.6f & %9.6f& %g\\\\ \n',...
                swap_maturity{i},forms{j},pvals_1y((i-1)*NF+j,1),pvals_1y((i-1)*NF+j,2),pvals_1y((i-1)*NF+j,3),...
                pvals_1y((i-1)*NF+j,4),pvals_1y((i-1)*NF+j,5),pvals_1y((i-1)*NF+j,6),pvals_1y((i-1)*NF+j,7),optimal_lags_full(i,j));
        else
            fprintf(FID,'& %s & %9.6f & %9.6f  &%9.6f & %9.6f & %9.6f  &%9.6f & %9.6f& %g\\\\ \n',...
                forms{j},pvals_1y((i-1)*NF+j,1),pvals_1y((i-1)*NF+j,2),pvals_1y((i-1)*NF+j,3),...
                pvals_1y((i-1)*NF+j,4),pvals_1y((i-1)*NF+j,5),pvals_1y((i-1)*NF+j,6),pvals_1y((i-1)*NF+j,7),optimal_lags_full(i,j));
        end
        if j==2
            fprintf(FID,'\\hline\n');
        end
    end
end 


fprintf(FID, '\\end{tabular}\n');
fclose(FID);