% compute log-likelihood function for driftless cev process with standard normal innovations
% INPUTS
% r0        = initial value
% r(1:T)    = sample, purpotedly from CEV with Student t innovations
% sigma     = scale of variance
% beta1      = arctan slope coeff in elasticity of variance
% beta2     = arctan intercept coeff in elasticity of variance
% OUTPUTS
% L         = log-likelihood function

function L = arctanvev_norm_loglik(r0,r,sigma,beta1,beta2)


alpha=2/pi*atan(beta1*r+beta2);
alpha0=2/pi*atan(beta1*r0+beta2);
% L=log(normpdf((r(1)-r0)/(sigma*r0^alpha0))/(sigma*r0^alpha0));
% L=L+sum(log(normpdf(diff(r)./(sigma.*r(1:end-1).^alpha(1:end-1)))./(sigma.*r(1:end-1).^alpha(1:end-1))));
L=log(tpdf((r(1)-r0)/(sigma*r0^alpha0),100)/(sigma*r0^alpha0));
L=L+nansum(log(tpdf(diff(r)./(sigma.*r(1:end-1).^alpha(1:end-1)),100)./(sigma.*r(1:end-1).^alpha(1:end-1))));