% compute log-likelihood function for driftless Variable Elasticity of Variance process with Student t innovations
% Elasticity of variance is given by scaled arctan: pi/2*arctan(beta*x+gamma)
% INPUTS
% params    = vector containing the three parameters (scale, elasticity and degrees of freedom)
% r0        = initial value
% data      = sample, purpotedly from CEV with Student t innovations
% cens      = censoring parameter (not used)
% freq      = a vector of integer input frequences 9not used)
% OUTPUTS
% L         = log-likelihood function

function L = arctanvevt2_loglik(params,data,cens,freq)

sigma=params(1);
beta0=params(2);
beta1=params(3);
beta2=params(4);
nu=params(5);
[T,N]=size(data);
L=0;
for i=1:N
    i0=min(find(~isnan(data(:,i))));
    r0=data(1,i0);
    if i0<T
        r=data(i0+1:end,i);   
        L=L+arctanvev2_t_loglik(r0,r,sigma,beta0,beta1,beta2,nu);
    end
end