% compute log-likelihood function for variable elasticity of
% volatility model with Student t innovations
% INPUTS
% params    = vector containing the 3 parameters (mean,log scale, elasticity parameters, degrees of freedom)
% r0        = initial value
% data      = sample, purpotedly from CEV with normal innovations
% cens      = censoring parameter (not used)
% freq      = a vector of integer input frequences 9not used)
% OUTPUTS
% L         = log-likelihood function

function L = atanvev3_t_llf(params,data,cens,freq)

r0=data(1,1);
r=data(2:end);
mu=params(1);
sigmabar=exp(params(2));
beta1=params(3);
beta2=params(4);
nu=params(5);
L=atanvev3_t_loglik(r0,r,mu,sigmabar,beta1,beta2,nu);