% compute log-likelihood function for driftless cev process with Student t innovations
% INPUTS
% r0        = initial value
% r(1:T)    = sample, purpotedly from CEV with Student t innovations
% sigma     = scale of variance
% alpha     = elasticity of variance
% nu        = degrees of freedom parameter
% OUTPUTS
% L         = log-likelihood function

function L = cev_t_loglik(r0,r,sigma,alpha,nu)

% T=size(r,1); % determine the sample size
% L=log(gamma((nu+1)/2)/gamma(nu/2)*sqrt(nu*pi*sigma*r0^alpha))-(nu+1)/2*log(1+1/nu*((r(1)-r0)^2/(2*sigma^2*r0^(2*alpha))));
% 
% for t=2:T
%     L=L+log(gamma((nu+1)/2)/gamma(nu/2)*sqrt(nu*pi*sigma*r(t-1)^alpha))-(nu+1)/2*log(1+1/nu*((r(t)-r(t-1))^2/(2*sigma^2*r(t-1)^(2*alpha))));
% end
% if nu>30
%     L = cev_normal_loglik(r0,r,sigma,alpha);
% else
    %L=log(gamma((nu+1)/2)/gamma(nu/2)*sqrt(nu*pi*sigma*r0^alpha))-(nu+1)/2*log(1+1/nu*((r(1)-r0)^2/(2*sigma^2*r0^(2*alpha))));
    L=log(tpdf((r(1)-r0)/(sigma*r0^alpha),nu)/(sigma*r0^alpha));
    if ~isnan(L)
        L=L+nansum(log(tpdf(diff(r)./(sigma.*r(1:end-1).^alpha),nu)./(sigma.*r(1:end-1).^alpha))); 
    else
        L=nansum(log(tpdf(diff(r)./(sigma.*r(1:end-1).^alpha),nu)./(sigma.*r(1:end-1).^alpha))); 
    end
% end