% compute log-likelihood function for driftless cev process with normal innovations
% INPUTS
% params    = vector containing the three parameters (scale, elasticity and degrees of freedom)
% r0        = initial value
% data      = sample, purpotedly from CEV with normal innovations
% cens      = censoring parameter (not used)
% freq      = a vector of integer input frequences 9not used)
% OUTPUTS
% L         = log-likelihood function

function L = cevt_loglik(params,data,cens,freq)

r0=data(1,1);
r=data(2:end);
sigma=params(1);
alpha=params(2);
nu=params(3);
% T=size(r,1); % determine the sample size
% L=log(gamma((nu+1)/2)/gamma(nu/2)*sqrt(nu*pi*sigma*r0^alpha))-(nu+1)/2*log(1+1/nu*((r(1)-r0)^2/(2*sigma^2*r0^(2*alpha))));
% 
% for t=2:T
%     L=L+log(gamma((nu+1)/2)/gamma(nu/2)*sqrt(nu*pi*sigma*r(t-1)^alpha))-(nu+1)/2*log(1+1/nu*((r(t)-r(t-1))^2/(2*sigma^2*r(t-1)^(2*alpha))));
% end
L=cev_t_loglik(r0,r,sigma,alpha,nu);