% variable elasticity profiles implied by posterior median estimates
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
sample={' (full sample)',' (4-year sample)','(1-year sample)'};
sample0={'_full_','_sample4_','_sample1_'};
data=csvread('../data/irswap_daily_20000703_20120726.csv',1,1);
[T,N]=size(data);
dates=csvread('../data/irswap_daily_20000703_20120726.csv',1,0,[1,0,T,0]);
NR=64;
elast=NaN(NR,N,3);
vl=NaN(NR,N,3);
r=linspace(0.05,max(max(data)),NR)';

params=csvread('irswap_atanvev3t_full_panelstats.csv',1,2);
sigma(:,1)=params(2:5:37,1);
beta1(1,1)=params(3);
beta2(1,1)=params(4);
params4=csvread('irswap_atanvev3t_sample4_panelstats.csv',1,2);
sigma(:,2)=params4(2:5:37,1);
beta1(1,2)=params4(3);
beta2(1,2)=params4(4);
params1=csvread('irswap_atanvev3t_sample1_panelstats.csv',1,2);
sigma(:,3)=params1(2:5:37,1);
beta1(1,3)=params1(3);
beta2(1,3)=params1(4);

for j=1:3
    for i=1:N
        elast(:,i,j)=3/pi*atan(beta1(1,j)+beta2(1,j)*r)+0.5;
        vl(:,i,j)=sigma(i,j)*r.^elast(:,i,j);
    end
end
        
% figures
for j=1:3
    for i=1:N
        figure;
        plot(r,elast(:,i,j),'r','LineWidth',2);
        axis([0 max(max(data)) -1 2]);
        xlabel('Swap Rate');
        ylabel('Elasticity of Volatility');
        title([swap_maturity{i},' US Interest Rate Swaps', sample{j}]);
        filename=[swap_maturity{i},sample0{j},'panel_atanvev3t_median_elasticity_profile'];
        print('-depsc2',[filename,'.eps']);
        print('-djpeg',[filename,'.jpg']);
        print('-dpdf',[filename,'.pdf']);
        
        figure;
        plot(r,vl(:,i,j),'r','LineWidth',2);
        xlabel('Swap Rate');
        ylabel('Volatility');
        title([swap_maturity{i},' US Interest Rate Swaps', sample{j}]);
        filename=[swap_maturity{i},sample0{j},'panel_atanvev3t_median_volatility_profile'];
        print('-depsc2',[filename,'.eps']);
        print('-djpeg',[filename,'.jpg']);
        print('-dpdf',[filename,'.pdf']);
    end
end