% analysis of VEV model results using posterior medians
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
sample={' (full sample)',' (4-year sample)',' (1-year sample)'};
sample1={'Full sample','4-year sample','1-year sample'};
sample0={'_full_','_sample4_','_sample1_'};
N=8;
% version without panel restrictions
beta1=NaN(N,3);
beta2=NaN(N,3);
sigma=NaN(N,3);
nu=NaN(N,3);

params=csvread('irswap_atanvev3t_full_stats.csv',1,2);
sigma(:,1)=params(2:5:37,1);
beta1(:,1)=params(3:5:38,1);
beta2(:,1)=params(4:5:39,1);
nu(:,1)=params(5:5:40,1);
params4=csvread('irswap_atanvev3t_sample4_stats.csv',1,2);
sigma(:,2)=params4(2:5:37,1);
beta1(:,2)=params4(3:5:38,1);
beta2(:,2)=params4(4:5:39,1);
nu(:,2)=params4(5:5:40,1);
params1=csvread('irswap_atanvev3t_sample1_stats.csv',1,2);
sigma(:,3)=params1(2:5:37,1);
beta1(:,3)=params1(3:5:38,1);
beta2(:,3)=params1(4:5:39,1);
nu(:,3)=params1(5:5:40,1);

figure;
plot(sigma);
legend(sample1);
set(gca,'XTickLabel',swap_maturity);
xlabel('Swap maturity');
ylabel('\sigma');
print('-depsc2','sigma_bvev.eps');
print('-djpeg','sigma_bvev.jpg');
print('-dpdf','sigma_bvev.pdf');

figure;
plot(beta1);
legend(sample1);
set(gca,'XTickLabel',swap_maturity);
xlabel('Swap maturity');
ylabel('\beta_1');
print('-depsc2','beta1_bvev.eps');
print('-djpeg','beta1_bvev.jpg');
print('-dpdf','beta1_bvev.pdf');

figure;
plot(beta2);
legend(sample1);
set(gca,'XTickLabel',swap_maturity);
xlabel('Swap maturity');
ylabel('\beta_2');
print('-depsc2','beta2_bvev.eps');
print('-djpeg','beta2_bvev.jpg');
print('-dpdf','beta2_bvev.pdf');

figure;
plot(nu);
legend(sample1);
set(gca,'XTickLabel',swap_maturity);
xlabel('Swap maturity');
ylabel('\nu');
print('-depsc2','nu_bvev.eps');
print('-djpeg','nu_bvev.jpg');
print('-dpdf','nu_bvev.pdf');

% panel version with common betas
params=csvread('irswap_atanvev3t_full_panelstats.csv',1,2);
sigma(:,1)=params(2:5:37,1);
beta1(:,1)=params(3:5:38,1);
beta2(:,1)=params(4:5:39,1);
nu(:,1)=params(5:5:40,1);
params4=csvread('irswap_atanvev3t_sample4_panelstats.csv',1,2);
sigma(:,2)=params4(2:5:37,1);
beta1(:,2)=params4(3:5:38,1);
beta2(:,2)=params4(4:5:39,1);
nu(:,2)=params4(5:5:40,1);
params1=csvread('irswap_atanvev3t_sample1_panelstats.csv',1,2);
sigma(:,3)=params1(2:5:37,1);
beta1(:,3)=params1(3:5:38,1);
beta2(:,3)=params1(4:5:39,1);
nu(:,3)=params1(5:5:40,1);

figure;
plot(sigma);
legend(sample1);
set(gca,'XTickLabel',swap_maturity);
xlabel('Swap maturity');
ylabel('\sigma');
print('-depsc2','sigma_pbvev.eps');
print('-djpeg','sigma_pbvev.jpg');
print('-dpdf','sigma_pbvev.pdf');

figure;
plot(nu);
legend(sample1);
set(gca,'XTickLabel',swap_maturity);
xlabel('Swap maturity');
ylabel('\nu');
print('-depsc2','nu_pbvev.eps');
print('-djpeg','nu_pbvev.jpg');
print('-dpdf','nu_pbvev.pdf');

figure;
plot(beta1(1,:),'b'); hold on;
plot(beta2(1,:),'r');
legend('\beta_1','\beta_2');
set(gca,'XTick',1:1:3);
set(gca,'XTickLabel',sample1);
print('-depsc2','betas_panel_bvev.eps');
print('-djpeg','betas_panel_bvev.jpg');
print('-dpdf','betas_panel_bvev.pdf');

%panel version with common betas and common df
params=csvread('irswap_atanvev3tc_full_panelstats.csv',1,2);
sigma(:,1)=params(2:5:37,1);
beta1(:,1)=params(3:5:38,1);
beta2(:,1)=params(4:5:39,1);
nu(:,1)=params(5:5:40,1);
params4=csvread('irswap_atanvev3tc_sample4_panelstats.csv',1,2);
sigma(:,2)=params4(2:5:37,1);
beta1(:,2)=params4(3:5:38,1);
beta2(:,2)=params4(4:5:39,1);
nu(:,2)=params4(5:5:40,1);
params1=csvread('irswap_atanvev3tc_sample1_panelstats.csv',1,2);
sigma(:,3)=params1(2:5:37,1);
beta1(:,3)=params1(3:5:38,1);
beta2(:,3)=params1(4:5:39,1);
nu(:,3)=params1(5:5:40,1);

figure;
plot(sigma);
legend(sample1);
set(gca,'XTickLabel',swap_maturity);
xlabel('Swap maturity');
ylabel('\sigma');
print('-depsc2','sigma_panelc_bvev.eps');
print('-djpeg','sigma_panelc_bvev.jpg');
print('-dpdf','sigma_panelc_bvev.pdf');

figure;
plot(beta1(1,:),'b'); hold on;
plot(beta2(1,:),'r');
legend('\beta_1','\beta_2');
set(gca,'XTick',1:1:3);
set(gca,'XTickLabel',sample1);
print('-depsc2','betas_panel_bvev.eps');
print('-djpeg','betas_panel_bvev.jpg');
print('-dpdf','betas_panel_bvev.pdf');

figure;
plot(nu(1,:),'r');
ylabel('\nu');
set(gca,'XTick',1:1:3)
set(gca,'XTickLabel',sample1);
print('-depsc2','nu_panelc_bvev.eps');
print('-djpeg','nu_panelc_bvev.jpg');
print('-dpdf','nu_panelc_bvev.pdf');
