% analysis of VEVSQ model results using posterior medians
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
sample={' (full sample)',' (4-year sample)',' (1-year sample)'};
sample1={'Full sample','4-year sample','1-year sample'};
sample0={'_full_','_sample4_','_sample1_'};
N=8;NV=6;
% version without panel restrictions
beta0=NaN(N,3);
beta1=NaN(N,3);
beta2=NaN(N,3);
sigma=NaN(N,3);
nu=NaN(N,3);

params=csvread('irswap_vevtsq_full_stats.csv',1,2);
sigma(:,1)=params(2:NV:N*NV-4,1);
beta0(:,1)=params(3:NV:N*NV-3,1);
beta1(:,1)=params(4:NV:N*NV-2,1);
beta2(:,1)=params(5:NV:N*NV-1,1);
nu(:,1)=params(6:NV:N*NV,1);
params4=csvread('irswap_vevtsq_sample4_stats.csv',1,2);
sigma(:,2)=params4(2:NV:N*NV-4,1);
beta0(:,2)=params4(3:NV:N*NV-3,1);
beta1(:,2)=params4(4:NV:N*NV-2,1);
beta2(:,2)=params4(5:NV:N*NV-1,1);
nu(:,2)=params4(6:NV:N*NV,1);
params1=csvread('irswap_vevtsq_sample1_stats.csv',1,2);
sigma(:,3)=params1(2:NV:N*NV-4,1);
beta0(:,3)=params1(3:NV:N*NV-3,1);
beta1(:,3)=params1(4:NV:N*NV-2,1);
beta2(:,3)=params1(5:NV:N*NV-1,1);
nu(:,3)=params1(6:NV:N*NV,1);

figure;
plot(sigma);
legend(sample1);
set(gca,'XTickLabel',swap_maturity);
xlabel('Swap maturity');
ylabel('\sigma');
print('-depsc2','sigma_bvevtsq.eps');
print('-djpeg','sigma_bvevtsq.jpg');
print('-dpdf','sigma_bvevtsq.pdf');

figure;
plot(beta0);
legend(sample1);
set(gca,'XTickLabel',swap_maturity);
xlabel('Swap maturity');
ylabel('\beta_0');
print('-depsc2','beta0_bvevtsq.eps');
print('-djpeg','beta0_bvevtsq.jpg');
print('-dpdf','beta0_bvevtsq.pdf');

figure;
plot(beta1);
legend(sample1);
set(gca,'XTickLabel',swap_maturity);
xlabel('Swap maturity');
ylabel('\beta_1');
print('-depsc2','beta1_bvevtsq.eps');
print('-djpeg','beta1_bvevtsq.jpg');
print('-dpdf','beta1_bvevtsq.pdf');

figure;
plot(beta2);
legend(sample1);
set(gca,'XTickLabel',swap_maturity);
xlabel('Swap maturity');
ylabel('\beta_2');
print('-depsc2','beta2_bvevtsq.eps');
print('-djpeg','beta2_bvevtsq.jpg');
print('-dpdf','beta2_bvevtsq.pdf');

figure;
plot(nu);
legend(sample1);
set(gca,'XTickLabel',swap_maturity);
xlabel('Swap maturity');
ylabel('\nu');
print('-depsc2','nu_bvevtsq.eps');
print('-djpeg','nu_bvevtsq.jpg');
print('-dpdf','nu_bvevtsq.pdf');

% panel version with common betas
params=csvread('irswap_vevtsq_full_panelstats.csv',1,2);
params4=csvread('irswap_vevtsq_sample4_panelstats.csv',1,2);
params1=csvread('irswap_vevtsq_sample1_panelstats.csv',1,2);
beta0(:,1)=params(3:NV:N*NV-3,1);
beta1(:,1)=params(4:NV:N*NV-2,1);
beta2(:,1)=params(5:NV:N*NV-1,1);
nu(:,1)=params(6:NV:N*NV,1);
sigma(:,2)=params4(2:NV:N*NV-4,1);
beta0(:,2)=params4(3:NV:N*NV-3,1);
beta1(:,2)=params4(4:NV:N*NV-2,1);
beta2(:,2)=params4(5:NV:N*NV-1,1);
nu(:,2)=params4(6:NV:N*NV,1);
sigma(:,3)=params1(2:NV:N*NV-4,1);
beta0(:,3)=params1(3:NV:N*NV-3,1);
beta1(:,3)=params1(4:NV:N*NV-2,1);
beta2(:,3)=params1(5:NV:N*NV-1,1);
nu(:,3)=params1(6:NV:N*NV,1);


figure;
plot(sigma);
legend(sample1);
set(gca,'XTickLabel',swap_maturity);
xlabel('Swap maturity');
ylabel('\sigma');
print('-depsc2','sigma_pbvevtsq.eps');
print('-djpeg','sigma_pbvevtsq.jpg');
print('-dpdf','sigma_pbvevtsq.pdf');

figure;
plot(nu);
legend(sample1);
set(gca,'XTickLabel',swap_maturity);
xlabel('Swap maturity');
ylabel('\nu');
print('-depsc2','nu_pbvevtsq.eps');
print('-djpeg','nu_pbvevtsq.jpg');
print('-dpdf','nu_pbvevtsq.pdf');

figure;
plot(beta0(1,:),'b'); hold on;
plot(beta1(1,:),'r'); hold on;
plot(beta2(1,:),'g'); hold on
legend('\beta_0','\beta_1','\beta_2');
set(gca,'XTick',1:1:3);
set(gca,'XTickLabel',sample1);
print('-depsc2','betas_panel_bvevtsq.eps');
print('-djpeg','betas_panel_bvevtsq.jpg');
print('-dpdf','betas_panel_bvevtsq.pdf');

