% process results of Bayesian Variable Elasticity of Volatility model
% with quadratic ealsticity function

% load data
data=csvread('../data/irswap_daily_20000703_20120726.csv',1,1);
[T,N]=size(data);
dates=csvread('../data/irswap_daily_20000703_20120726.csv',1,0,[1,0,T,0]);
% last 4 years
i4=find(dates>=dates(end)-40000);
data4=data(i4,:);
T4=size(data4,1);
% last 1 year
i1=find(dates>=dates(end)-10000);
data1=data(i1,:);
T1=size(data1,1);
names={'US IRSWAPS 1y','US IRSWAPS 2y','US IRSWAPS 3y','US IRSWAPS 4y',...
    'US IRSWAPS 5y','US IRSWAPS 7y','US IRSWAPS 10y','US IRSWAPS 30y'};
TTT=T;
years=floor(dates/10000);
months=floor((dates-years*10000)/100);
days=(dates-years*10000-months*100);
T0=floor(TTT/7);
label_indices=1:T0:TTT;
N0=numel(label_indices);
date_label={};
for i=1:N0
    date_label{i}=[num2str(years(label_indices(i))),'.',num2str(months(label_indices(i))),'.',num2str(days(label_indices(i)))];
end

%% results using full sample

% load saved samples of parameters
d=load('mu_vevtsq_full_1y_chain1.txt');
mu_sample1y=d(:,2);
d=load('mu_vevtsq_full_2y_chain1.txt');
mu_sample2y=d(:,2);
d=load('mu_vevtsq_full_3y_chain1.txt');
mu_sample3y=d(:,2);
d=load('mu_vevtsq_full_4y_chain1.txt');
mu_sample4y=d(:,2);
d=load('mu_vevtsq_full_5y_chain1.txt');
mu_sample5y=d(:,2);
d=load('mu_vevtsq_full_7y_chain1.txt');
mu_sample7y=d(:,2);
d=load('mu_vevtsq_full_10y_chain1.txt');
mu_sample10y=d(:,2);
d=load('mu_vevtsq_full_30y_chain1.txt');
mu_sample30y=d(:,2);

d=load('sigma_vevtsq_full_1y_chain1.txt');
sigma_sample1y=d(:,2);
d=load('sigma_vevtsq_full_2y_chain1.txt');
sigma_sample2y=d(:,2);
d=load('sigma_vevtsq_full_3y_chain1.txt');
sigma_sample3y=d(:,2);
d=load('sigma_vevtsq_full_4y_chain1.txt');
sigma_sample4y=d(:,2);
d=load('sigma_vevtsq_full_5y_chain1.txt');
sigma_sample5y=d(:,2);
d=load('sigma_vevtsq_full_7y_chain1.txt');
sigma_sample7y=d(:,2);
d=load('sigma_vevtsq_full_10y_chain1.txt');
sigma_sample10y=d(:,2);
d=load('sigma_vevtsq_full_30y_chain1.txt');
sigma_sample30y=d(:,2);

d=load('beta0_vevtsq_full_1y_chain1.txt');
beta0_sample1y=d(:,2);
d=load('beta0_vevtsq_full_2y_chain1.txt');
beta0_sample2y=d(:,2);
d=load('beta0_vevtsq_full_3y_chain1.txt');
beta0_sample3y=d(:,2);
d=load('beta0_vevtsq_full_4y_chain1.txt');
beta0_sample4y=d(:,2);
d=load('beta0_vevtsq_full_5y_chain1.txt');
beta0_sample5y=d(:,2);
d=load('beta0_vevtsq_full_7y_chain1.txt');
beta0_sample7y=d(:,2);
d=load('beta0_vevtsq_full_10y_chain1.txt');
beta0_sample10y=d(:,2);
d=load('beta0_vevtsq_full_30y_chain1.txt');
beta0_sample30y=d(:,2);

d=load('beta1_vevtsq_full_1y_chain1.txt');
beta1_sample1y=d(:,2);
d=load('beta1_vevtsq_full_2y_chain1.txt');
beta1_sample2y=d(:,2);
d=load('beta1_vevtsq_full_3y_chain1.txt');
beta1_sample3y=d(:,2);
d=load('beta1_vevtsq_full_4y_chain1.txt');
beta1_sample4y=d(:,2);
d=load('beta1_vevtsq_full_5y_chain1.txt');
beta1_sample5y=d(:,2);
d=load('beta1_vevtsq_full_7y_chain1.txt');
beta1_sample7y=d(:,2);
d=load('beta1_vevtsq_full_10y_chain1.txt');
beta1_sample10y=d(:,2);
d=load('beta1_vevtsq_full_30y_chain1.txt');
beta1_sample30y=d(:,2);

d=load('beta2_vevtsq_full_1y_chain1.txt');
beta2_sample1y=d(:,2);
d=load('beta2_vevtsq_full_2y_chain1.txt');
beta2_sample2y=d(:,2);
d=load('beta2_vevtsq_full_3y_chain1.txt');
beta2_sample3y=d(:,2);
d=load('beta2_vevtsq_full_4y_chain1.txt');
beta2_sample4y=d(:,2);
d=load('beta2_vevtsq_full_5y_chain1.txt');
beta2_sample5y=d(:,2);
d=load('beta2_vevtsq_full_7y_chain1.txt');
beta2_sample7y=d(:,2);
d=load('beta2_vevtsq_full_10y_chain1.txt');
beta2_sample10y=d(:,2);
d=load('beta2_vevtsq_full_30y_chain1.txt');
beta2_sample30y=d(:,2);

d=load('nu_vevtsq_full_1y_chain1.txt');
nu_sample1y=d(:,2);
d=load('nu_vevtsq_full_2y_chain1.txt');
nu_sample2y=d(:,2);
d=load('nu_vevtsq_full_3y_chain1.txt');
nu_sample3y=d(:,2);
d=load('nu_vevtsq_full_4y_chain1.txt');
nu_sample4y=d(:,2);
d=load('nu_vevtsq_full_5y_chain1.txt');
nu_sample5y=d(:,2);
d=load('nu_vevtsq_full_7y_chain1.txt');
nu_sample7y=d(:,2);
d=load('nu_vevtsq_full_10y_chain1.txt');
nu_sample10y=d(:,2);
d=load('nu_vevtsq_full_30y_chain1.txt');
nu_sample30y=d(:,2);



% compute some simple statistics
mean_mu=mean([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);
median_mu=median([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);
p025_mu=prctile([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y],2.5);
p975_mu=prctile([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y],97.5);
std_mu=std([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);

mean_sigma=mean([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
median_sigma=median([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
p025_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],2.5);
p975_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],97.5);
std_sigma=std([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);

mean_beta0=mean([beta0_sample1y,beta0_sample2y,beta0_sample3y,beta0_sample4y,...
    beta0_sample5y,beta0_sample7y,beta0_sample10y,beta0_sample30y]);
median_beta0=median([beta0_sample1y,beta0_sample2y,beta0_sample3y,beta0_sample4y,...
    beta0_sample5y,beta0_sample7y,beta0_sample10y,beta0_sample30y]);
p025_beta0=prctile([beta0_sample1y,beta0_sample2y,beta0_sample3y,beta0_sample4y,...
    beta0_sample5y,beta0_sample7y,beta0_sample10y,beta0_sample30y],2.5);
p975_beta0=prctile([beta0_sample1y,beta0_sample2y,beta0_sample3y,beta0_sample4y,...
    beta0_sample5y,beta0_sample7y,beta0_sample10y,beta0_sample30y],97.5);
std_beta0=std([beta0_sample1y,beta0_sample2y,beta0_sample3y,beta0_sample4y,...
    beta0_sample5y,beta0_sample7y,beta0_sample10y,beta0_sample30y]);

mean_beta1=mean([beta1_sample1y,beta1_sample2y,beta1_sample3y,beta1_sample4y,...
    beta1_sample5y,beta1_sample7y,beta1_sample10y,beta1_sample30y]);
median_beta1=median([beta1_sample1y,beta1_sample2y,beta1_sample3y,beta1_sample4y,...
    beta1_sample5y,beta1_sample7y,beta1_sample10y,beta1_sample30y]);
p025_beta1=prctile([beta1_sample1y,beta1_sample2y,beta1_sample3y,beta1_sample4y,...
    beta1_sample5y,beta1_sample7y,beta1_sample10y,beta1_sample30y],2.5);
p975_beta1=prctile([beta1_sample1y,beta1_sample2y,beta1_sample3y,beta1_sample4y,...
    beta1_sample5y,beta1_sample7y,beta1_sample10y,beta1_sample30y],97.5);
std_beta1=std([beta1_sample1y,beta1_sample2y,beta1_sample3y,beta1_sample4y,...
    beta1_sample5y,beta1_sample7y,beta1_sample10y,beta1_sample30y]);

mean_beta2=mean([beta2_sample1y,beta2_sample2y,beta2_sample3y,beta2_sample4y,...
    beta2_sample5y,beta2_sample7y,beta2_sample10y,beta2_sample30y]);
median_beta2=median([beta2_sample1y,beta2_sample2y,beta2_sample3y,beta2_sample4y,...
    beta2_sample5y,beta2_sample7y,beta2_sample10y,beta2_sample30y]);
p025_beta2=prctile([beta2_sample1y,beta2_sample2y,beta2_sample3y,beta2_sample4y,...
    beta2_sample5y,beta2_sample7y,beta2_sample10y,beta2_sample30y],2.5);
p975_beta2=prctile([beta2_sample1y,beta2_sample2y,beta2_sample3y,beta2_sample4y,...
    beta2_sample5y,beta2_sample7y,beta2_sample10y,beta2_sample30y],97.5);
std_beta2=std([beta2_sample1y,beta2_sample2y,beta2_sample3y,beta2_sample4y,...
    beta2_sample5y,beta2_sample7y,beta2_sample10y,beta2_sample30y]);

mean_nu=mean([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
median_nu=median([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
p025_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],2.5);
p975_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],97.5);
std_nu=std([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);

medians=[median_mu;median_sigma;median_beta0;median_beta1;median_beta2;median_nu];
p025=[p025_mu;p025_sigma;p025_beta0;p025_beta1;p025_beta2;p025_nu];
p975=[p975_mu;p975_sigma;p975_beta0;p975_beta1;p975_beta2;p975_nu];
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
pname={'mu','sigma','beta0','beta1','beta2','nu'};
NM=8;
NV=6;

% save posterior medians and posterior 95% confidence intervals into a file
fid=fopen('irswap_vevtsq_full_stats.csv','w');
fprintf(fid,'%s,%s,%s,%s,%s\n','Swap Maturity','Parameter','Posterior Median',...
    'Posterior 2.5th percentile','Posterior 97.5th percentile');
for i=1:NM
    for j=1:NV
        fprintf(fid,'%s,%s,%7.4f,%7.4f,%7.4f\n',swap_maturity{i},pname{j},...
            medians(j,i),p025(j,i),p975(j,i));
    end
end
fclose(fid);

% kernel-smoothed density plots of posterior marginal densities
NK=100;
samples=NaN(NMC,NV,NM);
samples(:,:,1)=[mu_sample1y,sigma_sample1y,beta0_sample1y,beta1_sample1y,beta2_sample1y,nu_sample1y];
samples(:,:,2)=[mu_sample2y,sigma_sample2y,beta0_sample2y,beta1_sample2y,beta2_sample2y,nu_sample2y];
samples(:,:,3)=[mu_sample3y,sigma_sample3y,beta0_sample3y,beta1_sample3y,beta2_sample3y,nu_sample3y];
samples(:,:,4)=[mu_sample4y,sigma_sample4y,beta0_sample4y,beta1_sample4y,beta2_sample4y,nu_sample4y];
samples(:,:,5)=[mu_sample5y,sigma_sample5y,beta0_sample5y,beta1_sample5y,beta2_sample5y,nu_sample5y];
samples(:,:,6)=[mu_sample7y,sigma_sample7y,beta0_sample7y,beta1_sample7y,beta2_sample7y,nu_sample7y];
samples(:,:,7)=[mu_sample10y,sigma_sample10y,beta0_sample10y,beta1_sample10y,beta2_sample10y,nu_sample10y];
samples(:,:,8)=[mu_sample30y,sigma_sample30y,beta0_sample30y,beta1_sample30y,beta2_sample30y,nu_sample30y];

ksd=NaN(NV,NK,NM);
xsd=NaN(NV,NK,NM);

% all maturity-dependent densities
for i=1:NM
    for j=1:NV
        lb=prctile(samples(:,j,i),2.5);
        ub=prctile(samples(:,j,i),97.5);
        il=find(samples(:,j,i)>lb);
        gsample=samples(il,j,i);
        iu=find(gsample<ub);
        fsample=gsample(iu);
        if j<2
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','unbounded');
        elseif j<3
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','positive');
        elseif j<6
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','unbounded');
        else
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support',[1.99,130.1]);
        end
        figure;
        plot(xsd(j,:,i),ksd(j,:,i),'r-','LineWidth',2);
        xlabel(pname{j});
        ylabel('Marginal Posterior Density');
        title([swap_maturity{i},'US Interest Rate Swaps (full sample)']);
        filename=[pname{j},'_',swap_maturity{i},'_full_ksd_vevtsq'];
        print('-depsc2',[filename,'.eps']);
        print('-djpeg',[filename,'.jpg']);
        print('-dpdf',[filename,'.pdf']);
    end
end



% plot of posterior median elasticity of volatility over time
co=[0,0,1;  0,0.5,0; 1,0,0; 0,0.75,0.75;   0.75,0,0.75; 0.75,0.75,0; 0.25,0.25,0.25;0.31,0.4,0.58];

figure;
for i=1:NM-1
    plot(median_beta0(i)+median_beta1(i)*data(:,i)+median_beta2(i)*data(:,i).^2,'Color',co(i,:)); hold on;
end
plot(median_beta0(i)+median_beta1(i)*data(:,i)+median_beta2(i)*data(:,i).^2,'Color',[0.31,0.4,0.58]);hold on;
axis tight;
set(gca,'XTick',label_indices);
set(gca,'XTickLabel',date_label);
xticklabel_rotate([],60,[]);
legend('1y','2y','3y','4y','5y','7y','10y','30y');
xlabel('Date');
ylabel('Median elasticity of volatility');
print('-depsc2','gammamedians_full_vevtsq.eps');
print('-djpeg','gammamedians_full_vevtsq.jpg');
print('-dpdf','gammamedians_full_vevtsq.pdf');

% save data to mat file
save irswap_vevtsq_fullsample_postprocess.mat

%% 4-year subsample
% load saved samples of parameters
d=load('mu_vevtsq_sample4_1y_chain1.txt');
mu_sample1y=d(:,2);
d=load('mu_vevtsq_sample4_2y_chain1.txt');
mu_sample2y=d(:,2);
d=load('mu_vevtsq_sample4_3y_chain1.txt');
mu_sample3y=d(:,2);
d=load('mu_vevtsq_sample4_4y_chain1.txt');
mu_sample4y=d(:,2);
d=load('mu_vevtsq_sample4_5y_chain1.txt');
mu_sample5y=d(:,2);
d=load('mu_vevtsq_sample4_7y_chain1.txt');
mu_sample7y=d(:,2);
d=load('mu_vevtsq_sample4_10y_chain1.txt');
mu_sample10y=d(:,2);
d=load('mu_vevtsq_sample4_30y_chain1.txt');
mu_sample30y=d(:,2);

d=load('sigma_vevtsq_sample4_1y_chain1.txt');
sigma_sample1y=d(:,2);
d=load('sigma_vevtsq_sample4_2y_chain1.txt');
sigma_sample2y=d(:,2);
d=load('sigma_vevtsq_sample4_3y_chain1.txt');
sigma_sample3y=d(:,2);
d=load('sigma_vevtsq_sample4_4y_chain1.txt');
sigma_sample4y=d(:,2);
d=load('sigma_vevtsq_sample4_5y_chain1.txt');
sigma_sample5y=d(:,2);
d=load('sigma_vevtsq_sample4_7y_chain1.txt');
sigma_sample7y=d(:,2);
d=load('sigma_vevtsq_sample4_10y_chain1.txt');
sigma_sample10y=d(:,2);
d=load('sigma_vevtsq_sample4_30y_chain1.txt');
sigma_sample30y=d(:,2);

d=load('beta0_vevtsq_sample4_1y_chain1.txt');
beta0_sample1y=d(:,2);
d=load('beta0_vevtsq_sample4_2y_chain1.txt');
beta0_sample2y=d(:,2);
d=load('beta0_vevtsq_sample4_3y_chain1.txt');
beta0_sample3y=d(:,2);
d=load('beta0_vevtsq_sample4_4y_chain1.txt');
beta0_sample4y=d(:,2);
d=load('beta0_vevtsq_sample4_5y_chain1.txt');
beta0_sample5y=d(:,2);
d=load('beta0_vevtsq_sample4_7y_chain1.txt');
beta0_sample7y=d(:,2);
d=load('beta0_vevtsq_sample4_10y_chain1.txt');
beta0_sample10y=d(:,2);
d=load('beta0_vevtsq_sample4_30y_chain1.txt');
beta0_sample30y=d(:,2);

d=load('beta1_vevtsq_sample4_1y_chain1.txt');
beta1_sample1y=d(:,2);
d=load('beta1_vevtsq_sample4_2y_chain1.txt');
beta1_sample2y=d(:,2);
d=load('beta1_vevtsq_sample4_3y_chain1.txt');
beta1_sample3y=d(:,2);
d=load('beta1_vevtsq_sample4_4y_chain1.txt');
beta1_sample4y=d(:,2);
d=load('beta1_vevtsq_sample4_5y_chain1.txt');
beta1_sample5y=d(:,2);
d=load('beta1_vevtsq_sample4_7y_chain1.txt');
beta1_sample7y=d(:,2);
d=load('beta1_vevtsq_sample4_10y_chain1.txt');
beta1_sample10y=d(:,2);
d=load('beta1_vevtsq_sample4_30y_chain1.txt');
beta1_sample30y=d(:,2);

d=load('beta2_vevtsq_sample4_1y_chain1.txt');
beta2_sample1y=d(:,2);
d=load('beta2_vevtsq_sample4_2y_chain1.txt');
beta2_sample2y=d(:,2);
d=load('beta2_vevtsq_sample4_3y_chain1.txt');
beta2_sample3y=d(:,2);
d=load('beta2_vevtsq_sample4_4y_chain1.txt');
beta2_sample4y=d(:,2);
d=load('beta2_vevtsq_sample4_5y_chain1.txt');
beta2_sample5y=d(:,2);
d=load('beta2_vevtsq_sample4_7y_chain1.txt');
beta2_sample7y=d(:,2);
d=load('beta2_vevtsq_sample4_10y_chain1.txt');
beta2_sample10y=d(:,2);
d=load('beta2_vevtsq_sample4_30y_chain1.txt');
beta2_sample30y=d(:,2);

d=load('nu_vevtsq_sample4_1y_chain1.txt');
nu_sample1y=d(:,2);
d=load('nu_vevtsq_sample4_2y_chain1.txt');
nu_sample2y=d(:,2);
d=load('nu_vevtsq_sample4_3y_chain1.txt');
nu_sample3y=d(:,2);
d=load('nu_vevtsq_sample4_4y_chain1.txt');
nu_sample4y=d(:,2);
d=load('nu_vevtsq_sample4_5y_chain1.txt');
nu_sample5y=d(:,2);
d=load('nu_vevtsq_sample4_7y_chain1.txt');
nu_sample7y=d(:,2);
d=load('nu_vevtsq_sample4_10y_chain1.txt');
nu_sample10y=d(:,2);
d=load('nu_vevtsq_sample4_30y_chain1.txt');
nu_sample30y=d(:,2);


% compute some simple statistics
mean_mu=mean([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);
median_mu=median([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);
p025_mu=prctile([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y],2.5);
p975_mu=prctile([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y],97.5);
std_mu=std([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);

mean_sigma=mean([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
median_sigma=median([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
p025_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],2.5);
p975_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],97.5);
std_sigma=std([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);

mean_beta0=mean([beta0_sample1y,beta0_sample2y,beta0_sample3y,beta0_sample4y,...
    beta0_sample5y,beta0_sample7y,beta0_sample10y,beta0_sample30y]);
median_beta0=median([beta0_sample1y,beta0_sample2y,beta0_sample3y,beta0_sample4y,...
    beta0_sample5y,beta0_sample7y,beta0_sample10y,beta0_sample30y]);
p025_beta0=prctile([beta0_sample1y,beta0_sample2y,beta0_sample3y,beta0_sample4y,...
    beta0_sample5y,beta0_sample7y,beta0_sample10y,beta0_sample30y],2.5);
p975_beta0=prctile([beta0_sample1y,beta0_sample2y,beta0_sample3y,beta0_sample4y,...
    beta0_sample5y,beta0_sample7y,beta0_sample10y,beta0_sample30y],97.5);
std_beta0=std([beta0_sample1y,beta0_sample2y,beta0_sample3y,beta0_sample4y,...
    beta0_sample5y,beta0_sample7y,beta0_sample10y,beta0_sample30y]);

mean_beta1=mean([beta1_sample1y,beta1_sample2y,beta1_sample3y,beta1_sample4y,...
    beta1_sample5y,beta1_sample7y,beta1_sample10y,beta1_sample30y]);
median_beta1=median([beta1_sample1y,beta1_sample2y,beta1_sample3y,beta1_sample4y,...
    beta1_sample5y,beta1_sample7y,beta1_sample10y,beta1_sample30y]);
p025_beta1=prctile([beta1_sample1y,beta1_sample2y,beta1_sample3y,beta1_sample4y,...
    beta1_sample5y,beta1_sample7y,beta1_sample10y,beta1_sample30y],2.5);
p975_beta1=prctile([beta1_sample1y,beta1_sample2y,beta1_sample3y,beta1_sample4y,...
    beta1_sample5y,beta1_sample7y,beta1_sample10y,beta1_sample30y],97.5);
std_beta1=std([beta1_sample1y,beta1_sample2y,beta1_sample3y,beta1_sample4y,...
    beta1_sample5y,beta1_sample7y,beta1_sample10y,beta1_sample30y]);

mean_beta2=mean([beta2_sample1y,beta2_sample2y,beta2_sample3y,beta2_sample4y,...
    beta2_sample5y,beta2_sample7y,beta2_sample10y,beta2_sample30y]);
median_beta2=median([beta2_sample1y,beta2_sample2y,beta2_sample3y,beta2_sample4y,...
    beta2_sample5y,beta2_sample7y,beta2_sample10y,beta2_sample30y]);
p025_beta2=prctile([beta2_sample1y,beta2_sample2y,beta2_sample3y,beta2_sample4y,...
    beta2_sample5y,beta2_sample7y,beta2_sample10y,beta2_sample30y],2.5);
p975_beta2=prctile([beta2_sample1y,beta2_sample2y,beta2_sample3y,beta2_sample4y,...
    beta2_sample5y,beta2_sample7y,beta2_sample10y,beta2_sample30y],97.5);
std_beta2=std([beta2_sample1y,beta2_sample2y,beta2_sample3y,beta2_sample4y,...
    beta2_sample5y,beta2_sample7y,beta2_sample10y,beta2_sample30y]);

mean_nu=mean([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
median_nu=median([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
p025_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],2.5);
p975_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],97.5);
std_nu=std([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);

medians=[median_mu;median_sigma;median_beta0;median_beta1;median_beta2;median_nu];
p025=[p025_mu;p025_sigma;p025_beta0;p025_beta1;p025_beta2;p025_nu];
p975=[p975_mu;p975_sigma;p975_beta0;p975_beta1;p975_beta2;p975_nu];
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
pname={'mu','sigma','beta0','beta1','beta2','nu'};

% save posterior medians and posterior 95% confidence intervals into a file
fid=fopen('irswap_vevtsq_sample4_stats.csv','w');
fprintf(fid,'%s,%s,%s,%s,%s\n','Swap Maturity','Parameter','Posterior Median',...
    'Posterior 2.5th percentile','Posterior 97.5th percentile');
for i=1:NM
    for j=1:NV
        fprintf(fid,'%s,%s,%7.4f,%7.4f,%7.4f\n',swap_maturity{i},pname{j},...
            medians(j,i),p025(j,i),p975(j,i));
    end
end
fclose(fid);

samples=NaN(NMC,NV,NM);
samples(:,:,1)=[mu_sample1y,sigma_sample1y,beta0_sample1y,beta1_sample1y,beta2_sample1y,nu_sample1y];
samples(:,:,2)=[mu_sample2y,sigma_sample2y,beta0_sample2y,beta1_sample2y,beta2_sample2y,nu_sample2y];
samples(:,:,3)=[mu_sample3y,sigma_sample3y,beta0_sample3y,beta1_sample3y,beta2_sample3y,nu_sample3y];
samples(:,:,4)=[mu_sample4y,sigma_sample4y,beta0_sample4y,beta1_sample4y,beta2_sample4y,nu_sample4y];
samples(:,:,5)=[mu_sample5y,sigma_sample5y,beta0_sample5y,beta1_sample5y,beta2_sample5y,nu_sample5y];
samples(:,:,6)=[mu_sample7y,sigma_sample7y,beta0_sample7y,beta1_sample7y,beta2_sample7y,nu_sample7y];
samples(:,:,7)=[mu_sample10y,sigma_sample10y,beta0_sample10y,beta1_sample10y,beta2_sample10y,nu_sample10y];
samples(:,:,8)=[mu_sample30y,sigma_sample30y,beta0_sample30y,beta1_sample30y,beta2_sample30y,nu_sample30y];

ksd=NaN(NV,NK,NM);
xsd=NaN(NV,NK,NM);

% all maturity-dependent densities
for i=1:NM
    for j=1:NV
        lb=prctile(samples(:,j,i),2.5);
        ub=prctile(samples(:,j,i),97.5);
        il=find(samples(:,j,i)>lb);
        gsample=samples(il,j,i);
        iu=find(gsample<ub);
        fsample=gsample(iu);
        if j<2
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','unbounded');
        elseif j<3
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','positive');
        elseif j<6
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','unbounded');
        else
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support',[1.99,130.01]);
        end
        figure;
        plot(xsd(j,:,i),ksd(j,:,i),'r-','LineWidth',2);
        xlabel(pname{j});
        ylabel('Marginal Posterior Density');
        title([swap_maturity{i},' US Interest Rate Swaps (4-year sample)']);
        filename=[pname{j},'_',swap_maturity{i},'_sample4_ksd_vevtsq'];
        print('-depsc2',[filename,'.eps']);
        print('-djpeg',[filename,'.jpg']);
        print('-dpdf',[filename,'.pdf']);
    end
end

% starting date of 4 year window
T04=dates(end)-40000;
i04=min(find(dates>=T04));
dates=dates(i04:end);
years=floor(dates/10000);
months=floor((dates-years*10000)/100);
days=(dates-years*10000-months*100);
T0=floor((T4)/7);
label_indices=1:T0:T4;
N0=numel(label_indices);
date_label={};
for i=1:N0
    date_label{i}=[num2str(years(label_indices(i))),'.',num2str(months(label_indices(i))),'.',num2str(days(label_indices(i)))];
end


% plot of posterior median elasticity of volatility over time
co=[0,0,1;  0,0.5,0; 1,0,0; 0,0.75,0.75;   0.75,0,0.75; 0.75,0.75,0; 0.25,0.25,0.25;0.31,0.4,0.58];

figure;
for i=1:NM-1
    plot(median_beta0(i)+median_beta1(i)*data4(:,i)+median_beta2(i)*data4(:,i).^2,'Color',co(i,:)); hold on;
end
plot(median_beta0(i)+median_beta1(i)*data4(:,i)+median_beta2(i)*data4(:,i).^2,'Color',[0.31,0.4,0.58]);hold on;
axis tight;
set(gca,'XTick',label_indices);
set(gca,'XTickLabel',date_label);
xticklabel_rotate([],60,[]);
legend('1y','2y','3y','4y','5y','7y','10y','30y');
xlabel('Date');
ylabel('Median elasticity of volatility');
print('-depsc2','gammamedians_sample4_vevtsq.eps');
print('-djpeg','gammamedians_sample4_vevtsq.jpg');
print('-dpdf','gammamedians_sample4_vevtsq.pdf');

% save data to mat file
save irswap_vevtsq_sample4_postprocess.mat

%% 1-year subsample
% load saved samples of parameters
d=load('mu_vevtsq_sample1_1y_chain1.txt');
mu_sample1y=d(:,2);
d=load('mu_vevtsq_sample1_2y_chain1.txt');
mu_sample2y=d(:,2);
d=load('mu_vevtsq_sample1_3y_chain1.txt');
mu_sample3y=d(:,2);
d=load('mu_vevtsq_sample1_4y_chain1.txt');
mu_sample4y=d(:,2);
d=load('mu_vevtsq_sample1_5y_chain1.txt');
mu_sample5y=d(:,2);
d=load('mu_vevtsq_sample1_7y_chain1.txt');
mu_sample7y=d(:,2);
d=load('mu_vevtsq_sample1_10y_chain1.txt');
mu_sample10y=d(:,2);
d=load('mu_vevtsq_sample1_30y_chain1.txt');
mu_sample30y=d(:,2);

d=load('sigma_vevtsq_sample1_1y_chain1.txt');
sigma_sample1y=d(:,2);
d=load('sigma_vevtsq_sample1_2y_chain1.txt');
sigma_sample2y=d(:,2);
d=load('sigma_vevtsq_sample1_3y_chain1.txt');
sigma_sample3y=d(:,2);
d=load('sigma_vevtsq_sample1_4y_chain1.txt');
sigma_sample4y=d(:,2);
d=load('sigma_vevtsq_sample1_5y_chain1.txt');
sigma_sample5y=d(:,2);
d=load('sigma_vevtsq_sample1_7y_chain1.txt');
sigma_sample7y=d(:,2);
d=load('sigma_vevtsq_sample1_10y_chain1.txt');
sigma_sample10y=d(:,2);
d=load('sigma_vevtsq_sample1_30y_chain1.txt');
sigma_sample30y=d(:,2);

d=load('beta0_vevtsq_sample1_1y_chain1.txt');
beta0_sample1y=d(:,2);
d=load('beta0_vevtsq_sample1_2y_chain1.txt');
beta0_sample2y=d(:,2);
d=load('beta0_vevtsq_sample1_3y_chain1.txt');
beta0_sample3y=d(:,2);
d=load('beta0_vevtsq_sample1_4y_chain1.txt');
beta0_sample4y=d(:,2);
d=load('beta0_vevtsq_sample1_5y_chain1.txt');
beta0_sample5y=d(:,2);
d=load('beta0_vevtsq_sample1_7y_chain1.txt');
beta0_sample7y=d(:,2);
d=load('beta0_vevtsq_sample1_10y_chain1.txt');
beta0_sample10y=d(:,2);
d=load('beta0_vevtsq_sample1_30y_chain1.txt');
beta0_sample30y=d(:,2);

d=load('beta1_vevtsq_sample1_1y_chain1.txt');
beta1_sample1y=d(:,2);
d=load('beta1_vevtsq_sample1_2y_chain1.txt');
beta1_sample2y=d(:,2);
d=load('beta1_vevtsq_sample1_3y_chain1.txt');
beta1_sample3y=d(:,2);
d=load('beta1_vevtsq_sample1_4y_chain1.txt');
beta1_sample4y=d(:,2);
d=load('beta1_vevtsq_sample1_5y_chain1.txt');
beta1_sample5y=d(:,2);
d=load('beta1_vevtsq_sample1_7y_chain1.txt');
beta1_sample7y=d(:,2);
d=load('beta1_vevtsq_sample1_10y_chain1.txt');
beta1_sample10y=d(:,2);
d=load('beta1_vevtsq_sample1_30y_chain1.txt');
beta1_sample30y=d(:,2);

d=load('beta2_vevtsq_sample1_1y_chain1.txt');
beta2_sample1y=d(:,2);
d=load('beta2_vevtsq_sample1_2y_chain1.txt');
beta2_sample2y=d(:,2);
d=load('beta2_vevtsq_sample1_3y_chain1.txt');
beta2_sample3y=d(:,2);
d=load('beta2_vevtsq_sample1_4y_chain1.txt');
beta2_sample4y=d(:,2);
d=load('beta2_vevtsq_sample1_5y_chain1.txt');
beta2_sample5y=d(:,2);
d=load('beta2_vevtsq_sample1_7y_chain1.txt');
beta2_sample7y=d(:,2);
d=load('beta2_vevtsq_sample1_10y_chain1.txt');
beta2_sample10y=d(:,2);
d=load('beta2_vevtsq_sample1_30y_chain1.txt');
beta2_sample30y=d(:,2);

d=load('nu_vevtsq_sample1_1y_chain1.txt');
nu_sample1y=d(:,2);
d=load('nu_vevtsq_sample1_2y_chain1.txt');
nu_sample2y=d(:,2);
d=load('nu_vevtsq_sample1_3y_chain1.txt');
nu_sample3y=d(:,2);
d=load('nu_vevtsq_sample1_4y_chain1.txt');
nu_sample4y=d(:,2);
d=load('nu_vevtsq_sample1_5y_chain1.txt');
nu_sample5y=d(:,2);
d=load('nu_vevtsq_sample1_7y_chain1.txt');
nu_sample7y=d(:,2);
d=load('nu_vevtsq_sample1_10y_chain1.txt');
nu_sample10y=d(:,2);
d=load('nu_vevtsq_sample1_30y_chain1.txt');
nu_sample30y=d(:,2);


% compute some simple statistics
mean_mu=mean([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);
median_mu=median([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);
p025_mu=prctile([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y],2.5);
p975_mu=prctile([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y],97.5);
std_mu=std([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);

mean_sigma=mean([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
median_sigma=median([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
p025_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],2.5);
p975_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],97.5);
std_sigma=std([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);

mean_beta0=mean([beta0_sample1y,beta0_sample2y,beta0_sample3y,beta0_sample4y,...
    beta0_sample5y,beta0_sample7y,beta0_sample10y,beta0_sample30y]);
median_beta0=median([beta0_sample1y,beta0_sample2y,beta0_sample3y,beta0_sample4y,...
    beta0_sample5y,beta0_sample7y,beta0_sample10y,beta0_sample30y]);
p025_beta0=prctile([beta0_sample1y,beta0_sample2y,beta0_sample3y,beta0_sample4y,...
    beta0_sample5y,beta0_sample7y,beta0_sample10y,beta0_sample30y],2.5);
p975_beta0=prctile([beta0_sample1y,beta0_sample2y,beta0_sample3y,beta0_sample4y,...
    beta0_sample5y,beta0_sample7y,beta0_sample10y,beta0_sample30y],97.5);
std_beta0=std([beta0_sample1y,beta0_sample2y,beta0_sample3y,beta0_sample4y,...
    beta0_sample5y,beta0_sample7y,beta0_sample10y,beta0_sample30y]);

mean_beta1=mean([beta1_sample1y,beta1_sample2y,beta1_sample3y,beta1_sample4y,...
    beta1_sample5y,beta1_sample7y,beta1_sample10y,beta1_sample30y]);
median_beta1=median([beta1_sample1y,beta1_sample2y,beta1_sample3y,beta1_sample4y,...
    beta1_sample5y,beta1_sample7y,beta1_sample10y,beta1_sample30y]);
p025_beta1=prctile([beta1_sample1y,beta1_sample2y,beta1_sample3y,beta1_sample4y,...
    beta1_sample5y,beta1_sample7y,beta1_sample10y,beta1_sample30y],2.5);
p975_beta1=prctile([beta1_sample1y,beta1_sample2y,beta1_sample3y,beta1_sample4y,...
    beta1_sample5y,beta1_sample7y,beta1_sample10y,beta1_sample30y],97.5);
std_beta1=std([beta1_sample1y,beta1_sample2y,beta1_sample3y,beta1_sample4y,...
    beta1_sample5y,beta1_sample7y,beta1_sample10y,beta1_sample30y]);

mean_beta2=mean([beta2_sample1y,beta2_sample2y,beta2_sample3y,beta2_sample4y,...
    beta2_sample5y,beta2_sample7y,beta2_sample10y,beta2_sample30y]);
median_beta2=median([beta2_sample1y,beta2_sample2y,beta2_sample3y,beta2_sample4y,...
    beta2_sample5y,beta2_sample7y,beta2_sample10y,beta2_sample30y]);
p025_beta2=prctile([beta2_sample1y,beta2_sample2y,beta2_sample3y,beta2_sample4y,...
    beta2_sample5y,beta2_sample7y,beta2_sample10y,beta2_sample30y],2.5);
p975_beta2=prctile([beta2_sample1y,beta2_sample2y,beta2_sample3y,beta2_sample4y,...
    beta2_sample5y,beta2_sample7y,beta2_sample10y,beta2_sample30y],97.5);
std_beta2=std([beta2_sample1y,beta2_sample2y,beta2_sample3y,beta2_sample4y,...
    beta2_sample5y,beta2_sample7y,beta2_sample10y,beta2_sample30y]);

mean_nu=mean([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
median_nu=median([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
p025_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],2.5);
p975_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],97.5);
std_nu=std([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);

medians=[median_mu;median_sigma;median_beta0;median_beta1;median_beta2;median_nu];
p025=[p025_mu;p025_sigma;p025_beta0;p025_beta1;p025_beta2;p025_nu];
p975=[p975_mu;p975_sigma;p975_beta0;p975_beta1;p975_beta2;p975_nu];


% save posterior medians and posterior 95% confidence intervals into a file
fid=fopen('irswap_vevtsq_sample1_stats.csv','w');
fprintf(fid,'%s,%s,%s,%s,%s\n','Swap Maturity','Parameter','Posterior Median',...
    'Posterior 2.5th percentile','Posterior 97.5th percentile');
for i=1:NM
    for j=1:NV
        fprintf(fid,'%s,%s,%7.4f,%7.4f,%7.4f\n',swap_maturity{i},pname{j},...
            medians(j,i),p025(j,i),p975(j,i));
    end
end
fclose(fid);

samples=NaN(NMC,NV,NM);
samples(:,:,1)=[mu_sample1y,sigma_sample1y,beta0_sample1y,beta1_sample1y,beta2_sample1y,nu_sample1y];
samples(:,:,2)=[mu_sample2y,sigma_sample2y,beta0_sample2y,beta1_sample2y,beta2_sample2y,nu_sample2y];
samples(:,:,3)=[mu_sample3y,sigma_sample3y,beta0_sample3y,beta1_sample3y,beta2_sample3y,nu_sample3y];
samples(:,:,4)=[mu_sample4y,sigma_sample4y,beta0_sample4y,beta1_sample4y,beta2_sample4y,nu_sample4y];
samples(:,:,5)=[mu_sample5y,sigma_sample5y,beta0_sample5y,beta1_sample5y,beta2_sample5y,nu_sample5y];
samples(:,:,6)=[mu_sample7y,sigma_sample7y,beta0_sample7y,beta1_sample7y,beta2_sample7y,nu_sample7y];
samples(:,:,7)=[mu_sample10y,sigma_sample10y,beta0_sample10y,beta1_sample10y,beta2_sample10y,nu_sample10y];
samples(:,:,8)=[mu_sample30y,sigma_sample30y,beta0_sample30y,beta1_sample30y,beta2_sample30y,nu_sample30y];

ksd=NaN(NV,NK,NM);
xsd=NaN(NV,NK,NM);

% all maturity-dependent densities
for i=1:NM
    for j=1:NV
        lb=prctile(samples(:,j,i),2.5);
        ub=prctile(samples(:,j,i),97.5);
        il=find(samples(:,j,i)>lb);
        gsample=samples(il,j,i);
        iu=find(gsample<ub);
        fsample=gsample(iu);
        if j<2
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','unbounded');
        elseif j<3
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','positive');
        elseif j<6
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','unbounded');
        else
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support',[1.99,130.01]);
        end
        figure;
        plot(xsd(j,:,i),ksd(j,:,i),'r-','LineWidth',2);
        xlabel(pname{j});
        ylabel('Marginal Posterior Density');
        title([swap_maturity{i},' US Interest Rate Swaps (1-year sample)']);
        filename=[pname{j},'_',swap_maturity{i},'_sample1_ksd_vevtsq'];
        print('-depsc2',[filename,'.eps']);
        print('-djpeg',[filename,'.jpg']);
        print('-dpdf',[filename,'.pdf']);
    end
end

% starting date of 1 year window
T01=dates(end)-10000;
i01=min(find(dates>=T01));
dates=dates(i01:end);
years=floor(dates/10000);
months=floor((dates-years*10000)/100);
days=(dates-years*10000-months*100);
T0=floor((T1)/7);
label_indices=1:T0:T1;
N0=numel(label_indices);
date_label={};
for i=1:N0
    date_label{i}=[num2str(years(label_indices(i))),'.',num2str(months(label_indices(i))),'.',num2str(days(label_indices(i)))];
end



% plot of posterior median elasticity of volatility over time
co=[0,0,1;  0,0.5,0; 1,0,0; 0,0.75,0.75;   0.75,0,0.75; 0.75,0.75,0; 0.25,0.25,0.25;0.31,0.4,0.58];

figure;
for i=1:NM-1
    plot(median_beta0(i)+median_beta1(i)*data1(:,i)+median_beta2(i)*data1(:,i).^2,'Color',co(i,:)); hold on;
end
plot(median_beta0(i)+median_beta1(i)*data1(:,i)+median_beta2(i)*data1(:,i).^2,'Color',[0.31,0.4,0.58]);hold on;
axis tight;
set(gca,'XTick',label_indices);
set(gca,'XTickLabel',date_label);
xticklabel_rotate([],60,[]);
legend('1y','2y','3y','4y','5y','7y','10y','30y');
xlabel('Date');
ylabel('Median elasticity of volatility');
print('-depsc2','gammamedians_sample1_vevtsq.eps');
print('-djpeg','gammamedians_sample1_vevtsq.jpg');
print('-dpdf','gammamedians_sample1_vevtsq.pdf');

% save data to mat file
save irswap_vevtsq_sample1_postprocess.mat