% compute log-likelihood function for driftless Variable Elasticity of Variance process with Student t innovations
% Elasticity of variance is given by logit: 1/(1+exp(-beta*s+c))
% INPUTS
% params    = vector containing the three parameters (scale, elasticity and degrees of freedom)
% r0        = initial value
% data      = sample, purpotedly from CEV with Student t innovations
% cens      = censoring parameter (not used)
% freq      = a vector of integer input frequences 9not used)
% OUTPUTS
% L         = log-likelihood function

function L = logitvevt_loglik(params,data,cens,freq)

r0=data(1);
r=data(2:end);
sigma=params(1);
beta=params(2);
c=params(3);
nu=params(4);
L=logitvev_t_loglik(r0,r,sigma,beta,c,nu);