% generate artificial time-series from the model
T=10240;
r0=2.9;
sigmabar=0.2;
mu=-0.0001;
gamma=0.5;
beta1=0.01;
beta2=0.5;
[r,sigma] = atanvev3_normal_simulator(T,mu,sigmabar,beta1,beta2,r0);
% regime counts
['CEV Regime  ','Difference Regime  ','Return Regime  ']
disp([sum(sigma<sigmabar),sum(sigma==sigmabar),sum(sigma>sigmabar)]);

% evaluate loglikelihood of the sample
L=atanvev3_normal_loglik(r0,r,mu,sigmabar,beta1,beta2)

% evaluate loglikelihood on a one-dimensional slice surrounding true values
N=64;% slice size
% mu slice
mu_grid=linspace(-2,6,N);
L_mu=NaN(N,1);
for i=1:N
    L_mu(i)=atanvev3_normal_loglik(r0,r,mu_grid(i),sigmabar,beta1,beta2);
end
figure1=figure;
set(figure1,'DefaultTextInterpreter','tex');
plot(mu_grid,L_mu,'b-'); hold on;
plot(mu,L,'MarkerSize',30,'Marker','.','LineStyle','none','Color','r');
hold on;
v=axis;
l0=line([mu,mu],[v(3),v(4)]);
set(l0,'Color','r','LineStyle','--');
xlabel('\mu');
ylabel('Log-likelihood');


% sigmabar slice
sigmabar_grid=logspace(-2,1,N);
L_sigmabar=NaN(N,1);
for i=1:N
    L_sigmabar(i)=atanvev3_normal_loglik(r0,r,mu,sigmabar_grid(i),beta1,beta2);
end
figure3=figure;
set(figure3,'DefaultTextInterpreter','tex');
plot(log(sigmabar_grid),L_sigmabar,'b-'); hold on;
plot(log(sigmabar),L,'MarkerSize',30,'Marker','.','LineStyle','none','Color','r');
hold on;
v=axis;
l0=line([log(sigmabar),log(sigmabar)],[v(3),v(4)]);
set(l0,'Color','r','LineStyle','--');
xlabel('log \sigma');
ylabel('Log-likelihood');

% beta1 slice
beta1_grid=linspace(-0.1,0.5,N);
L_beta1=NaN(N,1);
for i=1:N
    L_beta1(i)=atanvev3_normal_loglik(r0,r,mu,sigmabar,beta1_grid(i),beta2);
end
figure4=figure;
set(figure4,'DefaultTextInterpreter','tex');
plot(beta1_grid,L_beta1,'b-'); hold on;
plot(beta1,L,'MarkerSize',30,'Marker','.','LineStyle','none','Color','r');
hold on;
v=axis;
l0=line([beta1,beta1],[v(3),v(4)]);
set(l0,'Color','r','LineStyle','--');
xlabel('\beta_1');
ylabel('Log-likelihood');

% beta2 slice
beta2_grid=linspace(-0.1,1.5,N);
L_beta2=NaN(N,1);
for i=1:N
    L_beta2(i)=atanvev3_normal_loglik(r0,r,mu,sigmabar,beta1,beta2_grid(i));
end
figure4=figure;
set(figure4,'DefaultTextInterpreter','tex');
plot(beta2_grid,L_beta2,'b-'); hold on;
plot(beta2,L,'MarkerSize',30,'Marker','.','LineStyle','none','Color','r');
hold on;
v=axis;
l0=line([beta2,beta2],[v(3),v(4)]);
set(l0,'Color','r','LineStyle','--');
xlabel('\beta_1');
ylabel('Log-likelihood');