% testing simulators from variable elasticity of volatility model
T=1024;
r0=2.67;
sigmabar=0.025;
theta=2.6;
mu=0.0001;
nu=3.5;
beta1=2.51;
beta2=-0.5;
[r,sigma,gamman] = atanvev3_normal_simulator(T,mu,sigmabar,beta1,beta2,r0);
[rt,sigmat,gammat] = atanvev3_t_simulator(T,mu,sigmabar,beta1,beta2,nu,r0);
'sample volatility of normal rates'
std(diff(r))
'sample volatility of fat-tailed rates'
std(diff(rt))

figure;
subplot(2,3,1);
plot(r);axis tight;xlabel('t');ylabel('r_t');
subplot(2,3,2);
plot(sigma); axis tight;xlabel('t');ylabel('\sigma_t');
title('Normal innovations');
subplot(2,3,3);
plot(gamman); axis tight; xlabel('t');ylabel('\gamma_t');
subplot(2,3,4);
plot(rt);axis tight;xlabel('t');ylabel('r_t');
subplot(2,3,5);
plot(sigmat);axis tight;xlabel('t');ylabel('\sigma_t');
title('Student t innovations');
subplot(2,3,6);
plot(gammat); axis tight; xlabel('t');ylabel('\gamma_t');


figure;
subplot(3,1,1);
plot(r,'b-'); hold on;
plot(rt,'r-');
axis tight;
xlabel('t');ylabel('r_t');title('Simulated Interest Rate');
legend('Normal','Student t');
subplot(3,1,2);
plot(sigma,'b-'); hold on;
plot(sigmat,'r-');
axis tight;
xlabel('t');ylabel('\sigma_t');title('Simulated volatility');
legend('Normal','Student t');
subplot(3,1,3);
plot(gamman,'b-'); hold on;
plot(gammat,'r-');
axis tight;
xlabel('t');ylabel('\gamma_t');title('Simulated elasticity of volatility');
legend('Normal','Student t');