(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      9282,        305]
NotebookOptionsPosition[      8499,        277]
NotebookOutlinePosition[      8836,        292]
CellTagsIndexPosition[      8793,        289]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{
  RowBox[{
  "SetDirectory", "[", 
   "\"\</projects/financial_econometrics/fuform/code/cev\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"L", "[", 
   RowBox[{"\[Mu]_", ",", "\[Sigma]_", ",", "\[Alpha]_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Log", "[", 
    FractionBox["1", 
     RowBox[{"\[Sigma]", "*", 
      SuperscriptBox["r", "\[Alpha]"], "*", 
      SqrtBox[
       RowBox[{"2", "*", "\[Pi]"}]]}]], "]"}], "-", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"2", "*", 
      SuperscriptBox["\[Sigma]", "2"], "*", 
      SuperscriptBox["r", 
       RowBox[{"2", "*", "\[Alpha]"}]]}]], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"dr", "-", "\[Mu]"}], ")"}], 
     "2"]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"S1", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]", ",", "\[Alpha]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Mu]", ",", "1"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"S2", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]", ",", "\[Alpha]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Sigma]", ",", "1"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"S3", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]", ",", "\[Alpha]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Alpha]", ",", "1"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"H33", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]", ",", "\[Alpha]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Alpha]", ",", "2"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"S1m", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"mu", ",", "sigma", ",", "alpha"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"mu", ",", "1"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"S2m", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"mu", ",", "sigma", ",", "alpha"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"sigma", ",", "1"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"S3m", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"mu", ",", "sigma", ",", "alpha"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"alpha", ",", "1"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"H33m", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"mu", ",", "sigma", ",", "alpha"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"alpha", ",", "2"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"TeXForm", "[", 
  RowBox[{"Simplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]", ",", "\[Gamma]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Gamma]", ",", "2"}], "}"}]}], "]"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"<<", "ToMatlab.m"}], "\[IndentingNewLine]", 
 RowBox[{"ToMatlab", "[", 
  RowBox[{"S1m", ",", "\"\<S1\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"ToMatlab", "[", 
  RowBox[{"S2m", ",", "\"\<S2\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"ToMatlab", "[", 
  RowBox[{"S3m", ",", "\"\<S3\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"ToMatlab", "[", 
  RowBox[{"H33m", ",", "\"\<H33\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.555925572832676*^9, 3.5559258382919483`*^9}, {
  3.555925963481121*^9, 3.555926011347761*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox["r", 
    RowBox[{
     RowBox[{"-", "2"}], " ", "\[Alpha]"}]], " ", 
   RowBox[{"(", 
    RowBox[{"dr", "-", "\[Mu]"}], ")"}]}], 
  SuperscriptBox["\[Sigma]", "2"]]], "Output",
 CellChangeTimes->{3.555925889149664*^9, 3.555926019650374*^9}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    SuperscriptBox["r", 
     RowBox[{
      RowBox[{"-", "2"}], " ", "\[Alpha]"}]], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"dr", "-", "\[Mu]"}], ")"}], "2"]}], 
   SuperscriptBox["\[Sigma]", "3"]], "-", 
  FractionBox["1", "\[Sigma]"]}]], "Output",
 CellChangeTimes->{3.555925889149664*^9, 3.555926019651292*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1"}], "+", 
    FractionBox[
     RowBox[{
      SuperscriptBox["r", 
       RowBox[{
        RowBox[{"-", "2"}], " ", "\[Alpha]"}]], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"dr", "-", "\[Mu]"}], ")"}], "2"]}], 
     SuperscriptBox["\[Sigma]", "2"]]}], ")"}], " ", 
  RowBox[{"Log", "[", "r", "]"}]}]], "Output",
 CellChangeTimes->{3.555925889149664*^9, 3.555926019675596*^9}],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox["r", 
     RowBox[{
      RowBox[{"-", "2"}], " ", "\[Alpha]"}]], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"dr", "-", "\[Mu]"}], ")"}], "2"], " ", 
    SuperscriptBox[
     RowBox[{"Log", "[", "r", "]"}], "2"]}], 
   SuperscriptBox["\[Sigma]", "2"]]}]], "Output",
 CellChangeTimes->{3.555925889149664*^9, 3.5559260197998*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{"dr", "-", "mu"}], ")"}], " ", 
   SuperscriptBox["r", 
    RowBox[{
     RowBox[{"-", "2"}], " ", "alpha"}]]}], 
  SuperscriptBox["sigma", "2"]]], "Output",
 CellChangeTimes->{3.555925889149664*^9, 3.555926019806838*^9}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"dr", "-", "mu"}], ")"}], "2"], " ", 
    SuperscriptBox["r", 
     RowBox[{
      RowBox[{"-", "2"}], " ", "alpha"}]]}], 
   SuperscriptBox["sigma", "3"]], "-", 
  FractionBox["1", "sigma"]}]], "Output",
 CellChangeTimes->{3.555925889149664*^9, 3.5559260198142242`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1"}], "+", 
    FractionBox[
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"dr", "-", "mu"}], ")"}], "2"], " ", 
      SuperscriptBox["r", 
       RowBox[{
        RowBox[{"-", "2"}], " ", "alpha"}]]}], 
     SuperscriptBox["sigma", "2"]]}], ")"}], " ", 
  RowBox[{"Log", "[", "r", "]"}]}]], "Output",
 CellChangeTimes->{3.555925889149664*^9, 3.5559260198201714`*^9}],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"dr", "-", "mu"}], ")"}], "2"], " ", 
    SuperscriptBox["r", 
     RowBox[{
      RowBox[{"-", "2"}], " ", "alpha"}]], " ", 
    SuperscriptBox[
     RowBox[{"Log", "[", "r", "]"}], "2"]}], 
   SuperscriptBox["sigma", "2"]]}]], "Output",
 CellChangeTimes->{3.555925889149664*^9, 3.555926019822897*^9}],

Cell[BoxData["\<\"S1=(dr+(-1).*mu).*r.^((-2).*alpha).*sigma.^(-2);\\n\"\>"], \
"Output",
 CellChangeTimes->{3.555925889149664*^9, 3.5559260198324747`*^9}],

Cell[BoxData["\<\"S2=(dr+(-1).*mu).^2.*r.^((-2).*alpha).*sigma.^(-3)+(-1).*\
sigma.^(-1); ...\\n  \\n\"\>"], "Output",
 CellChangeTimes->{3.555925889149664*^9, 3.5559260198332357`*^9}],

Cell[BoxData["\<\"S3=((-1)+(dr+(-1).*mu).^2.*r.^((-2).*alpha).*sigma.^(-2)).*\
log(r);\\n\"\>"], "Output",
 CellChangeTimes->{3.555925889149664*^9, 3.555926019833932*^9}],

Cell[BoxData["\<\"H33=(-2).*(dr+(-1).*mu).^2.*r.^((-2).*alpha).*sigma.^(-2).*\
log(r).^2; ...\\n  \\n\"\>"], "Output",
 CellChangeTimes->{3.555925889149664*^9, 3.55592601983462*^9}],

Cell["\<\
-\\frac{2 (\\text{dr}-\\mu )^2 r^{-2 \\gamma } \\log ^2(r)}{\\sigma ^2}\
\>", "Output",
 CellChangeTimes->{3.555925889149664*^9, 3.555926019835588*^9}]
}, Open  ]]
},
WindowSize->{1920, 1073},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"8.0 for Linux x86 (64-bit) (February 23, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 3886, 117, 488, "Input"],
Cell[4468, 141, 298, 9, 66, "Output"],
Cell[4769, 152, 384, 12, 66, "Output"],
Cell[5156, 166, 471, 15, 68, "Output"],
Cell[5630, 183, 428, 13, 66, "Output"],
Cell[6061, 198, 289, 9, 69, "Output"],
Cell[6353, 209, 374, 12, 69, "Output"],
Cell[6730, 223, 464, 15, 69, "Output"],
Cell[7197, 240, 421, 13, 69, "Output"],
Cell[7621, 255, 154, 2, 71, "Output"],
Cell[7778, 259, 184, 2, 98, "Output"],
Cell[7965, 263, 170, 2, 71, "Output"],
Cell[8138, 267, 181, 2, 98, "Output"],
Cell[8322, 271, 161, 3, 43, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
