(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     36976,        968]
NotebookOptionsPosition[     35647,        928]
NotebookOutlinePosition[     36246,        949]
CellTagsIndexPosition[     36203,        946]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{
  RowBox[{
  "SetDirectory", "[", 
   "\"\</projects/financial_econometrics/fuform/code/cev\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"L", "[", 
    RowBox[{"\[Mu]_", ",", "\[Sigma]_", ",", "gamma_", ",", "nu_"}], "]"}], ":=", 
   RowBox[{"Log", "[", 
    RowBox[{
     FractionBox[
      RowBox[{"Gamma", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"nu", "+", "1"}], ")"}], "/", "2"}], "]"}], 
      RowBox[{
       RowBox[{"Gamma", "[", 
        RowBox[{"nu", "/", "2"}], "]"}], "*", "\[Sigma]", "*", 
       SuperscriptBox["r", "gamma"], "*", 
       SqrtBox[
        RowBox[{"nu", "*", "\[Pi]"}]]}]], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{
         FractionBox["1", "nu"], "*", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"dr", "-", "\[Mu]"}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"\[Sigma]", "*", 
              SuperscriptBox["r", "gamma"]}], ")"}]}], ")"}], "2"]}]}], ")"}], 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{"nu", "+", "1"}], ")"}]}], "/", "2"}]]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"S1", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]", ",", "\[Alpha]", ",", "\[Nu]"}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Mu]", ",", "1"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"S2", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]", ",", "\[Alpha]", ",", "\[Nu]"}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Sigma]", ",", "1"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"S3", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]", ",", "\[Alpha]", ",", "\[Nu]"}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Alpha]", ",", "1"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"S4", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]", ",", "\[Alpha]", ",", "\[Nu]"}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Nu]", ",", "1"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"H33", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]", ",", "\[Alpha]", ",", "\[Nu]"}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Alpha]", ",", "2"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"H44", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]", ",", "\[Alpha]", ",", "\[Nu]"}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Nu]", ",", "2"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"S1m", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"mu", ",", "sigma", ",", "alpha", ",", "nu"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"mu", ",", "1"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"S2m", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"mu", ",", "sigma", ",", "alpha", ",", "nu"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"sigma", ",", "1"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"S3m", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"mu", ",", "sigma", ",", "alpha", ",", "nu"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"alpha", ",", "1"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"S4m", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"mu", ",", "sigma", ",", "alpha", ",", "nu"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"nu", ",", "1"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"H33m", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"mu", ",", "sigma", ",", "alpha", ",", "nu"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"alpha", ",", "2"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"H44m", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"mu", ",", "sigma", ",", "alpha", ",", "nu"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"nu", ",", "2"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"TeXForm", "[", 
  RowBox[{"Simplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"L", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]", ",", "\[Gamma]", ",", "nu"}], "]"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"\[Gamma]", ",", "2"}], "}"}]}], "]"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"<<", "ToMatlab.m"}], "\[IndentingNewLine]", 
 RowBox[{"ToMatlab", "[", 
  RowBox[{"S1m", ",", "\"\<S1\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"ToMatlab", "[", 
  RowBox[{"S2m", ",", "\"\<S2\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"ToMatlab", "[", 
  RowBox[{"S3m", ",", "\"\<S3\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"ToMatlab", "[", 
  RowBox[{"S4m", ",", "\"\<S4\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"ToMatlab", "[", 
  RowBox[{"H33m", ",", "\"\<H33\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"ToMatlab", "[", 
  RowBox[{"H44m", ",", "\"\<H44\>\""}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.555867793314577*^9, 3.555867795599164*^9}, {
   3.555867891577938*^9, 3.555867905268832*^9}, {3.555868036839568*^9, 
   3.555868249429657*^9}, {3.555868362705517*^9, 3.5558683691594753`*^9}, {
   3.5558684270133038`*^9, 3.5558684763292513`*^9}, {3.5558687423073893`*^9, 
   3.555868789685419*^9}, {3.555869036662034*^9, 3.5558690481159286`*^9}, 
   3.555869142504904*^9, {3.555870184074966*^9, 3.555870301892446*^9}, {
   3.555870386321216*^9, 3.555870393938204*^9}, {3.555876689893531*^9, 
   3.555876963210018*^9}, {3.55587704365339*^9, 3.555877052428553*^9}, {
   3.555877268775659*^9, 3.555877440222948*^9}, {3.555878276596591*^9, 
   3.555878290374749*^9}, {3.555878413568941*^9, 3.555878418743435*^9}, {
   3.5558784857211313`*^9, 3.555878501811878*^9}, {3.555878556384721*^9, 
   3.555878606826886*^9}, {3.555885123321796*^9, 3.555885129243763*^9}, {
   3.555885214662236*^9, 3.555885217117443*^9}, {3.555891080513562*^9, 
   3.5558911457233963`*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{"dr", "-", "\[Mu]"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", "\[Nu]"}], ")"}]}], 
  RowBox[{
   SuperscriptBox["dr", "2"], "-", 
   RowBox[{"2", " ", "dr", " ", "\[Mu]"}], "+", 
   SuperscriptBox["\[Mu]", "2"], "+", 
   RowBox[{
    SuperscriptBox["r", 
     RowBox[{"2", " ", "\[Alpha]"}]], " ", "\[Nu]", " ", 
    SuperscriptBox["\[Sigma]", "2"]}]}]]], "Output",
 CellChangeTimes->{
  3.5558687938711433`*^9, 3.555869053176969*^9, 3.5558691458017483`*^9, 
   3.555870236283201*^9, {3.555870289552745*^9, 3.5558703056977777`*^9}, 
   3.5558703968532963`*^9, 3.555876767672971*^9, 3.5558768583128757`*^9, 
   3.5558769663170633`*^9, 3.5558772301160583`*^9, 3.555877448062018*^9, {
   3.555878283838213*^9, 3.555878293570106*^9}, 3.5558784200425797`*^9, 
   3.555878503537323*^9, 3.55587861234009*^9, 3.555885130574129*^9, 
   3.5558852206567698`*^9, 3.555891148945209*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{"\[Nu]", " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["dr", "2"], "-", 
     RowBox[{"2", " ", "dr", " ", "\[Mu]"}], "+", 
     SuperscriptBox["\[Mu]", "2"], "-", 
     RowBox[{
      SuperscriptBox["r", 
       RowBox[{"2", " ", "\[Alpha]"}]], " ", 
      SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
  RowBox[{"\[Sigma]", " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["dr", "2"], "-", 
     RowBox[{"2", " ", "dr", " ", "\[Mu]"}], "+", 
     SuperscriptBox["\[Mu]", "2"], "+", 
     RowBox[{
      SuperscriptBox["r", 
       RowBox[{"2", " ", "\[Alpha]"}]], " ", "\[Nu]", " ", 
      SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}]]], "Output",
 CellChangeTimes->{
  3.5558687938711433`*^9, 3.555869053176969*^9, 3.5558691458017483`*^9, 
   3.555870236283201*^9, {3.555870289552745*^9, 3.5558703056977777`*^9}, 
   3.5558703968532963`*^9, 3.555876767672971*^9, 3.5558768583128757`*^9, 
   3.5558769663170633`*^9, 3.5558772301160583`*^9, 3.555877448062018*^9, {
   3.555878283838213*^9, 3.555878293570106*^9}, 3.5558784200425797`*^9, 
   3.555878503537323*^9, 3.55587861234009*^9, 3.555885130574129*^9, 
   3.5558852206567698`*^9, 3.555891148946107*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{"\[Nu]", " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["dr", "2"], "-", 
     RowBox[{"2", " ", "dr", " ", "\[Mu]"}], "+", 
     SuperscriptBox["\[Mu]", "2"], "-", 
     RowBox[{
      SuperscriptBox["r", 
       RowBox[{"2", " ", "\[Alpha]"}]], " ", 
      SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], " ", 
   RowBox[{"Log", "[", "r", "]"}]}], 
  RowBox[{
   SuperscriptBox["dr", "2"], "-", 
   RowBox[{"2", " ", "dr", " ", "\[Mu]"}], "+", 
   SuperscriptBox["\[Mu]", "2"], "+", 
   RowBox[{
    SuperscriptBox["r", 
     RowBox[{"2", " ", "\[Alpha]"}]], " ", "\[Nu]", " ", 
    SuperscriptBox["\[Sigma]", "2"]}]}]]], "Output",
 CellChangeTimes->{
  3.5558687938711433`*^9, 3.555869053176969*^9, 3.5558691458017483`*^9, 
   3.555870236283201*^9, {3.555870289552745*^9, 3.5558703056977777`*^9}, 
   3.5558703968532963`*^9, 3.555876767672971*^9, 3.5558768583128757`*^9, 
   3.5558769663170633`*^9, 3.5558772301160583`*^9, 3.555877448062018*^9, {
   3.555878283838213*^9, 3.555878293570106*^9}, 3.5558784200425797`*^9, 
   3.555878503537323*^9, 3.55587861234009*^9, 3.555885130574129*^9, 
   3.5558852206567698`*^9, 3.555891148946926*^9}],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["dr", "2"]}], "+", 
     RowBox[{"2", " ", "dr", " ", "\[Mu]"}], "-", 
     SuperscriptBox["\[Mu]", "2"], "+", 
     RowBox[{
      SuperscriptBox["r", 
       RowBox[{"2", " ", "\[Alpha]"}]], " ", 
      SuperscriptBox["\[Sigma]", "2"]}], "+", 
     RowBox[{
      SuperscriptBox["dr", "2"], " ", 
      RowBox[{"Log", "[", 
       RowBox[{"1", "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["r", 
           RowBox[{
            RowBox[{"-", "2"}], " ", "\[Alpha]"}]], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"dr", "-", "\[Mu]"}], ")"}], "2"]}], 
         RowBox[{"\[Nu]", " ", 
          SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], "-", 
     RowBox[{"2", " ", "dr", " ", "\[Mu]", " ", 
      RowBox[{"Log", "[", 
       RowBox[{"1", "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["r", 
           RowBox[{
            RowBox[{"-", "2"}], " ", "\[Alpha]"}]], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"dr", "-", "\[Mu]"}], ")"}], "2"]}], 
         RowBox[{"\[Nu]", " ", 
          SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["\[Mu]", "2"], " ", 
      RowBox[{"Log", "[", 
       RowBox[{"1", "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["r", 
           RowBox[{
            RowBox[{"-", "2"}], " ", "\[Alpha]"}]], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"dr", "-", "\[Mu]"}], ")"}], "2"]}], 
         RowBox[{"\[Nu]", " ", 
          SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["r", 
       RowBox[{"2", " ", "\[Alpha]"}]], " ", "\[Nu]", " ", 
      SuperscriptBox["\[Sigma]", "2"], " ", 
      RowBox[{"Log", "[", 
       RowBox[{"1", "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox["r", 
           RowBox[{
            RowBox[{"-", "2"}], " ", "\[Alpha]"}]], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"dr", "-", "\[Mu]"}], ")"}], "2"]}], 
         RowBox[{"\[Nu]", " ", 
          SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["dr", "2"], "-", 
        RowBox[{"2", " ", "dr", " ", "\[Mu]"}], "+", 
        SuperscriptBox["\[Mu]", "2"], "+", 
        RowBox[{
         SuperscriptBox["r", 
          RowBox[{"2", " ", "\[Alpha]"}]], " ", "\[Nu]", " ", 
         SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], " ", 
      RowBox[{"PolyGamma", "[", 
       RowBox[{"0", ",", 
        FractionBox["\[Nu]", "2"]}], "]"}]}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["dr", "2"], "-", 
        RowBox[{"2", " ", "dr", " ", "\[Mu]"}], "+", 
        SuperscriptBox["\[Mu]", "2"], "+", 
        RowBox[{
         SuperscriptBox["r", 
          RowBox[{"2", " ", "\[Alpha]"}]], " ", "\[Nu]", " ", 
         SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], " ", 
      RowBox[{"PolyGamma", "[", 
       RowBox[{"0", ",", 
        FractionBox[
         RowBox[{"1", "+", "\[Nu]"}], "2"]}], "]"}]}]}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["dr", "2"], "-", 
       RowBox[{"2", " ", "dr", " ", "\[Mu]"}], "+", 
       SuperscriptBox["\[Mu]", "2"], "+", 
       RowBox[{
        SuperscriptBox["r", 
         RowBox[{"2", " ", "\[Alpha]"}]], " ", "\[Nu]", " ", 
        SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.5558687938711433`*^9, 3.555869053176969*^9, 3.5558691458017483`*^9, 
   3.555870236283201*^9, {3.555870289552745*^9, 3.5558703056977777`*^9}, 
   3.5558703968532963`*^9, 3.555876767672971*^9, 3.5558768583128757`*^9, 
   3.5558769663170633`*^9, 3.5558772301160583`*^9, 3.555877448062018*^9, {
   3.555878283838213*^9, 3.555878293570106*^9}, 3.5558784200425797`*^9, 
   3.555878503537323*^9, 3.55587861234009*^9, 3.555885130574129*^9, 
   3.5558852206567698`*^9, 3.5558911489481373`*^9}],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox["r", 
     RowBox[{"2", " ", "\[Alpha]"}]], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"dr", "-", "\[Mu]"}], ")"}], "2"], " ", "\[Nu]", " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", "\[Nu]"}], ")"}], " ", 
    SuperscriptBox["\[Sigma]", "2"], " ", 
    SuperscriptBox[
     RowBox[{"Log", "[", "r", "]"}], "2"]}], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"dr", "-", "\[Mu]"}], ")"}], "2"], "+", 
      RowBox[{
       SuperscriptBox["r", 
        RowBox[{"2", " ", "\[Alpha]"}]], " ", "\[Nu]", " ", 
       SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "2"]]}]], "Output",
 CellChangeTimes->{
  3.5558687938711433`*^9, 3.555869053176969*^9, 3.5558691458017483`*^9, 
   3.555870236283201*^9, {3.555870289552745*^9, 3.5558703056977777`*^9}, 
   3.5558703968532963`*^9, 3.555876767672971*^9, 3.5558768583128757`*^9, 
   3.5558769663170633`*^9, 3.5558772301160583`*^9, 3.555877448062018*^9, {
   3.555878283838213*^9, 3.555878293570106*^9}, 3.5558784200425797`*^9, 
   3.555878503537323*^9, 3.55587861234009*^9, 3.555885130574129*^9, 
   3.5558852206567698`*^9, 3.5558911489502287`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["dr", "4"], "-", 
       RowBox[{"4", " ", 
        SuperscriptBox["dr", "3"], " ", "\[Mu]"}], "+", 
       RowBox[{"6", " ", 
        SuperscriptBox["dr", "2"], " ", 
        SuperscriptBox["\[Mu]", "2"]}], "-", 
       RowBox[{"4", " ", "dr", " ", 
        SuperscriptBox["\[Mu]", "3"]}], "+", 
       SuperscriptBox["\[Mu]", "4"], "+", 
       RowBox[{
        SuperscriptBox["r", 
         RowBox[{"4", " ", "\[Alpha]"}]], " ", "\[Nu]", " ", 
        SuperscriptBox["\[Sigma]", "4"]}]}], ")"}]}], "-", 
    RowBox[{"\[Nu]", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["dr", "2"], "-", 
        RowBox[{"2", " ", "dr", " ", "\[Mu]"}], "+", 
        SuperscriptBox["\[Mu]", "2"], "+", 
        RowBox[{
         SuperscriptBox["r", 
          RowBox[{"2", " ", "\[Alpha]"}]], " ", "\[Nu]", " ", 
         SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "2"], " ", 
     RowBox[{"PolyGamma", "[", 
      RowBox[{"1", ",", 
       FractionBox["\[Nu]", "2"]}], "]"}]}], "+", 
    RowBox[{"\[Nu]", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["dr", "2"], "-", 
        RowBox[{"2", " ", "dr", " ", "\[Mu]"}], "+", 
        SuperscriptBox["\[Mu]", "2"], "+", 
        RowBox[{
         SuperscriptBox["r", 
          RowBox[{"2", " ", "\[Alpha]"}]], " ", "\[Nu]", " ", 
         SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "2"], " ", 
     RowBox[{"PolyGamma", "[", 
      RowBox[{"1", ",", 
       FractionBox[
        RowBox[{"1", "+", "\[Nu]"}], "2"]}], "]"}]}]}], ")"}], "/", 
  RowBox[{"(", 
   RowBox[{"4", " ", "\[Nu]", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["dr", "2"], "-", 
       RowBox[{"2", " ", "dr", " ", "\[Mu]"}], "+", 
       SuperscriptBox["\[Mu]", "2"], "+", 
       RowBox[{
        SuperscriptBox["r", 
         RowBox[{"2", " ", "\[Alpha]"}]], " ", "\[Nu]", " ", 
        SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "2"]}], ")"}]}]], "Output",\

 CellChangeTimes->{
  3.5558687938711433`*^9, 3.555869053176969*^9, 3.5558691458017483`*^9, 
   3.555870236283201*^9, {3.555870289552745*^9, 3.5558703056977777`*^9}, 
   3.5558703968532963`*^9, 3.555876767672971*^9, 3.5558768583128757`*^9, 
   3.5558769663170633`*^9, 3.5558772301160583`*^9, 3.555877448062018*^9, {
   3.555878283838213*^9, 3.555878293570106*^9}, 3.5558784200425797`*^9, 
   3.555878503537323*^9, 3.55587861234009*^9, 3.555885130574129*^9, 
   3.5558852206567698`*^9, 3.555891149112053*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{"dr", "-", "mu"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", "nu"}], ")"}]}], 
  RowBox[{
   SuperscriptBox["dr", "2"], "-", 
   RowBox[{"2", " ", "dr", " ", "mu"}], "+", 
   SuperscriptBox["mu", "2"], "+", 
   RowBox[{"nu", " ", 
    SuperscriptBox["r", 
     RowBox[{"2", " ", "alpha"}]], " ", 
    SuperscriptBox["sigma", "2"]}]}]]], "Output",
 CellChangeTimes->{
  3.5558687938711433`*^9, 3.555869053176969*^9, 3.5558691458017483`*^9, 
   3.555870236283201*^9, {3.555870289552745*^9, 3.5558703056977777`*^9}, 
   3.5558703968532963`*^9, 3.555876767672971*^9, 3.5558768583128757`*^9, 
   3.5558769663170633`*^9, 3.5558772301160583`*^9, 3.555877448062018*^9, {
   3.555878283838213*^9, 3.555878293570106*^9}, 3.5558784200425797`*^9, 
   3.555878503537323*^9, 3.55587861234009*^9, 3.555885130574129*^9, 
   3.5558852206567698`*^9, 3.555891149113667*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{"nu", " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["dr", "2"], "-", 
     RowBox[{"2", " ", "dr", " ", "mu"}], "+", 
     SuperscriptBox["mu", "2"], "-", 
     RowBox[{
      SuperscriptBox["r", 
       RowBox[{"2", " ", "alpha"}]], " ", 
      SuperscriptBox["sigma", "2"]}]}], ")"}]}], 
  RowBox[{"sigma", " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["dr", "2"], "-", 
     RowBox[{"2", " ", "dr", " ", "mu"}], "+", 
     SuperscriptBox["mu", "2"], "+", 
     RowBox[{"nu", " ", 
      SuperscriptBox["r", 
       RowBox[{"2", " ", "alpha"}]], " ", 
      SuperscriptBox["sigma", "2"]}]}], ")"}]}]]], "Output",
 CellChangeTimes->{
  3.5558687938711433`*^9, 3.555869053176969*^9, 3.5558691458017483`*^9, 
   3.555870236283201*^9, {3.555870289552745*^9, 3.5558703056977777`*^9}, 
   3.5558703968532963`*^9, 3.555876767672971*^9, 3.5558768583128757`*^9, 
   3.5558769663170633`*^9, 3.5558772301160583`*^9, 3.555877448062018*^9, {
   3.555878283838213*^9, 3.555878293570106*^9}, 3.5558784200425797`*^9, 
   3.555878503537323*^9, 3.55587861234009*^9, 3.555885130574129*^9, 
   3.5558852206567698`*^9, 3.555891149114552*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{"nu", " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["dr", "2"], "-", 
     RowBox[{"2", " ", "dr", " ", "mu"}], "+", 
     SuperscriptBox["mu", "2"], "-", 
     RowBox[{
      SuperscriptBox["r", 
       RowBox[{"2", " ", "alpha"}]], " ", 
      SuperscriptBox["sigma", "2"]}]}], ")"}], " ", 
   RowBox[{"Log", "[", "r", "]"}]}], 
  RowBox[{
   SuperscriptBox["dr", "2"], "-", 
   RowBox[{"2", " ", "dr", " ", "mu"}], "+", 
   SuperscriptBox["mu", "2"], "+", 
   RowBox[{"nu", " ", 
    SuperscriptBox["r", 
     RowBox[{"2", " ", "alpha"}]], " ", 
    SuperscriptBox["sigma", "2"]}]}]]], "Output",
 CellChangeTimes->{
  3.5558687938711433`*^9, 3.555869053176969*^9, 3.5558691458017483`*^9, 
   3.555870236283201*^9, {3.555870289552745*^9, 3.5558703056977777`*^9}, 
   3.5558703968532963`*^9, 3.555876767672971*^9, 3.5558768583128757`*^9, 
   3.5558769663170633`*^9, 3.5558772301160583`*^9, 3.555877448062018*^9, {
   3.555878283838213*^9, 3.555878293570106*^9}, 3.5558784200425797`*^9, 
   3.555878503537323*^9, 3.55587861234009*^9, 3.555885130574129*^9, 
   3.5558852206567698`*^9, 3.555891149115464*^9}],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["dr", "2"]}], "+", 
     RowBox[{"2", " ", "dr", " ", "mu"}], "-", 
     SuperscriptBox["mu", "2"], "+", 
     RowBox[{
      SuperscriptBox["r", 
       RowBox[{"2", " ", "alpha"}]], " ", 
      SuperscriptBox["sigma", "2"]}], "+", 
     RowBox[{
      SuperscriptBox["dr", "2"], " ", 
      RowBox[{"Log", "[", 
       RowBox[{"1", "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"dr", "-", "mu"}], ")"}], "2"], " ", 
          SuperscriptBox["r", 
           RowBox[{
            RowBox[{"-", "2"}], " ", "alpha"}]]}], 
         RowBox[{"nu", " ", 
          SuperscriptBox["sigma", "2"]}]]}], "]"}]}], "-", 
     RowBox[{"2", " ", "dr", " ", "mu", " ", 
      RowBox[{"Log", "[", 
       RowBox[{"1", "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"dr", "-", "mu"}], ")"}], "2"], " ", 
          SuperscriptBox["r", 
           RowBox[{
            RowBox[{"-", "2"}], " ", "alpha"}]]}], 
         RowBox[{"nu", " ", 
          SuperscriptBox["sigma", "2"]}]]}], "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["mu", "2"], " ", 
      RowBox[{"Log", "[", 
       RowBox[{"1", "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"dr", "-", "mu"}], ")"}], "2"], " ", 
          SuperscriptBox["r", 
           RowBox[{
            RowBox[{"-", "2"}], " ", "alpha"}]]}], 
         RowBox[{"nu", " ", 
          SuperscriptBox["sigma", "2"]}]]}], "]"}]}], "+", 
     RowBox[{"nu", " ", 
      SuperscriptBox["r", 
       RowBox[{"2", " ", "alpha"}]], " ", 
      SuperscriptBox["sigma", "2"], " ", 
      RowBox[{"Log", "[", 
       RowBox[{"1", "+", 
        FractionBox[
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"dr", "-", "mu"}], ")"}], "2"], " ", 
          SuperscriptBox["r", 
           RowBox[{
            RowBox[{"-", "2"}], " ", "alpha"}]]}], 
         RowBox[{"nu", " ", 
          SuperscriptBox["sigma", "2"]}]]}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["dr", "2"], "-", 
        RowBox[{"2", " ", "dr", " ", "mu"}], "+", 
        SuperscriptBox["mu", "2"], "+", 
        RowBox[{"nu", " ", 
         SuperscriptBox["r", 
          RowBox[{"2", " ", "alpha"}]], " ", 
         SuperscriptBox["sigma", "2"]}]}], ")"}], " ", 
      RowBox[{"PolyGamma", "[", 
       RowBox[{"0", ",", 
        FractionBox["nu", "2"]}], "]"}]}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["dr", "2"], "-", 
        RowBox[{"2", " ", "dr", " ", "mu"}], "+", 
        SuperscriptBox["mu", "2"], "+", 
        RowBox[{"nu", " ", 
         SuperscriptBox["r", 
          RowBox[{"2", " ", "alpha"}]], " ", 
         SuperscriptBox["sigma", "2"]}]}], ")"}], " ", 
      RowBox[{"PolyGamma", "[", 
       RowBox[{"0", ",", 
        FractionBox[
         RowBox[{"1", "+", "nu"}], "2"]}], "]"}]}]}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["dr", "2"], "-", 
       RowBox[{"2", " ", "dr", " ", "mu"}], "+", 
       SuperscriptBox["mu", "2"], "+", 
       RowBox[{"nu", " ", 
        SuperscriptBox["r", 
         RowBox[{"2", " ", "alpha"}]], " ", 
        SuperscriptBox["sigma", "2"]}]}], ")"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.5558687938711433`*^9, 3.555869053176969*^9, 3.5558691458017483`*^9, 
   3.555870236283201*^9, {3.555870289552745*^9, 3.5558703056977777`*^9}, 
   3.5558703968532963`*^9, 3.555876767672971*^9, 3.5558768583128757`*^9, 
   3.5558769663170633`*^9, 3.5558772301160583`*^9, 3.555877448062018*^9, {
   3.555878283838213*^9, 3.555878293570106*^9}, 3.5558784200425797`*^9, 
   3.555878503537323*^9, 3.55587861234009*^9, 3.555885130574129*^9, 
   3.5558852206567698`*^9, 3.555891149116754*^9}],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"dr", "-", "mu"}], ")"}], "2"], " ", "nu", " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", "nu"}], ")"}], " ", 
    SuperscriptBox["r", 
     RowBox[{"2", " ", "alpha"}]], " ", 
    SuperscriptBox["sigma", "2"], " ", 
    SuperscriptBox[
     RowBox[{"Log", "[", "r", "]"}], "2"]}], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["dr", "2"], "-", 
      RowBox[{"2", " ", "dr", " ", "mu"}], "+", 
      SuperscriptBox["mu", "2"], "+", 
      RowBox[{"nu", " ", 
       SuperscriptBox["r", 
        RowBox[{"2", " ", "alpha"}]], " ", 
       SuperscriptBox["sigma", "2"]}]}], ")"}], "2"]]}]], "Output",
 CellChangeTimes->{
  3.5558687938711433`*^9, 3.555869053176969*^9, 3.5558691458017483`*^9, 
   3.555870236283201*^9, {3.555870289552745*^9, 3.5558703056977777`*^9}, 
   3.5558703968532963`*^9, 3.555876767672971*^9, 3.5558768583128757`*^9, 
   3.5558769663170633`*^9, 3.5558772301160583`*^9, 3.555877448062018*^9, {
   3.555878283838213*^9, 3.555878293570106*^9}, 3.5558784200425797`*^9, 
   3.555878503537323*^9, 3.55587861234009*^9, 3.555885130574129*^9, 
   3.5558852206567698`*^9, 3.555891149118973*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["dr", "4"], "-", 
       RowBox[{"4", " ", 
        SuperscriptBox["dr", "3"], " ", "mu"}], "+", 
       RowBox[{"6", " ", 
        SuperscriptBox["dr", "2"], " ", 
        SuperscriptBox["mu", "2"]}], "-", 
       RowBox[{"4", " ", "dr", " ", 
        SuperscriptBox["mu", "3"]}], "+", 
       SuperscriptBox["mu", "4"], "+", 
       RowBox[{"nu", " ", 
        SuperscriptBox["r", 
         RowBox[{"4", " ", "alpha"}]], " ", 
        SuperscriptBox["sigma", "4"]}]}], ")"}]}], "-", 
    RowBox[{"nu", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["dr", "2"], "-", 
        RowBox[{"2", " ", "dr", " ", "mu"}], "+", 
        SuperscriptBox["mu", "2"], "+", 
        RowBox[{"nu", " ", 
         SuperscriptBox["r", 
          RowBox[{"2", " ", "alpha"}]], " ", 
         SuperscriptBox["sigma", "2"]}]}], ")"}], "2"], " ", 
     RowBox[{"PolyGamma", "[", 
      RowBox[{"1", ",", 
       FractionBox["nu", "2"]}], "]"}]}], "+", 
    RowBox[{"nu", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["dr", "2"], "-", 
        RowBox[{"2", " ", "dr", " ", "mu"}], "+", 
        SuperscriptBox["mu", "2"], "+", 
        RowBox[{"nu", " ", 
         SuperscriptBox["r", 
          RowBox[{"2", " ", "alpha"}]], " ", 
         SuperscriptBox["sigma", "2"]}]}], ")"}], "2"], " ", 
     RowBox[{"PolyGamma", "[", 
      RowBox[{"1", ",", 
       FractionBox[
        RowBox[{"1", "+", "nu"}], "2"]}], "]"}]}]}], ")"}], "/", 
  RowBox[{"(", 
   RowBox[{"4", " ", "nu", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["dr", "2"], "-", 
       RowBox[{"2", " ", "dr", " ", "mu"}], "+", 
       SuperscriptBox["mu", "2"], "+", 
       RowBox[{"nu", " ", 
        SuperscriptBox["r", 
         RowBox[{"2", " ", "alpha"}]], " ", 
        SuperscriptBox["sigma", "2"]}]}], ")"}], "2"]}], ")"}]}]], "Output",
 CellChangeTimes->{
  3.5558687938711433`*^9, 3.555869053176969*^9, 3.5558691458017483`*^9, 
   3.555870236283201*^9, {3.555870289552745*^9, 3.5558703056977777`*^9}, 
   3.5558703968532963`*^9, 3.555876767672971*^9, 3.5558768583128757`*^9, 
   3.5558769663170633`*^9, 3.5558772301160583`*^9, 3.555877448062018*^9, {
   3.555878283838213*^9, 3.555878293570106*^9}, 3.5558784200425797`*^9, 
   3.555878503537323*^9, 3.55587861234009*^9, 3.555885130574129*^9, 
   3.5558852206567698`*^9, 3.555891149279531*^9}],

Cell[BoxData["\<\"S1=(dr+(-1).*mu).*(1+nu).*(dr.^2+(-2).*dr.*mu+mu.^2+nu.*r.^(\
2.*alpha) ...\\n  .*sigma.^2).^(-1);\\n\"\>"], "Output",
 CellChangeTimes->{
  3.5558687938711433`*^9, 3.555869053176969*^9, 3.5558691458017483`*^9, 
   3.555870236283201*^9, {3.555870289552745*^9, 3.5558703056977777`*^9}, 
   3.5558703968532963`*^9, 3.555876767672971*^9, 3.5558768583128757`*^9, 
   3.5558769663170633`*^9, 3.5558772301160583`*^9, 3.555877448062018*^9, {
   3.555878283838213*^9, 3.555878293570106*^9}, 3.5558784200425797`*^9, 
   3.555878503537323*^9, 3.55587861234009*^9, 3.555885130574129*^9, 
   3.5558852206567698`*^9, 3.555891149291692*^9}],

Cell[BoxData["\<\"S2=nu.*sigma.^(-1).*(dr.^2+(-2).*dr.*mu+mu.^2+(-1).*r.^(2.*\
alpha).* ...\\n  \
sigma.^2).*(dr.^2+(-2).*dr.*mu+mu.^2+nu.*r.^(2.*alpha).*sigma.^2) ...\\n  \
.^(-1);\\n\"\>"], "Output",
 CellChangeTimes->{
  3.5558687938711433`*^9, 3.555869053176969*^9, 3.5558691458017483`*^9, 
   3.555870236283201*^9, {3.555870289552745*^9, 3.5558703056977777`*^9}, 
   3.5558703968532963`*^9, 3.555876767672971*^9, 3.5558768583128757`*^9, 
   3.5558769663170633`*^9, 3.5558772301160583`*^9, 3.555877448062018*^9, {
   3.555878283838213*^9, 3.555878293570106*^9}, 3.5558784200425797`*^9, 
   3.555878503537323*^9, 3.55587861234009*^9, 3.555885130574129*^9, 
   3.5558852206567698`*^9, 3.5558911492925577`*^9}],

Cell[BoxData["\<\"S3=nu.*(dr.^2+(-2).*dr.*mu+mu.^2+(-1).*r.^(2.*alpha).*sigma.\
^2).*( ...\\n  \
dr.^2+(-2).*dr.*mu+mu.^2+nu.*r.^(2.*alpha).*sigma.^2).^(-1).*log( ...\\n  r);\
\\n\"\>"], "Output",
 CellChangeTimes->{
  3.5558687938711433`*^9, 3.555869053176969*^9, 3.5558691458017483`*^9, 
   3.555870236283201*^9, {3.555870289552745*^9, 3.5558703056977777`*^9}, 
   3.5558703968532963`*^9, 3.555876767672971*^9, 3.5558768583128757`*^9, 
   3.5558769663170633`*^9, 3.5558772301160583`*^9, 3.555877448062018*^9, {
   3.555878283838213*^9, 3.555878293570106*^9}, 3.5558784200425797`*^9, 
   3.555878503537323*^9, 3.55587861234009*^9, 3.555885130574129*^9, 
   3.5558852206567698`*^9, 3.5558911492934303`*^9}],

Cell[BoxData["\<\"S4=(-1/2).*(dr.^2+(-2).*dr.*mu+mu.^2+nu.*r.^(2.*alpha).*\
sigma.^2).^( ...\\n  \
-1).*((-1).*dr.^2+2.*dr.*mu+(-1).*mu.^2+r.^(2.*alpha).*sigma.^2+ ...\\n  \
dr.^2.*log(1+(dr+(-1).*mu).^2.*nu.^(-1).*r.^((-2).*alpha).* ...\\n  \
sigma.^(-2))+(-2).*dr.*mu.*log(1+(dr+(-1).*mu).^2.*nu.^(-1).*r.^(( ...\\n  \
-2).*alpha).*sigma.^(-2))+mu.^2.*log(1+(dr+(-1).*mu).^2.*nu.^(-1) ...\\n  \
.*r.^((-2).*alpha).*sigma.^(-2))+nu.*r.^(2.*alpha).*sigma.^2.*log( ...\\n  \
1+(dr+(-1).*mu).^2.*nu.^(-1).*r.^((-2).*alpha).*sigma.^(-2))+( ...\\n  \
dr.^2+(-2).*dr.*mu+mu.^2+nu.*r.^(2.*alpha).*sigma.^2).*PolyGamma( ...\\n  \
0,(1/2).*nu)+(-1).*(dr.^2+(-2).*dr.*mu+mu.^2+nu.*r.^(2.*alpha).* ...\\n  \
sigma.^2).*PolyGamma(0,(1/2).*(1+nu)));\\n\"\>"], "Output",
 CellChangeTimes->{
  3.5558687938711433`*^9, 3.555869053176969*^9, 3.5558691458017483`*^9, 
   3.555870236283201*^9, {3.555870289552745*^9, 3.5558703056977777`*^9}, 
   3.5558703968532963`*^9, 3.555876767672971*^9, 3.5558768583128757`*^9, 
   3.5558769663170633`*^9, 3.5558772301160583`*^9, 3.555877448062018*^9, {
   3.555878283838213*^9, 3.555878293570106*^9}, 3.5558784200425797`*^9, 
   3.555878503537323*^9, 3.55587861234009*^9, 3.555885130574129*^9, 
   3.5558852206567698`*^9, 3.555891149299384*^9}],

Cell[BoxData["\<\"H33=(-2).*(dr+(-1).*mu).^2.*nu.*(1+nu).*r.^(2.*alpha).*\
sigma.^2.*( ...\\n  \
dr.^2+(-2).*dr.*mu+mu.^2+nu.*r.^(2.*alpha).*sigma.^2).^(-2).*log( ...\\n  \
r).^2;\\n\"\>"], "Output",
 CellChangeTimes->{
  3.5558687938711433`*^9, 3.555869053176969*^9, 3.5558691458017483`*^9, 
   3.555870236283201*^9, {3.555870289552745*^9, 3.5558703056977777`*^9}, 
   3.5558703968532963`*^9, 3.555876767672971*^9, 3.5558768583128757`*^9, 
   3.5558769663170633`*^9, 3.5558772301160583`*^9, 3.555877448062018*^9, {
   3.555878283838213*^9, 3.555878293570106*^9}, 3.5558784200425797`*^9, 
   3.555878503537323*^9, 3.55587861234009*^9, 3.555885130574129*^9, 
   3.5558852206567698`*^9, 3.555891149301025*^9}],

Cell[BoxData["\<\"H44=(1/4).*nu.^(-1).*(dr.^2+(-2).*dr.*mu+mu.^2+nu.*r.^(2.*\
alpha).* ...\\n  \
sigma.^2).^(-2).*(2.*(dr.^4+(-4).*dr.^3.*mu+6.*dr.^2.*mu.^2+(-4).* ...\\n  \
dr.*mu.^3+mu.^4+nu.*r.^(4.*alpha).*sigma.^4)+(-1).*nu.*(dr.^2+(-2) ...\\n  \
.*dr.*mu+mu.^2+nu.*r.^(2.*alpha).*sigma.^2).^2.*PolyGamma(1,(1/2) ...\\n  \
.*nu)+nu.*(dr.^2+(-2).*dr.*mu+mu.^2+nu.*r.^(2.*alpha).*sigma.^2) ...\\n  \
.^2.*PolyGamma(1,(1/2).*(1+nu)));\\n\"\>"], "Output",
 CellChangeTimes->{
  3.5558687938711433`*^9, 3.555869053176969*^9, 3.5558691458017483`*^9, 
   3.555870236283201*^9, {3.555870289552745*^9, 3.5558703056977777`*^9}, 
   3.5558703968532963`*^9, 3.555876767672971*^9, 3.5558768583128757`*^9, 
   3.5558769663170633`*^9, 3.5558772301160583`*^9, 3.555877448062018*^9, {
   3.555878283838213*^9, 3.555878293570106*^9}, 3.5558784200425797`*^9, 
   3.555878503537323*^9, 3.55587861234009*^9, 3.555885130574129*^9, 
   3.5558852206567698`*^9, 3.555891149301898*^9}],

Cell["\<\
-\\frac{2 \\nu  (\\nu +1) \\sigma ^2 (\\text{dr}-\\mu )^2 r^{2
   \\gamma } \\log ^2(r)}{\\left(\\text{dr}^2-2 \\text{dr} \\mu
   +\\mu ^2+\\nu  \\sigma ^2 r^{2 \\gamma }\\right)^2}\
\>", "Output",
 CellChangeTimes->{
  3.5558687938711433`*^9, 3.555869053176969*^9, 3.5558691458017483`*^9, 
   3.555870236283201*^9, {3.555870289552745*^9, 3.5558703056977777`*^9}, 
   3.5558703968532963`*^9, 3.555876767672971*^9, 3.5558768583128757`*^9, 
   3.5558769663170633`*^9, 3.5558772301160583`*^9, 3.555877448062018*^9, {
   3.555878283838213*^9, 3.555878293570106*^9}, 3.5558784200425797`*^9, 
   3.555878503537323*^9, 3.55587861234009*^9, 3.555885130574129*^9, 
   3.5558852206567698`*^9, 3.555891149303256*^9}]
}, Open  ]]
},
WindowSize->{1199, 867},
WindowMargins->{{190, Automatic}, {Automatic, 48}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"PaperOrientation"->"Portrait",
"PaperSize"->{Automatic, Automatic},
"PostScriptOutputFile"->"/home/smv/Research/projects/financial_econometrics/\
fuform/papers/cevt_nyblom.pdf"},
FrontEndVersion->"8.0 for Linux x86 (64-bit) (February 23, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 6804, 192, 705, "Input"],
Cell[7386, 216, 953, 22, 66, "Output"],
Cell[8342, 240, 1213, 29, 70, "Output"],
Cell[9558, 271, 1184, 28, 69, "Output"],
Cell[10745, 301, 4159, 115, 224, "Output"],
Cell[14907, 418, 1252, 31, 70, "Output"],
Cell[16162, 451, 2626, 69, 104, "Output"],
Cell[18791, 522, 932, 22, 66, "Output"],
Cell[19726, 546, 1180, 29, 70, "Output"],
Cell[20909, 577, 1154, 28, 69, "Output"],
Cell[22066, 607, 4031, 115, 270, "Output"],
Cell[26100, 724, 1253, 31, 70, "Output"],
Cell[27356, 757, 2543, 68, 175, "Output"],
Cell[29902, 827, 644, 9, 98, "Output"],
Cell[30549, 838, 711, 11, 125, "Output"],
Cell[31263, 851, 706, 11, 125, "Output"],
Cell[31972, 864, 1265, 18, 314, "Output"],
Cell[33240, 884, 707, 11, 125, "Output"],
Cell[33950, 897, 963, 14, 206, "Output"],
Cell[34916, 913, 715, 12, 88, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
